/*!
 * 
 *     ol-mapbox-style
 *     Copyright 2016-present Boundless Spatial
 *     Copyright漏 2000-2018 SuperMap Software Co. Ltd
 *     github: https://github.com/boundlessgeo/ol-mapbox-style
 *     github: https://github.com/SuperMap/ol-mapbox-style
 *     license: BSD 2-Clause "Simplified" License
 *     version: v2.11.2-1
 * 
 */
olms=function(e){var t={};function r(n){if(t[n])return t[n].exports;var o=t[n]={i:n,l:!1,exports:{}};return e[n].call(o.exports,o,o.exports,r),o.l=!0,o.exports}return r.m=e,r.c=t,r.d=function(e,t,n){r.o(e,t)||Object.defineProperty(e,t,{enumerable:!0,get:n})},r.r=function(e){"undefined"!=typeof Symbol&&Symbol.toStringTag&&Object.defineProperty(e,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(e,"__esModule",{value:!0})},r.t=function(e,t){if(1&t&&(e=r(e)),8&t)return e;if(4&t&&"object"==typeof e&&e&&e.__esModule)return e;var n=Object.create(null);if(r.r(n),Object.defineProperty(n,"default",{enumerable:!0,value:e}),2&t&&"string"!=typeof e)for(var o in e)r.d(n,o,function(t){return e[t]}.bind(null,o));return n},r.n=function(e){var t=e&&e.__esModule?function(){return e.default}:function(){return e};return r.d(t,"a",t),t},r.o=function(e,t){return Object.prototype.hasOwnProperty.call(e,t)},r.p="",r(r.s=4)}([function(e,t,r){"use strict";(function(e,r){Object.defineProperty(t,"__esModule",{value:!0});var n="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},o={$version:8,$root:{version:{required:!0,type:"enum",values:[8],doc:"Style specification version number. Must be 8.",example:8},name:{type:"string",doc:"A human-readable name for the style.",example:"Bright"},metadata:{type:"*",doc:"Arbitrary properties useful to track with the stylesheet, but do not influence rendering. Properties should be prefixed to avoid collisions, like 'mapbox:'."},center:{type:"array",value:"number",doc:"Default map center in longitude and latitude.  The style center will be used only if the map has not been positioned by other means (e.g. map options or user interaction).",example:[-73.9749,40.7736]},zoom:{type:"number",doc:"Default zoom level.  The style zoom will be used only if the map has not been positioned by other means (e.g. map options or user interaction).",example:12.5},bearing:{type:"number",default:0,period:360,units:"degrees",doc:'Default bearing, in degrees. The bearing is the compass direction that is "up"; for example, a bearing of 90掳 orients the map so that east is up. This value will be used only if the map has not been positioned by other means (e.g. map options or user interaction).',example:29},pitch:{type:"number",default:0,units:"degrees",doc:"Default pitch, in degrees. Zero is perpendicular to the surface, for a look straight down at the map, while a greater value like 60 looks ahead towards the horizon. The style pitch will be used only if the map has not been positioned by other means (e.g. map options or user interaction).",example:50},light:{type:"light",doc:"The global light source.",example:{anchor:"viewport",color:"white",intensity:.4}},sources:{required:!0,type:"sources",doc:"Data source specifications.",example:{"mapbox-streets":{type:"vector",url:"mapbox://mapbox.mapbox-streets-v6"}}},sprite:{type:"string",doc:"A base URL for retrieving the sprite image and metadata. The extensions `.png`, `.json` and scale factor `@2x.png` will be automatically appended. This property is required if any layer uses the `background-pattern`, `fill-pattern`, `line-pattern`, `fill-extrusion-pattern`, or `icon-image` properties. The URL must be absolute, containing the [scheme, authority and path components](https://en.wikipedia.org/wiki/URL#Syntax).",example:"mapbox://sprites/mapbox/bright-v8"},glyphs:{type:"string",doc:"A URL template for loading signed-distance-field glyph sets in PBF format. The URL must include `{fontstack}` and `{range}` tokens. This property is required if any layer uses the `text-field` layout property. The URL must be absolute, containing the [scheme, authority and path components](https://en.wikipedia.org/wiki/URL#Syntax).",example:"mapbox://fonts/mapbox/{fontstack}/{range}.pbf"},transition:{type:"transition",doc:"A global transition definition to use as a default across properties, to be used for timing transitions between one value and the next when no property-specific transition is set. Collision-based symbol fading is controlled independently of the style's `transition` property.",example:{duration:300,delay:0}},layers:{required:!0,type:"array",value:"layer",doc:"Layers will be drawn in the order of this array.",example:[{id:"water",source:"mapbox-streets","source-layer":"water",type:"fill",paint:{"fill-color":"#00ffff"}}]}},sources:{"*":{type:"source",doc:"Specification of a data source. For vector and raster sources, either TileJSON or a URL to a TileJSON must be provided. For image and video sources, a URL must be provided. For GeoJSON sources, a URL or inline GeoJSON must be provided."}},source:["source_vector","source_raster","source_raster_dem","source_geojson","source_video","source_image"],source_vector:{type:{required:!0,type:"enum",values:{vector:{doc:"A vector tile source."}},doc:"The type of the source."},url:{type:"string",doc:"A URL to a TileJSON resource. Supported protocols are `http:`, `https:`, and `mapbox://<Tileset ID>`."},tiles:{type:"array",value:"string",doc:"An array of one or more tile source URLs, as in the TileJSON spec."},bounds:{type:"array",value:"number",length:4,default:[-180,-85.051129,180,85.051129],doc:"An array containing the longitude and latitude of the southwest and northeast corners of the source's bounding box in the following order: `[sw.lng, sw.lat, ne.lng, ne.lat]`. When this property is included in a source, no tiles outside of the given bounds are requested by Mapbox GL."},scheme:{type:"enum",values:{xyz:{doc:"Slippy map tilenames scheme."},tms:{doc:"OSGeo spec scheme."}},default:"xyz",doc:"Influences the y direction of the tile coordinates. The global-mercator (aka Spherical Mercator) profile is assumed."},minzoom:{type:"number",default:0,doc:"Minimum zoom level for which tiles are available, as in the TileJSON spec."},maxzoom:{type:"number",default:22,doc:"Maximum zoom level for which tiles are available, as in the TileJSON spec. Data from tiles at the maxzoom are used when displaying the map at higher zoom levels."},attribution:{type:"string",doc:"Contains an attribution to be displayed when the map is shown to a user."},promoteId:{type:"promoteId",doc:"A property to use as a feature id (for feature state). Either a property name, or an object of the form `{<sourceLayer>: <propertyName>}`. If specified as a string for a vector tile source, the same property is used across all its source layers."},"*":{type:"*",doc:"Other keys to configure the data source."}},source_raster:{type:{required:!0,type:"enum",values:{raster:{doc:"A raster tile source."}},doc:"The type of the source."},url:{type:"string",doc:"A URL to a TileJSON resource. Supported protocols are `http:`, `https:`, and `mapbox://<Tileset ID>`."},tiles:{type:"array",value:"string",doc:"An array of one or more tile source URLs, as in the TileJSON spec."},bounds:{type:"array",value:"number",length:4,default:[-180,-85.051129,180,85.051129],doc:"An array containing the longitude and latitude of the southwest and northeast corners of the source's bounding box in the following order: `[sw.lng, sw.lat, ne.lng, ne.lat]`. When this property is included in a source, no tiles outside of the given bounds are requested by Mapbox GL."},minzoom:{type:"number",default:0,doc:"Minimum zoom level for which tiles are available, as in the TileJSON spec."},maxzoom:{type:"number",default:22,doc:"Maximum zoom level for which tiles are available, as in the TileJSON spec. Data from tiles at the maxzoom are used when displaying the map at higher zoom levels."},tileSize:{type:"number",default:512,units:"pixels",doc:"The minimum visual size to display tiles for this layer. Only configurable for raster layers."},scheme:{type:"enum",values:{xyz:{doc:"Slippy map tilenames scheme."},tms:{doc:"OSGeo spec scheme."}},default:"xyz",doc:"Influences the y direction of the tile coordinates. The global-mercator (aka Spherical Mercator) profile is assumed."},attribution:{type:"string",doc:"Contains an attribution to be displayed when the map is shown to a user."},"*":{type:"*",doc:"Other keys to configure the data source."}},source_raster_dem:{type:{required:!0,type:"enum",values:{"raster-dem":{doc:"A RGB-encoded raster DEM source"}},doc:"The type of the source."},url:{type:"string",doc:"A URL to a TileJSON resource. Supported protocols are `http:`, `https:`, and `mapbox://<Tileset ID>`."},tiles:{type:"array",value:"string",doc:"An array of one or more tile source URLs, as in the TileJSON spec."},bounds:{type:"array",value:"number",length:4,default:[-180,-85.051129,180,85.051129],doc:"An array containing the longitude and latitude of the southwest and northeast corners of the source's bounding box in the following order: `[sw.lng, sw.lat, ne.lng, ne.lat]`. When this property is included in a source, no tiles outside of the given bounds are requested by Mapbox GL."},minzoom:{type:"number",default:0,doc:"Minimum zoom level for which tiles are available, as in the TileJSON spec."},maxzoom:{type:"number",default:22,doc:"Maximum zoom level for which tiles are available, as in the TileJSON spec. Data from tiles at the maxzoom are used when displaying the map at higher zoom levels."},tileSize:{type:"number",default:512,units:"pixels",doc:"The minimum visual size to display tiles for this layer. Only configurable for raster layers."},attribution:{type:"string",doc:"Contains an attribution to be displayed when the map is shown to a user."},encoding:{type:"enum",values:{terrarium:{doc:"Terrarium format PNG tiles. See https://aws.amazon.com/es/public-datasets/terrain/ for more info."},mapbox:{doc:"Mapbox Terrain RGB tiles. See https://www.mapbox.com/help/access-elevation-data/#mapbox-terrain-rgb for more info."}},default:"mapbox",doc:"The encoding used by this source. Mapbox Terrain RGB is used by default"},"*":{type:"*",doc:"Other keys to configure the data source."}},source_geojson:{type:{required:!0,type:"enum",values:{geojson:{doc:"A GeoJSON data source."}},doc:"The data type of the GeoJSON source."},data:{type:"*",doc:"A URL to a GeoJSON file, or inline GeoJSON."},maxzoom:{type:"number",default:18,doc:"Maximum zoom level at which to create vector tiles (higher means greater detail at high zoom levels)."},attribution:{type:"string",doc:"Contains an attribution to be displayed when the map is shown to a user."},buffer:{type:"number",default:128,maximum:512,minimum:0,doc:"Size of the tile buffer on each side. A value of 0 produces no buffer. A value of 512 produces a buffer as wide as the tile itself. Larger values produce fewer rendering artifacts near tile edges and slower performance."},tolerance:{type:"number",default:.375,doc:"Douglas-Peucker simplification tolerance (higher means simpler geometries and faster performance)."},cluster:{type:"boolean",default:!1,doc:"If the data is a collection of point features, setting this to true clusters the points by radius into groups. Cluster groups become new `Point` features in the source with additional properties:\n * `cluster` Is `true` if the point is a cluster \n * `cluster_id` A unqiue id for the cluster to be used in conjunction with the [cluster inspection methods](https://www.mapbox.com/mapbox-gl-js/api/#geojsonsource#getclusterexpansionzoom)\n * `point_count` Number of original points grouped into this cluster\n * `point_count_abbreviated` An abbreviated point count"},clusterRadius:{type:"number",default:50,minimum:0,doc:"Radius of each cluster if clustering is enabled. A value of 512 indicates a radius equal to the width of a tile."},clusterMaxZoom:{type:"number",doc:"Max zoom on which to cluster points if clustering is enabled. Defaults to one zoom less than maxzoom (so that last zoom features are not clustered)."},clusterProperties:{type:"*",doc:'An object defining custom properties on the generated clusters if clustering is enabled, aggregating values from clustered points. Has the form `{"property_name": [operator, map_expression]}`. `operator` is any expression function that accepts at least 2 operands (e.g. `"+"` or `"max"`) 鈥� it accumulates the property value from clusters/points the cluster contains; `map_expression` produces the value of a single point.\n\nExample: `{"sum": ["+", ["get", "scalerank"]]}`.\n\nFor more advanced use cases, in place of `operator`, you can use a custom reduce expression that references a special `["accumulated"]` value, e.g.:\n`{"sum": [["+", ["accumulated"], ["get", "sum"]], ["get", "scalerank"]]}`'},lineMetrics:{type:"boolean",default:!1,doc:"Whether to calculate line distance metrics. This is required for line layers that specify `line-gradient` values."},generateId:{type:"boolean",default:!1,doc:"Whether to generate ids for the geojson features. When enabled, the `feature.id` property will be auto assigned based on its index in the `features` array, over-writing any previous values."},promoteId:{type:"promoteId",doc:"A property to use as a feature id (for feature state). Either a property name, or an object of the form `{<sourceLayer>: <propertyName>}`."}},source_video:{type:{required:!0,type:"enum",values:{video:{doc:"A video data source."}},doc:"The data type of the video source."},urls:{required:!0,type:"array",value:"string",doc:"URLs to video content in order of preferred format."},coordinates:{required:!0,doc:"Corners of video specified in longitude, latitude pairs.",type:"array",length:4,value:{type:"array",length:2,value:"number",doc:"A single longitude, latitude pair."}}},source_image:{type:{required:!0,type:"enum",values:{image:{doc:"An image data source."}},doc:"The data type of the image source."},url:{required:!0,type:"string",doc:"URL that points to an image."},coordinates:{required:!0,doc:"Corners of image specified in longitude, latitude pairs.",type:"array",length:4,value:{type:"array",length:2,value:"number",doc:"A single longitude, latitude pair."}}},layer:{id:{type:"string",doc:"Unique layer name.",required:!0},type:{type:"enum",values:{fill:{doc:"A filled polygon with an optional stroked border.","sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"}}},line:{doc:"A stroked line.","sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"}}},symbol:{doc:"An icon or a text label.","sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"}}},circle:{doc:"A filled circle.","sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"}}},heatmap:{doc:"A heatmap.","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},"fill-extrusion":{doc:"An extruded (3D) polygon.","sdk-support":{"basic functionality":{js:"0.27.0",android:"5.1.0",ios:"3.6.0",macos:"0.5.0"}}},raster:{doc:"Raster map textures such as satellite imagery.","sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"}}},hillshade:{doc:"Client-side hillshading visualization based on DEM data. Currently, the implementation only supports Mapbox Terrain RGB and Mapzen Terrarium tiles.","sdk-support":{"basic functionality":{js:"0.43.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},background:{doc:"The background color or pattern of the map.","sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"}}}},doc:"Rendering type of this layer.",required:!0},metadata:{type:"*",doc:"Arbitrary properties useful to track with the layer, but do not influence rendering. Properties should be prefixed to avoid collisions, like 'mapbox:'."},source:{type:"string",doc:"Name of a source description to be used for this layer. Required for all layer types except `background`."},"source-layer":{type:"string",doc:"Layer to use from a vector tile source. Required for vector tile sources; prohibited for all other source types, including GeoJSON sources."},minzoom:{type:"number",minimum:0,maximum:24,doc:"The minimum zoom level for the layer. At zoom levels less than the minzoom, the layer will be hidden."},maxzoom:{type:"number",minimum:0,maximum:24,doc:"The maximum zoom level for the layer. At zoom levels equal to or greater than the maxzoom, the layer will be hidden."},filter:{type:"filter",doc:"A expression specifying conditions on source features. Only features that match the filter are displayed. Zoom expressions in filters are only evaluated at integer zoom levels. The `feature-state` expression is not supported in filter expressions."},layout:{type:"layout",doc:"Layout properties for the layer."},paint:{type:"paint",doc:"Default paint properties for this layer."}},layout:["layout_fill","layout_line","layout_circle","layout_heatmap","layout_fill-extrusion","layout_symbol","layout_raster","layout_hillshade","layout_background"],layout_background:{visibility:{type:"enum",values:{visible:{doc:"The layer is shown."},none:{doc:"The layer is not shown."}},default:"visible",doc:"Whether this layer is displayed.","sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"}},"property-type":"constant"}},layout_fill:{"fill-sort-key":{type:"number",doc:"Sorts features in ascending order based on this value. Features with a higher sort key will appear above features with a lower sort key.","sdk-support":{"basic functionality":{js:"1.2.0"},"data-driven styling":{js:"1.2.0"}},expression:{interpolated:!1,parameters:["zoom","feature"]},"property-type":"data-driven"},visibility:{type:"enum",values:{visible:{doc:"The layer is shown."},none:{doc:"The layer is not shown."}},default:"visible",doc:"Whether this layer is displayed.","sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"}},"property-type":"constant"}},layout_circle:{"circle-sort-key":{type:"number",doc:"Sorts features in ascending order based on this value. Features with a higher sort key will appear above features with a lower sort key.","sdk-support":{"basic functionality":{js:"1.2.0"},"data-driven styling":{js:"1.2.0"}},expression:{interpolated:!1,parameters:["zoom","feature"]},"property-type":"data-driven"},visibility:{type:"enum",values:{visible:{doc:"The layer is shown."},none:{doc:"The layer is not shown."}},default:"visible",doc:"Whether this layer is displayed.","sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"}},"property-type":"constant"}},layout_heatmap:{visibility:{type:"enum",values:{visible:{doc:"The layer is shown."},none:{doc:"The layer is not shown."}},default:"visible",doc:"Whether this layer is displayed.","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}},"property-type":"constant"}},"layout_fill-extrusion":{visibility:{type:"enum",values:{visible:{doc:"The layer is shown."},none:{doc:"The layer is not shown."}},default:"visible",doc:"Whether this layer is displayed.","sdk-support":{"basic functionality":{js:"0.27.0",android:"5.1.0",ios:"3.6.0",macos:"0.5.0"}},"property-type":"constant"}},layout_line:{"line-cap":{type:"enum",values:{butt:{doc:"A cap with a squared-off end which is drawn to the exact endpoint of the line."},round:{doc:"A cap with a rounded end which is drawn beyond the endpoint of the line at a radius of one-half of the line's width and centered on the endpoint of the line."},square:{doc:"A cap with a squared-off end which is drawn beyond the endpoint of the line at a distance of one-half of the line's width."}},default:"butt",doc:"The display of line endings.","sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"}},expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"line-join":{type:"enum",values:{bevel:{doc:"A join with a squared-off end which is drawn beyond the endpoint of the line at a distance of one-half of the line's width."},round:{doc:"A join with a rounded end which is drawn beyond the endpoint of the line at a radius of one-half of the line's width and centered on the endpoint of the line."},miter:{doc:"A join with a sharp, angled corner which is drawn with the outer sides beyond the endpoint of the path until they meet."}},default:"miter",doc:"The display of lines when joining.","sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"},"data-driven styling":{js:"0.40.0",android:"5.2.0",ios:"3.7.0",macos:"0.6.0"}},expression:{interpolated:!1,parameters:["zoom","feature"]},"property-type":"data-driven"},"line-miter-limit":{type:"number",default:2,doc:"Used to automatically convert miter joins to bevel joins for sharp angles.",requires:[{"line-join":"miter"}],"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"}},expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"line-round-limit":{type:"number",default:1.05,doc:"Used to automatically convert round joins to miter joins for shallow angles.",requires:[{"line-join":"round"}],"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"}},expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"line-sort-key":{type:"number",doc:"Sorts features in ascending order based on this value. Features with a higher sort key will appear above features with a lower sort key.","sdk-support":{"basic functionality":{js:"1.2.0"},"data-driven styling":{js:"1.2.0"}},expression:{interpolated:!1,parameters:["zoom","feature"]},"property-type":"data-driven"},visibility:{type:"enum",values:{visible:{doc:"The layer is shown."},none:{doc:"The layer is not shown."}},default:"visible",doc:"Whether this layer is displayed.","sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"}},"property-type":"constant"}},layout_symbol:{"symbol-placement":{type:"enum",values:{point:{doc:"The label is placed at the point where the geometry is located."},line:{doc:"The label is placed along the line of the geometry. Can only be used on `LineString` and `Polygon` geometries."},"line-center":{doc:"The label is placed at the center of the line of the geometry. Can only be used on `LineString` and `Polygon` geometries. Note that a single feature in a vector tile may contain multiple line geometries."}},default:"point",doc:"Label placement relative to its geometry.","sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"},"`line-center` value":{js:"0.47.0",android:"6.4.0",ios:"4.3.0",macos:"0.10.0"}},expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"symbol-spacing":{type:"number",default:250,minimum:1,units:"pixels",doc:"Distance between two symbol anchors.",requires:[{"symbol-placement":"line"}],"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"}},expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"symbol-avoid-edges":{type:"boolean",default:!1,doc:"If true, the symbols will not cross tile edges to avoid mutual collisions. Recommended in layers that don't have enough padding in the vector tile to prevent collisions, or if it is a point symbol layer placed after a line symbol layer. When using a client that supports global collision detection, like Mapbox GL JS version 0.42.0 or greater, enabling this property is not needed to prevent clipped labels at tile boundaries.","sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"}},expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"symbol-sort-key":{type:"number",doc:"Sorts features in ascending order based on this value. Features with lower sort keys are drawn and placed first.  When `icon-allow-overlap` or `text-allow-overlap` is `false`, features with a lower sort key will have priority during placement. When `icon-allow-overlap` or `text-allow-overlap` is set to `true`, features with a higher sort key will overlap over features with a lower sort key.","sdk-support":{"basic functionality":{js:"0.53.0",android:"7.4.0",ios:"4.11.0",macos:"0.14.0"},"data-driven styling":{js:"0.53.0",android:"7.4.0",ios:"4.11.0",macos:"0.14.0"}},expression:{interpolated:!1,parameters:["zoom","feature"]},"property-type":"data-driven"},"symbol-z-order":{type:"enum",values:{auto:{doc:"If `symbol-sort-key` is set, sort based on that. Otherwise sort symbols by their y-position relative to the viewport."},"viewport-y":{doc:"Symbols will be sorted by their y-position relative to the viewport."},source:{doc:"Symbols will be rendered in the same order as the source data with no sorting applied."}},default:"auto",doc:"Controls the order in which overlapping symbols in the same layer are rendered","sdk-support":{"basic functionality":{js:"0.49.0",android:"6.6.0",ios:"4.5.0",macos:"0.12.0"}},expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"icon-allow-overlap":{type:"boolean",default:!1,doc:"If true, the icon will be visible even if it collides with other previously drawn symbols.",requires:["icon-image"],"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"}},expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"icon-ignore-placement":{type:"boolean",default:!1,doc:"If true, other symbols can be visible even if they collide with the icon.",requires:["icon-image"],"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"}},expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"icon-optional":{type:"boolean",default:!1,doc:"If true, text will display without their corresponding icons when the icon collides with other symbols and the text does not.",requires:["icon-image","text-field"],"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"}},expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"icon-rotation-alignment":{type:"enum",values:{map:{doc:"When `symbol-placement` is set to `point`, aligns icons east-west. When `symbol-placement` is set to `line` or `line-center`, aligns icon x-axes with the line."},viewport:{doc:"Produces icons whose x-axes are aligned with the x-axis of the viewport, regardless of the value of `symbol-placement`."},auto:{doc:"When `symbol-placement` is set to `point`, this is equivalent to `viewport`. When `symbol-placement` is set to `line` or `line-center`, this is equivalent to `map`."}},default:"auto",doc:"In combination with `symbol-placement`, determines the rotation behavior of icons.",requires:["icon-image"],"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"},"`auto` value":{js:"0.25.0",android:"4.2.0",ios:"3.4.0",macos:"0.3.0"}},expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"icon-size":{type:"number",default:1,minimum:0,units:"factor of the original icon size",doc:"Scales the original size of the icon by the provided factor. The new pixel size of the image will be the original pixel size multiplied by `icon-size`. 1 is the original size; 3 triples the size of the image.",requires:["icon-image"],"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"},"data-driven styling":{js:"0.35.0",android:"5.1.0",ios:"3.6.0",macos:"0.5.0"}},expression:{interpolated:!0,parameters:["zoom","feature"]},"property-type":"data-driven"},"icon-text-fit":{type:"enum",values:{none:{doc:"The icon is displayed at its intrinsic aspect ratio."},width:{doc:"The icon is scaled in the x-dimension to fit the width of the text."},height:{doc:"The icon is scaled in the y-dimension to fit the height of the text."},both:{doc:"The icon is scaled in both x- and y-dimensions."}},default:"none",doc:"Scales the icon to fit around the associated text.",requires:["icon-image","text-field"],"sdk-support":{"basic functionality":{js:"0.21.0",android:"4.2.0",ios:"3.4.0",macos:"0.2.1"}},expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"icon-text-fit-padding":{type:"array",value:"number",length:4,default:[0,0,0,0],units:"pixels",doc:"Size of the additional area added to dimensions determined by `icon-text-fit`, in clockwise order: top, right, bottom, left.",requires:["icon-image","text-field",{"icon-text-fit":["both","width","height"]}],"sdk-support":{"basic functionality":{js:"0.21.0",android:"4.2.0",ios:"3.4.0",macos:"0.2.1"}},expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"icon-image":{type:"resolvedImage",doc:"Name of image in sprite to use for drawing an image background.",tokens:!0,"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"},"data-driven styling":{js:"0.35.0",android:"5.1.0",ios:"3.6.0",macos:"0.5.0"}},expression:{interpolated:!1,parameters:["zoom","feature"]},"property-type":"data-driven"},"icon-rotate":{type:"number",default:0,period:360,units:"degrees",doc:"Rotates the icon clockwise.",requires:["icon-image"],"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"},"data-driven styling":{js:"0.21.0",android:"5.0.0",ios:"3.5.0",macos:"0.4.0"}},expression:{interpolated:!0,parameters:["zoom","feature"]},"property-type":"data-driven"},"icon-padding":{type:"number",default:2,minimum:0,units:"pixels",doc:"Size of the additional area around the icon bounding box used for detecting symbol collisions.",requires:["icon-image"],"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"}},expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"icon-keep-upright":{type:"boolean",default:!1,doc:"If true, the icon may be flipped to prevent it from being rendered upside-down.",requires:["icon-image",{"icon-rotation-alignment":"map"},{"symbol-placement":["line","line-center"]}],"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"}},expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"icon-offset":{type:"array",value:"number",length:2,default:[0,0],doc:"Offset distance of icon from its anchor. Positive values indicate right and down, while negative values indicate left and up. Each component is multiplied by the value of `icon-size` to obtain the final offset in pixels. When combined with `icon-rotate` the offset will be as if the rotated direction was up.",requires:["icon-image"],"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"},"data-driven styling":{js:"0.29.0",android:"5.0.0",ios:"3.5.0",macos:"0.4.0"}},expression:{interpolated:!0,parameters:["zoom","feature"]},"property-type":"data-driven"},"icon-anchor":{type:"enum",values:{center:{doc:"The center of the icon is placed closest to the anchor."},left:{doc:"The left side of the icon is placed closest to the anchor."},right:{doc:"The right side of the icon is placed closest to the anchor."},top:{doc:"The top of the icon is placed closest to the anchor."},bottom:{doc:"The bottom of the icon is placed closest to the anchor."},"top-left":{doc:"The top left corner of the icon is placed closest to the anchor."},"top-right":{doc:"The top right corner of the icon is placed closest to the anchor."},"bottom-left":{doc:"The bottom left corner of the icon is placed closest to the anchor."},"bottom-right":{doc:"The bottom right corner of the icon is placed closest to the anchor."}},default:"center",doc:"Part of the icon placed closest to the anchor.",requires:["icon-image"],"sdk-support":{"basic functionality":{js:"0.40.0",android:"5.2.0",ios:"3.7.0",macos:"0.6.0"},"data-driven styling":{js:"0.40.0",android:"5.2.0",ios:"3.7.0",macos:"0.6.0"}},expression:{interpolated:!1,parameters:["zoom","feature"]},"property-type":"data-driven"},"icon-pitch-alignment":{type:"enum",values:{map:{doc:"The icon is aligned to the plane of the map."},viewport:{doc:"The icon is aligned to the plane of the viewport."},auto:{doc:"Automatically matches the value of `icon-rotation-alignment`."}},default:"auto",doc:"Orientation of icon when map is pitched.",requires:["icon-image"],"sdk-support":{"basic functionality":{js:"0.39.0",android:"5.2.0",ios:"3.7.0",macos:"0.6.0"}},expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"text-pitch-alignment":{type:"enum",values:{map:{doc:"The text is aligned to the plane of the map."},viewport:{doc:"The text is aligned to the plane of the viewport."},auto:{doc:"Automatically matches the value of `text-rotation-alignment`."}},default:"auto",doc:"Orientation of text when map is pitched.",requires:["text-field"],"sdk-support":{"basic functionality":{js:"0.21.0",android:"4.2.0",ios:"3.4.0",macos:"0.2.1"},"`auto` value":{js:"0.25.0",android:"4.2.0",ios:"3.4.0",macos:"0.3.0"}},expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"text-rotation-alignment":{type:"enum",values:{map:{doc:"When `symbol-placement` is set to `point`, aligns text east-west. When `symbol-placement` is set to `line` or `line-center`, aligns text x-axes with the line."},viewport:{doc:"Produces glyphs whose x-axes are aligned with the x-axis of the viewport, regardless of the value of `symbol-placement`."},auto:{doc:"When `symbol-placement` is set to `point`, this is equivalent to `viewport`. When `symbol-placement` is set to `line` or `line-center`, this is equivalent to `map`."}},default:"auto",doc:"In combination with `symbol-placement`, determines the rotation behavior of the individual glyphs forming the text.",requires:["text-field"],"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"},"`auto` value":{js:"0.25.0",android:"4.2.0",ios:"3.4.0",macos:"0.3.0"}},expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"text-field":{type:"formatted",default:"",tokens:!0,doc:"Value to use for a text label. If a plain `string` is provided, it will be treated as a `formatted` with default/inherited formatting options.","sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"},"data-driven styling":{js:"0.33.0",android:"5.0.0",ios:"3.5.0",macos:"0.4.0"}},expression:{interpolated:!1,parameters:["zoom","feature"]},"property-type":"data-driven"},"text-font":{type:"array",value:"string",default:["Open Sans Regular","Arial Unicode MS Regular"],doc:"Font stack to use for displaying text.",requires:["text-field"],"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"},"data-driven styling":{js:"0.43.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}},expression:{interpolated:!1,parameters:["zoom","feature"]},"property-type":"data-driven"},"text-size":{type:"number",default:16,minimum:0,units:"pixels",doc:"Font size.",requires:["text-field"],"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"},"data-driven styling":{js:"0.35.0",android:"5.1.0",ios:"3.6.0",macos:"0.5.0"}},expression:{interpolated:!0,parameters:["zoom","feature"]},"property-type":"data-driven"},"text-max-width":{type:"number",default:10,minimum:0,units:"ems",doc:"The maximum line width for text wrapping.",requires:["text-field"],"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"},"data-driven styling":{js:"0.40.0",android:"5.2.0",ios:"3.7.0",macos:"0.6.0"}},expression:{interpolated:!0,parameters:["zoom","feature"]},"property-type":"data-driven"},"text-line-height":{type:"number",default:1.2,units:"ems",doc:"Text leading value for multi-line text.",requires:["text-field"],"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"}},expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"text-letter-spacing":{type:"number",default:0,units:"ems",doc:"Text tracking amount.",requires:["text-field"],"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"},"data-driven styling":{js:"0.40.0",android:"5.2.0",ios:"3.7.0",macos:"0.6.0"}},expression:{interpolated:!0,parameters:["zoom","feature"]},"property-type":"data-driven"},"text-justify":{type:"enum",values:{auto:{doc:"The text is aligned towards the anchor position."},left:{doc:"The text is aligned to the left."},center:{doc:"The text is centered."},right:{doc:"The text is aligned to the right."}},default:"center",doc:"Text justification options.",requires:["text-field"],"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"},"data-driven styling":{js:"0.39.0",android:"5.2.0",ios:"3.7.0",macos:"0.6.0"},auto:{js:"0.54.0",android:"7.4.0",ios:"4.10.0",macos:"0.14.0"}},expression:{interpolated:!1,parameters:["zoom","feature"]},"property-type":"data-driven"},"text-radial-offset":{type:"number",units:"ems",default:0,doc:"Radial offset of text, in the direction of the symbol's anchor. Useful in combination with `text-variable-anchor`, which defaults to using the two-dimensional `text-offset` if present.","sdk-support":{"basic functionality":{js:"0.54.0",android:"7.4.0",ios:"4.10.0",macos:"0.14.0"},"data-driven styling":{js:"0.54.0",android:"7.4.0",ios:"4.10.0",macos:"0.14.0"}},requires:["text-field"],"property-type":"data-driven",expression:{interpolated:!0,parameters:["zoom","feature"]}},"text-variable-anchor":{type:"array",value:"enum",values:{center:{doc:"The center of the text is placed closest to the anchor."},left:{doc:"The left side of the text is placed closest to the anchor."},right:{doc:"The right side of the text is placed closest to the anchor."},top:{doc:"The top of the text is placed closest to the anchor."},bottom:{doc:"The bottom of the text is placed closest to the anchor."},"top-left":{doc:"The top left corner of the text is placed closest to the anchor."},"top-right":{doc:"The top right corner of the text is placed closest to the anchor."},"bottom-left":{doc:"The bottom left corner of the text is placed closest to the anchor."},"bottom-right":{doc:"The bottom right corner of the text is placed closest to the anchor."}},requires:["text-field",{"symbol-placement":["point"]}],doc:"To increase the chance of placing high-priority labels on the map, you can provide an array of `text-anchor` locations: the renderer will attempt to place the label at each location, in order, before moving onto the next label. Use `text-justify: auto` to choose justification based on anchor position. To apply an offset, use the `text-radial-offset` or the two-dimensional `text-offset`.","sdk-support":{"basic functionality":{js:"0.54.0",android:"7.4.0",ios:"4.10.0",macos:"0.14.0"}},expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"text-anchor":{type:"enum",values:{center:{doc:"The center of the text is placed closest to the anchor."},left:{doc:"The left side of the text is placed closest to the anchor."},right:{doc:"The right side of the text is placed closest to the anchor."},top:{doc:"The top of the text is placed closest to the anchor."},bottom:{doc:"The bottom of the text is placed closest to the anchor."},"top-left":{doc:"The top left corner of the text is placed closest to the anchor."},"top-right":{doc:"The top right corner of the text is placed closest to the anchor."},"bottom-left":{doc:"The bottom left corner of the text is placed closest to the anchor."},"bottom-right":{doc:"The bottom right corner of the text is placed closest to the anchor."}},default:"center",doc:"Part of the text placed closest to the anchor.",requires:["text-field",{"!":"text-variable-anchor"}],"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"},"data-driven styling":{js:"0.39.0",android:"5.2.0",ios:"3.7.0",macos:"0.6.0"}},expression:{interpolated:!1,parameters:["zoom","feature"]},"property-type":"data-driven"},"text-max-angle":{type:"number",default:45,units:"degrees",doc:"Maximum angle change between adjacent characters.",requires:["text-field",{"symbol-placement":["line","line-center"]}],"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"}},expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"text-writing-mode":{type:"array",value:"enum",values:{horizontal:{doc:"If a text's language supports horizontal writing mode, symbols with point placement would be laid out horizontally."},vertical:{doc:"If a text's language supports vertical writing mode, symbols with point placement would be laid out vertically."}},doc:"The property allows control over a symbol's orientation. Note that the property values act as a hint, so that a symbol whose language doesn鈥檛 support the provided orientation will be laid out in its natural orientation. Example: English point symbol will be rendered horizontally even if array value contains single 'vertical' enum value. The order of elements in an array define priority order for the placement of an orientation variant.",requires:["text-field",{"symbol-placement":["point"]}],"sdk-support":{"basic functionality":{js:"1.3.0",android:"8.3.0",ios:"5.3.0",macos:"0.14.0"}},expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"text-rotate":{type:"number",default:0,period:360,units:"degrees",doc:"Rotates the text clockwise.",requires:["text-field"],"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"},"data-driven styling":{js:"0.35.0",android:"5.1.0",ios:"3.6.0",macos:"0.5.0"}},expression:{interpolated:!0,parameters:["zoom","feature"]},"property-type":"data-driven"},"text-padding":{type:"number",default:2,minimum:0,units:"pixels",doc:"Size of the additional area around the text bounding box used for detecting symbol collisions.",requires:["text-field"],"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"}},expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"text-keep-upright":{type:"boolean",default:!0,doc:"If true, the text may be flipped vertically to prevent it from being rendered upside-down.",requires:["text-field",{"text-rotation-alignment":"map"},{"symbol-placement":["line","line-center"]}],"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"}},expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"text-transform":{type:"enum",values:{none:{doc:"The text is not altered."},uppercase:{doc:"Forces all letters to be displayed in uppercase."},lowercase:{doc:"Forces all letters to be displayed in lowercase."}},default:"none",doc:"Specifies how to capitalize text, similar to the CSS `text-transform` property.",requires:["text-field"],"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"},"data-driven styling":{js:"0.33.0",android:"5.0.0",ios:"3.5.0",macos:"0.4.0"}},expression:{interpolated:!1,parameters:["zoom","feature"]},"property-type":"data-driven"},"text-offset":{type:"array",doc:"Offset distance of text from its anchor. Positive values indicate right and down, while negative values indicate left and up. If used with text-variable-anchor, input values will be taken as absolute values. Offsets along the x- and y-axis will be applied automatically based on the anchor position.",value:"number",units:"ems",length:2,default:[0,0],requires:["text-field",{"!":"text-radial-offset"}],"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"},"data-driven styling":{js:"0.35.0",android:"5.1.0",ios:"3.6.0",macos:"0.5.0"}},expression:{interpolated:!0,parameters:["zoom","feature"]},"property-type":"data-driven"},"text-allow-overlap":{type:"boolean",default:!1,doc:"If true, the text will be visible even if it collides with other previously drawn symbols.",requires:["text-field"],"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"}},expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"text-ignore-placement":{type:"boolean",default:!1,doc:"If true, other symbols can be visible even if they collide with the text.",requires:["text-field"],"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"}},expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"text-optional":{type:"boolean",default:!1,doc:"If true, icons will display without their corresponding text when the text collides with other symbols and the icon does not.",requires:["text-field","icon-image"],"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"}},expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},visibility:{type:"enum",values:{visible:{doc:"The layer is shown."},none:{doc:"The layer is not shown."}},default:"visible",doc:"Whether this layer is displayed.","sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"}},"property-type":"constant"}},layout_raster:{visibility:{type:"enum",values:{visible:{doc:"The layer is shown."},none:{doc:"The layer is not shown."}},default:"visible",doc:"Whether this layer is displayed.","sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"}},"property-type":"constant"}},layout_hillshade:{visibility:{type:"enum",values:{visible:{doc:"The layer is shown."},none:{doc:"The layer is not shown."}},default:"visible",doc:"Whether this layer is displayed.","sdk-support":{"basic functionality":{js:"0.43.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}},"property-type":"constant"}},filter:{type:"array",value:"*",doc:"A filter selects specific features from a layer."},filter_operator:{type:"enum",values:{"==":{doc:'`["==", key, value]` equality: `feature[key] = value`'},"!=":{doc:'`["!=", key, value]` inequality: `feature[key] 鈮� value`'},">":{doc:'`[">", key, value]` greater than: `feature[key] > value`'},">=":{doc:'`[">=", key, value]` greater than or equal: `feature[key] 鈮� value`'},"<":{doc:'`["<", key, value]` less than: `feature[key] < value`'},"<=":{doc:'`["<=", key, value]` less than or equal: `feature[key] 鈮� value`'},in:{doc:'`["in", key, v0, ..., vn]` set inclusion: `feature[key] 鈭� {v0, ..., vn}`'},"!in":{doc:'`["!in", key, v0, ..., vn]` set exclusion: `feature[key] 鈭� {v0, ..., vn}`'},all:{doc:'`["all", f0, ..., fn]` logical `AND`: `f0 鈭� ... 鈭� fn`'},any:{doc:'`["any", f0, ..., fn]` logical `OR`: `f0 鈭� ... 鈭� fn`'},none:{doc:'`["none", f0, ..., fn]` logical `NOR`: `卢f0 鈭� ... 鈭� 卢fn`'},has:{doc:'`["has", key]` `feature[key]` exists'},"!has":{doc:'`["!has", key]` `feature[key]` does not exist'}},doc:"The filter operator."},geometry_type:{type:"enum",values:{Point:{doc:"Filter to point geometries."},LineString:{doc:"Filter to line geometries."},Polygon:{doc:"Filter to polygon geometries."}},doc:"The geometry type for the filter to select."},function:{expression:{type:"expression",doc:"An expression."},stops:{type:"array",doc:"An array of stops.",value:"function_stop"},base:{type:"number",default:1,minimum:0,doc:"The exponential base of the interpolation curve. It controls the rate at which the result increases. Higher values make the result increase more towards the high end of the range. With `1` the stops are interpolated linearly."},property:{type:"string",doc:"The name of a feature property to use as the function input.",default:"$zoom"},type:{type:"enum",values:{identity:{doc:"Return the input value as the output value."},exponential:{doc:"Generate an output by interpolating between stops just less than and just greater than the function input."},interval:{doc:"Return the output value of the stop just less than the function input."},categorical:{doc:"Return the output value of the stop equal to the function input."}},doc:"The interpolation strategy to use in function evaluation.",default:"exponential"},colorSpace:{type:"enum",values:{rgb:{doc:"Use the RGB color space to interpolate color values"},lab:{doc:"Use the LAB color space to interpolate color values."},hcl:{doc:"Use the HCL color space to interpolate color values, interpolating the Hue, Chroma, and Luminance channels individually."}},doc:"The color space in which colors interpolated. Interpolating colors in perceptual color spaces like LAB and HCL tend to produce color ramps that look more consistent and produce colors that can be differentiated more easily than those interpolated in RGB space.",default:"rgb"},default:{type:"*",required:!1,doc:"A value to serve as a fallback function result when a value isn't otherwise available. It is used in the following circumstances:\n* In categorical functions, when the feature value does not match any of the stop domain values.\n* In property and zoom-and-property functions, when a feature does not contain a value for the specified property.\n* In identity functions, when the feature value is not valid for the style property (for example, if the function is being used for a `circle-color` property but the feature property value is not a string or not a valid color).\n* In interval or exponential property and zoom-and-property functions, when the feature value is not numeric.\nIf no default is provided, the style property's default is used in these circumstances."}},function_stop:{type:"array",minimum:0,maximum:24,value:["number","color"],length:2,doc:"Zoom level and value pair."},expression:{type:"array",value:"*",minimum:1,doc:"An expression defines a function that can be used for data-driven style properties or feature filters."},expression_name:{doc:"",type:"enum",values:{let:{doc:'Binds expressions to named variables, which can then be referenced in the result expression using ["var", "variable_name"].',group:"Variable binding","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},var:{doc:'References variable bound using "let".',group:"Variable binding","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},literal:{doc:"Provides a literal array or object value.",group:"Types","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},array:{doc:"Asserts that the input is an array (optionally with a specific item type and length).  If, when the input expression is evaluated, it is not of the asserted type, then this assertion will cause the whole expression to be aborted.",group:"Types","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},at:{doc:"Retrieves an item from an array.",group:"Lookup","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},in:{doc:"Determines whether an item exists in an array or a substring exists in a string.",group:"Lookup","sdk-support":{"basic functionality":{js:"1.6.0"}}},"index-of":{doc:"Returns the first index at which a given element can be found in an array, or for a string, the first occurrence of the specified value. If a second argument is provided, then the search is started from that position. Returns -1 if the value is not found.",group:"Lookup","sdk-support":{"basic functionality":{js:"1.10.0"}}},case:{doc:"Selects the first output whose corresponding test condition evaluates to true, or the fallback value otherwise.",group:"Decision","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},match:{doc:'Selects the output whose label value matches the input value, or the fallback value if no match is found. The input can be any expression (e.g. `["get", "building_type"]`). Each label must be either:\n * a single literal value; or\n * an array of literal values, whose values must be all strings or all numbers (e.g. `[100, 101]` or `["c", "b"]`). The input matches if any of the values in the array matches, similar to the `"in"` operator.\n\nEach label must be unique. If the input type does not match the type of the labels, the result will be the fallback value.',group:"Decision","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},coalesce:{doc:"Evaluates each expression in turn until the first non-null value is obtained, and returns that value.",group:"Decision","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},step:{doc:'Produces discrete, stepped results by evaluating a piecewise-constant function defined by pairs of input and output values ("stops"). The `input` may be any numeric expression (e.g., `["get", "population"]`). Stop inputs must be numeric literals in strictly ascending order. Returns the output value of the stop just less than the input, or the first output if the input is less than the first stop.',group:"Ramps, scales, curves","sdk-support":{"basic functionality":{js:"0.42.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},interpolate:{doc:'Produces continuous, smooth results by interpolating between pairs of input and output values ("stops"). The `input` may be any numeric expression (e.g., `["get", "population"]`). Stop inputs must be numeric literals in strictly ascending order. The output type must be `number`, `array<number>`, or `color`.\n\nInterpolation types:\n- `["linear"]`: interpolates linearly between the pair of stops just less than and just greater than the input.\n- `["exponential", base]`: interpolates exponentially between the stops just less than and just greater than the input. `base` controls the rate at which the output increases: higher values make the output increase more towards the high end of the range. With values close to 1 the output increases linearly.\n- `["cubic-bezier", x1, y1, x2, y2]`: interpolates using the cubic bezier curve defined by the given control points.',group:"Ramps, scales, curves","sdk-support":{"basic functionality":{js:"0.42.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},"interpolate-hcl":{doc:'Produces continuous, smooth results by interpolating between pairs of input and output values ("stops"). Works like `interpolate`, but the output type must be `color`, and the interpolation is performed in the Hue-Chroma-Luminance color space.',group:"Ramps, scales, curves","sdk-support":{"basic functionality":{js:"0.49.0"}}},"interpolate-lab":{doc:'Produces continuous, smooth results by interpolating between pairs of input and output values ("stops"). Works like `interpolate`, but the output type must be `color`, and the interpolation is performed in the CIELAB color space.',group:"Ramps, scales, curves","sdk-support":{"basic functionality":{js:"0.49.0"}}},ln2:{doc:"Returns mathematical constant ln(2).",group:"Math","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},pi:{doc:"Returns the mathematical constant pi.",group:"Math","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},e:{doc:"Returns the mathematical constant e.",group:"Math","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},typeof:{doc:"Returns a string describing the type of the given value.",group:"Types","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},string:{doc:"Asserts that the input value is a string. If multiple values are provided, each one is evaluated in order until a string is obtained. If none of the inputs are strings, the expression is an error.",group:"Types","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},number:{doc:"Asserts that the input value is a number. If multiple values are provided, each one is evaluated in order until a number is obtained. If none of the inputs are numbers, the expression is an error.",group:"Types","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},boolean:{doc:"Asserts that the input value is a boolean. If multiple values are provided, each one is evaluated in order until a boolean is obtained. If none of the inputs are booleans, the expression is an error.",group:"Types","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},object:{doc:"Asserts that the input value is an object. If multiple values are provided, each one is evaluated in order until an object is obtained. If none of the inputs are objects, the expression is an error.",group:"Types","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},collator:{doc:"Returns a `collator` for use in locale-dependent comparison operations. The `case-sensitive` and `diacritic-sensitive` options default to `false`. The `locale` argument specifies the IETF language tag of the locale to use. If none is provided, the default locale is used. If the requested locale is not available, the `collator` will use a system-defined fallback locale. Use `resolved-locale` to test the results of locale fallback behavior.",group:"Types","sdk-support":{"basic functionality":{js:"0.45.0",android:"6.5.0",ios:"4.2.0",macos:"0.9.0"}}},format:{doc:"Returns `formatted` text containing annotations for use in mixed-format `text-field` entries. For a `text-field` entries of a string type, following option object's properties are supported: If set, the `text-font` value overrides the font specified by the root layout properties. If set, the `font-scale` value specifies a scaling factor relative to the `text-size` specified in the root layout properties. If set, the `text-color` value overrides the color specified by the root paint properties for this layer.",group:"Types","sdk-support":{"basic functionality":{js:"0.48.0",android:"6.7.0",ios:"4.6.0",macos:"0.12.0"},"text-font":{js:"0.48.0",android:"6.7.0",ios:"4.6.0",macos:"0.12.0"},"font-scale":{js:"0.48.0",android:"6.7.0",ios:"4.6.0",macos:"0.12.0"},"text-color":{js:"1.3.0",android:"7.3.0",ios:"4.10.0",macos:"0.14.0"},image:{js:"1.6.0"}}},image:{doc:"Returns an `image` type for use in `icon-image`, `*-pattern` entries and as a section in the `format` expression. If set, the `image` argument will check that the requested image exists in the style and will return either the resolved image name or `null`, depending on whether or not the image is currently in the style. This validation process is synchronous and requires the image to have been added to the style before requesting it in the `image` argument.",group:"Types","sdk-support":{"basic functionality":{js:"1.4.0",android:"8.6.0",ios:"5.6.0"}}},"number-format":{doc:"Converts the input number into a string representation using the providing formatting rules. If set, the `locale` argument specifies the locale to use, as a BCP 47 language tag. If set, the `currency` argument specifies an ISO 4217 code to use for currency-style formatting. If set, the `min-fraction-digits` and `max-fraction-digits` arguments specify the minimum and maximum number of fractional digits to include.",group:"Types","sdk-support":{"basic functionality":{js:"0.54.0"}}},"to-string":{doc:'Converts the input value to a string. If the input is `null`, the result is `""`. If the input is a boolean, the result is `"true"` or `"false"`. If the input is a number, it is converted to a string as specified by the ["NumberToString" algorithm](https://tc39.github.io/ecma262/#sec-tostring-applied-to-the-number-type) of the ECMAScript Language Specification. If the input is a color, it is converted to a string of the form `"rgba(r,g,b,a)"`, where `r`, `g`, and `b` are numerals ranging from 0 to 255, and `a` ranges from 0 to 1. Otherwise, the input is converted to a string in the format specified by the [`JSON.stringify`](https://tc39.github.io/ecma262/#sec-json.stringify) function of the ECMAScript Language Specification.',group:"Types","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},"to-number":{doc:'Converts the input value to a number, if possible. If the input is `null` or `false`, the result is 0. If the input is `true`, the result is 1. If the input is a string, it is converted to a number as specified by the ["ToNumber Applied to the String Type" algorithm](https://tc39.github.io/ecma262/#sec-tonumber-applied-to-the-string-type) of the ECMAScript Language Specification. If multiple values are provided, each one is evaluated in order until the first successful conversion is obtained. If none of the inputs can be converted, the expression is an error.',group:"Types","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},"to-boolean":{doc:"Converts the input value to a boolean. The result is `false` when then input is an empty string, 0, `false`, `null`, or `NaN`; otherwise it is `true`.",group:"Types","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},"to-rgba":{doc:"Returns a four-element array containing the input color's red, green, blue, and alpha components, in that order.",group:"Color","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},"to-color":{doc:"Converts the input value to a color. If multiple values are provided, each one is evaluated in order until the first successful conversion is obtained. If none of the inputs can be converted, the expression is an error.",group:"Types","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},rgb:{doc:"Creates a color value from red, green, and blue components, which must range between 0 and 255, and an alpha component of 1. If any component is out of range, the expression is an error.",group:"Color","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},rgba:{doc:"Creates a color value from red, green, blue components, which must range between 0 and 255, and an alpha component which must range between 0 and 1. If any component is out of range, the expression is an error.",group:"Color","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},get:{doc:"Retrieves a property value from the current feature's properties, or from another object if a second argument is provided. Returns null if the requested property is missing.",group:"Lookup","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},has:{doc:"Tests for the presence of an property value in the current feature's properties, or from another object if a second argument is provided.",group:"Lookup","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},length:{doc:"Gets the length of an array or string.",group:"Lookup","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},properties:{doc:'Gets the feature properties object.  Note that in some cases, it may be more efficient to use ["get", "property_name"] directly.',group:"Feature data","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},"feature-state":{doc:"Retrieves a property value from the current feature's state. Returns null if the requested property is not present on the feature's state. A feature's state is not part of the GeoJSON or vector tile data, and must be set programmatically on each feature. Features are identified by their `id` attribute, which must be an integer or a string that can be cast to an integer. Note that [\"feature-state\"] can only be used with paint properties that support data-driven styling.",group:"Feature data","sdk-support":{"basic functionality":{js:"0.46.0"}}},"geometry-type":{doc:"Gets the feature's geometry type: Point, MultiPoint, LineString, MultiLineString, Polygon, MultiPolygon.",group:"Feature data","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},id:{doc:"Gets the feature's id, if it has one.",group:"Feature data","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},zoom:{doc:'Gets the current zoom level.  Note that in style layout and paint properties, ["zoom"] may only appear as the input to a top-level "step" or "interpolate" expression.',group:"Zoom","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},"heatmap-density":{doc:"Gets the kernel density estimation of a pixel in a heatmap layer, which is a relative measure of how many data points are crowded around a particular pixel. Can only be used in the `heatmap-color` property.",group:"Heatmap","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},"line-progress":{doc:"Gets the progress along a gradient line. Can only be used in the `line-gradient` property.",group:"Feature data","sdk-support":{"basic functionality":{js:"0.45.0",android:"6.5.0",ios:"4.6.0",macos:"0.12.0"}}},accumulated:{doc:"Gets the value of a cluster property accumulated so far. Can only be used in the `clusterProperties` option of a clustered GeoJSON source.",group:"Feature data","sdk-support":{"basic functionality":{js:"0.53.0"}}},"+":{doc:"Returns the sum of the inputs.",group:"Math","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},"*":{doc:"Returns the product of the inputs.",group:"Math","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},"-":{doc:"For two inputs, returns the result of subtracting the second input from the first. For a single input, returns the result of subtracting it from 0.",group:"Math","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},"/":{doc:"Returns the result of floating point division of the first input by the second.",group:"Math","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},"%":{doc:"Returns the remainder after integer division of the first input by the second.",group:"Math","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},"^":{doc:"Returns the result of raising the first input to the power specified by the second.",group:"Math","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},sqrt:{doc:"Returns the square root of the input.",group:"Math","sdk-support":{"basic functionality":{js:"0.42.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},log10:{doc:"Returns the base-ten logarithm of the input.",group:"Math","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},ln:{doc:"Returns the natural logarithm of the input.",group:"Math","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},log2:{doc:"Returns the base-two logarithm of the input.",group:"Math","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},sin:{doc:"Returns the sine of the input.",group:"Math","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},cos:{doc:"Returns the cosine of the input.",group:"Math","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},tan:{doc:"Returns the tangent of the input.",group:"Math","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},asin:{doc:"Returns the arcsine of the input.",group:"Math","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},acos:{doc:"Returns the arccosine of the input.",group:"Math","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},atan:{doc:"Returns the arctangent of the input.",group:"Math","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},min:{doc:"Returns the minimum value of the inputs.",group:"Math","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},max:{doc:"Returns the maximum value of the inputs.",group:"Math","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},round:{doc:'Rounds the input to the nearest integer. Halfway values are rounded away from zero. For example, `["round", -1.5]` evaluates to -2.',group:"Math","sdk-support":{"basic functionality":{js:"0.45.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},abs:{doc:"Returns the absolute value of the input.",group:"Math","sdk-support":{"basic functionality":{js:"0.45.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},ceil:{doc:"Returns the smallest integer that is greater than or equal to the input.",group:"Math","sdk-support":{"basic functionality":{js:"0.45.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},floor:{doc:"Returns the largest integer that is less than or equal to the input.",group:"Math","sdk-support":{"basic functionality":{js:"0.45.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},"==":{doc:"Returns `true` if the input values are equal, `false` otherwise. The comparison is strictly typed: values of different runtime types are always considered unequal. Cases where the types are known to be different at parse time are considered invalid and will produce a parse error. Accepts an optional `collator` argument to control locale-dependent string comparisons.",group:"Decision","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"},collator:{js:"0.45.0",android:"6.5.0",ios:"4.2.0",macos:"0.9.0"}}},"!=":{doc:"Returns `true` if the input values are not equal, `false` otherwise. The comparison is strictly typed: values of different runtime types are always considered unequal. Cases where the types are known to be different at parse time are considered invalid and will produce a parse error. Accepts an optional `collator` argument to control locale-dependent string comparisons.",group:"Decision","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"},collator:{js:"0.45.0",android:"6.5.0",ios:"4.2.0",macos:"0.9.0"}}},">":{doc:"Returns `true` if the first input is strictly greater than the second, `false` otherwise. The arguments are required to be either both strings or both numbers; if during evaluation they are not, expression evaluation produces an error. Cases where this constraint is known not to hold at parse time are considered in valid and will produce a parse error. Accepts an optional `collator` argument to control locale-dependent string comparisons.",group:"Decision","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"},collator:{js:"0.45.0",android:"6.5.0",ios:"4.2.0",macos:"0.9.0"}}},"<":{doc:"Returns `true` if the first input is strictly less than the second, `false` otherwise. The arguments are required to be either both strings or both numbers; if during evaluation they are not, expression evaluation produces an error. Cases where this constraint is known not to hold at parse time are considered in valid and will produce a parse error. Accepts an optional `collator` argument to control locale-dependent string comparisons.",group:"Decision","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"},collator:{js:"0.45.0",android:"6.5.0",ios:"4.2.0",macos:"0.9.0"}}},">=":{doc:"Returns `true` if the first input is greater than or equal to the second, `false` otherwise. The arguments are required to be either both strings or both numbers; if during evaluation they are not, expression evaluation produces an error. Cases where this constraint is known not to hold at parse time are considered in valid and will produce a parse error. Accepts an optional `collator` argument to control locale-dependent string comparisons.",group:"Decision","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"},collator:{js:"0.45.0",android:"6.5.0",ios:"4.2.0",macos:"0.9.0"}}},"<=":{doc:"Returns `true` if the first input is less than or equal to the second, `false` otherwise. The arguments are required to be either both strings or both numbers; if during evaluation they are not, expression evaluation produces an error. Cases where this constraint is known not to hold at parse time are considered in valid and will produce a parse error. Accepts an optional `collator` argument to control locale-dependent string comparisons.",group:"Decision","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"},collator:{js:"0.45.0",android:"6.5.0",ios:"4.2.0",macos:"0.9.0"}}},all:{doc:"Returns `true` if all the inputs are `true`, `false` otherwise. The inputs are evaluated in order, and evaluation is short-circuiting: once an input expression evaluates to `false`, the result is `false` and no further input expressions are evaluated.",group:"Decision","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},any:{doc:"Returns `true` if any of the inputs are `true`, `false` otherwise. The inputs are evaluated in order, and evaluation is short-circuiting: once an input expression evaluates to `true`, the result is `true` and no further input expressions are evaluated.",group:"Decision","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},"!":{doc:"Logical negation. Returns `true` if the input is `false`, and `false` if the input is `true`.",group:"Decision","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},within:{doc:"Returns `true` if the feature being evaluated is inside the pre-defined geometry boundary, `false` otherwise. The expression has one argument which must be a valid GeoJSON Polygon/Multi-Polygon object. The expression only evaluates on `Point` or `LineString` feature. For `Point` feature, The expression will return false if any point of the feature is on the boundary or outside the boundary. For `LineString` feature, the expression will return false if the line is fully outside the boundary, or the line is partially intersecting the boundary, which means either part of the line is outside of the boundary, or end point of the line lies on the boundary.",group:"Decision","sdk-support":{"basic functionality":{js:"1.9.0"}}},"is-supported-script":{doc:"Returns `true` if the input string is expected to render legibly. Returns `false` if the input string contains sections that cannot be rendered without potential loss of meaning (e.g. Indic scripts that require complex text shaping, or right-to-left scripts if the the `mapbox-gl-rtl-text` plugin is not in use in Mapbox GL JS).",group:"String","sdk-support":{"basic functionality":{js:"0.45.0",android:"6.6.0"}}},upcase:{doc:"Returns the input string converted to uppercase. Follows the Unicode Default Case Conversion algorithm and the locale-insensitive case mappings in the Unicode Character Database.",group:"String","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},downcase:{doc:"Returns the input string converted to lowercase. Follows the Unicode Default Case Conversion algorithm and the locale-insensitive case mappings in the Unicode Character Database.",group:"String","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},concat:{doc:"Returns a `string` consisting of the concatenation of the inputs. Each input is converted to a string as if by `to-string`.",group:"String","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}}},"resolved-locale":{doc:"Returns the IETF language tag of the locale being used by the provided `collator`. This can be used to determine the default system locale, or to determine if a requested locale was successfully loaded.",group:"String","sdk-support":{"basic functionality":{js:"0.45.0",android:"6.5.0",ios:"4.2.0",macos:"0.9.0"}}},slice:{doc:"Returns a portion of a string or an array starting from the provided beginning index. If a second argument is provided, then the return portion will run to, but not include, the end index.",group:"String","sdk-support":{"basic functionality":{js:"1.10.0"}}}}},light:{anchor:{type:"enum",default:"viewport",values:{map:{doc:"The position of the light source is aligned to the rotation of the map."},viewport:{doc:"The position of the light source is aligned to the rotation of the viewport."}},"property-type":"data-constant",transition:!1,expression:{interpolated:!1,parameters:["zoom"]},doc:"Whether extruded geometries are lit relative to the map or viewport.",example:"map","sdk-support":{"basic functionality":{js:"0.27.0",android:"5.1.0",ios:"3.6.0",macos:"0.5.0"}}},position:{type:"array",default:[1.15,210,30],length:3,value:"number","property-type":"data-constant",transition:!0,expression:{interpolated:!0,parameters:["zoom"]},doc:"Position of the light source relative to lit (extruded) geometries, in [r radial coordinate, a azimuthal angle, p polar angle] where r indicates the distance from the center of the base of an object to its light, a indicates the position of the light relative to 0掳 (0掳 when `light.anchor` is set to `viewport` corresponds to the top of the viewport, or 0掳 when `light.anchor` is set to `map` corresponds to due north, and degrees proceed clockwise), and p indicates the height of the light (from 0掳, directly above, to 180掳, directly below).",example:[1.5,90,80],"sdk-support":{"basic functionality":{js:"0.27.0",android:"5.1.0",ios:"3.6.0",macos:"0.5.0"}}},color:{type:"color","property-type":"data-constant",default:"#ffffff",expression:{interpolated:!0,parameters:["zoom"]},transition:!0,doc:"Color tint for lighting extruded geometries.","sdk-support":{"basic functionality":{js:"0.27.0",android:"5.1.0",ios:"3.6.0",macos:"0.5.0"}}},intensity:{type:"number","property-type":"data-constant",default:.5,minimum:0,maximum:1,expression:{interpolated:!0,parameters:["zoom"]},transition:!0,doc:"Intensity of lighting (on a scale from 0 to 1). Higher numbers will present as more extreme contrast.","sdk-support":{"basic functionality":{js:"0.27.0",android:"5.1.0",ios:"3.6.0",macos:"0.5.0"}}}},paint:["paint_fill","paint_line","paint_circle","paint_heatmap","paint_fill-extrusion","paint_symbol","paint_raster","paint_hillshade","paint_background"],paint_fill:{"fill-antialias":{type:"boolean",default:!0,doc:"Whether or not the fill should be antialiased.","sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"}},expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"fill-opacity":{type:"number",default:1,minimum:0,maximum:1,doc:"The opacity of the entire fill layer. In contrast to the `fill-color`, this value will also affect the 1px stroke around the fill, if the stroke is used.",transition:!0,"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"},"data-driven styling":{js:"0.21.0",android:"5.0.0",ios:"3.5.0",macos:"0.4.0"}},expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"fill-color":{type:"color",default:"#000000",doc:"The color of the filled part of this layer. This color can be specified as `rgba` with an alpha component and the color's opacity will not affect the opacity of the 1px stroke, if it is used.",transition:!0,requires:[{"!":"fill-pattern"}],"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"},"data-driven styling":{js:"0.19.0",android:"5.0.0",ios:"3.5.0",macos:"0.4.0"}},expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"fill-outline-color":{type:"color",doc:"The outline color of the fill. Matches the value of `fill-color` if unspecified.",transition:!0,requires:[{"!":"fill-pattern"},{"fill-antialias":!0}],"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"},"data-driven styling":{js:"0.19.0",android:"5.0.0",ios:"3.5.0",macos:"0.4.0"}},expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"fill-translate":{type:"array",value:"number",length:2,default:[0,0],transition:!0,units:"pixels",doc:"The geometry's offset. Values are [x, y] where negatives indicate left and up, respectively.","sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"}},expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"fill-translate-anchor":{type:"enum",values:{map:{doc:"The fill is translated relative to the map."},viewport:{doc:"The fill is translated relative to the viewport."}},doc:"Controls the frame of reference for `fill-translate`.",default:"map",requires:["fill-translate"],"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"}},expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"fill-pattern":{type:"resolvedImage",transition:!0,doc:"Name of image in sprite to use for drawing image fills. For seamless patterns, image width and height must be a factor of two (2, 4, 8, ..., 512). Note that zoom-dependent expressions will be evaluated only at integer zoom levels.","sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"},"data-driven styling":{js:"0.49.0",android:"6.5.0",macos:"0.11.0",ios:"4.4.0"}},expression:{interpolated:!1,parameters:["zoom","feature"]},"property-type":"cross-faded-data-driven"}},"paint_fill-extrusion":{"fill-extrusion-opacity":{type:"number",default:1,minimum:0,maximum:1,doc:"The opacity of the entire fill extrusion layer. This is rendered on a per-layer, not per-feature, basis, and data-driven styling is not available.",transition:!0,"sdk-support":{"basic functionality":{js:"0.27.0",android:"5.1.0",ios:"3.6.0",macos:"0.5.0"}},expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"fill-extrusion-color":{type:"color",default:"#000000",doc:"The base color of the extruded fill. The extrusion's surfaces will be shaded differently based on this color in combination with the root `light` settings. If this color is specified as `rgba` with an alpha component, the alpha component will be ignored; use `fill-extrusion-opacity` to set layer opacity.",transition:!0,requires:[{"!":"fill-extrusion-pattern"}],"sdk-support":{"basic functionality":{js:"0.27.0",android:"5.1.0",ios:"3.6.0",macos:"0.5.0"},"data-driven styling":{js:"0.27.0",android:"5.1.0",ios:"3.6.0",macos:"0.5.0"}},expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"fill-extrusion-translate":{type:"array",value:"number",length:2,default:[0,0],transition:!0,units:"pixels",doc:"The geometry's offset. Values are [x, y] where negatives indicate left and up (on the flat plane), respectively.","sdk-support":{"basic functionality":{js:"0.27.0",android:"5.1.0",ios:"3.6.0",macos:"0.5.0"}},expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"fill-extrusion-translate-anchor":{type:"enum",values:{map:{doc:"The fill extrusion is translated relative to the map."},viewport:{doc:"The fill extrusion is translated relative to the viewport."}},doc:"Controls the frame of reference for `fill-extrusion-translate`.",default:"map",requires:["fill-extrusion-translate"],"sdk-support":{"basic functionality":{js:"0.27.0",android:"5.1.0",ios:"3.6.0",macos:"0.5.0"}},expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"fill-extrusion-pattern":{type:"resolvedImage",transition:!0,doc:"Name of image in sprite to use for drawing images on extruded fills. For seamless patterns, image width and height must be a factor of two (2, 4, 8, ..., 512). Note that zoom-dependent expressions will be evaluated only at integer zoom levels.","sdk-support":{"basic functionality":{js:"0.27.0",android:"5.1.0",ios:"3.6.0",macos:"0.5.0"},"data-driven styling":{js:"0.49.0",android:"6.5.0",macos:"0.11.0",ios:"4.4.0"}},expression:{interpolated:!1,parameters:["zoom","feature"]},"property-type":"cross-faded-data-driven"},"fill-extrusion-height":{type:"number",default:0,minimum:0,units:"meters",doc:"The height with which to extrude this layer.",transition:!0,"sdk-support":{"basic functionality":{js:"0.27.0",android:"5.1.0",ios:"3.6.0",macos:"0.5.0"},"data-driven styling":{js:"0.27.0",android:"5.1.0",ios:"3.6.0",macos:"0.5.0"}},expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"fill-extrusion-base":{type:"number",default:0,minimum:0,units:"meters",doc:"The height with which to extrude the base of this layer. Must be less than or equal to `fill-extrusion-height`.",transition:!0,requires:["fill-extrusion-height"],"sdk-support":{"basic functionality":{js:"0.27.0",android:"5.1.0",ios:"3.6.0",macos:"0.5.0"},"data-driven styling":{js:"0.27.0",android:"5.1.0",ios:"3.6.0",macos:"0.5.0"}},expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"fill-extrusion-vertical-gradient":{type:"boolean",default:!0,doc:"Whether to apply a vertical gradient to the sides of a fill-extrusion layer. If true, sides will be shaded slightly darker farther down.",transition:!1,"sdk-support":{"basic functionality":{js:"0.50.0",ios:"4.7.0",macos:"0.13.0"}},expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"}},paint_line:{"line-opacity":{type:"number",doc:"The opacity at which the line will be drawn.",default:1,minimum:0,maximum:1,transition:!0,"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"},"data-driven styling":{js:"0.29.0",android:"5.0.0",ios:"3.5.0",macos:"0.4.0"}},expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"line-color":{type:"color",doc:"The color with which the line will be drawn.",default:"#000000",transition:!0,requires:[{"!":"line-pattern"}],"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"},"data-driven styling":{js:"0.23.0",android:"5.0.0",ios:"3.5.0",macos:"0.4.0"}},expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"line-translate":{type:"array",value:"number",length:2,default:[0,0],transition:!0,units:"pixels",doc:"The geometry's offset. Values are [x, y] where negatives indicate left and up, respectively.","sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"}},expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"line-translate-anchor":{type:"enum",values:{map:{doc:"The line is translated relative to the map."},viewport:{doc:"The line is translated relative to the viewport."}},doc:"Controls the frame of reference for `line-translate`.",default:"map",requires:["line-translate"],"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"}},expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"line-width":{type:"number",default:1,minimum:0,transition:!0,units:"pixels",doc:"Stroke thickness.","sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"},"data-driven styling":{js:"0.39.0",android:"5.2.0",ios:"3.7.0",macos:"0.6.0"}},expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"line-gap-width":{type:"number",default:0,minimum:0,doc:"Draws a line casing outside of a line's actual path. Value indicates the width of the inner gap.",transition:!0,units:"pixels","sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"},"data-driven styling":{js:"0.29.0",android:"5.0.0",ios:"3.5.0",macos:"0.4.0"}},expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"line-offset":{type:"number",default:0,doc:"The line's offset. For linear features, a positive value offsets the line to the right, relative to the direction of the line, and a negative value to the left. For polygon features, a positive value results in an inset, and a negative value results in an outset.",transition:!0,units:"pixels","sdk-support":{"basic functionality":{js:"0.12.1",android:"3.0.0",ios:"3.1.0",macos:"0.1.0"},"data-driven styling":{js:"0.29.0",android:"5.0.0",ios:"3.5.0",macos:"0.4.0"}},expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"line-blur":{type:"number",default:0,minimum:0,transition:!0,units:"pixels",doc:"Blur applied to the line, in pixels.","sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"},"data-driven styling":{js:"0.29.0",android:"5.0.0",ios:"3.5.0",macos:"0.4.0"}},expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"line-dasharray":{type:"array",value:"number",doc:"Specifies the lengths of the alternating dashes and gaps that form the dash pattern. The lengths are later scaled by the line width. To convert a dash length to pixels, multiply the length by the current line width. Note that GeoJSON sources with `lineMetrics: true` specified won't render dashed lines to the expected scale. Also note that zoom-dependent expressions will be evaluated only at integer zoom levels.",minimum:0,transition:!0,units:"line widths",requires:[{"!":"line-pattern"}],"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"},"data-driven styling":{}},expression:{interpolated:!1,parameters:["zoom"]},"property-type":"cross-faded"},"line-pattern":{type:"resolvedImage",transition:!0,doc:"Name of image in sprite to use for drawing image lines. For seamless patterns, image width must be a factor of two (2, 4, 8, ..., 512). Note that zoom-dependent expressions will be evaluated only at integer zoom levels.","sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"},"data-driven styling":{js:"0.49.0",android:"6.5.0",macos:"0.11.0",ios:"4.4.0"}},expression:{interpolated:!1,parameters:["zoom","feature"]},"property-type":"cross-faded-data-driven"},"line-gradient":{type:"color",doc:'Defines a gradient with which to color a line feature. Can only be used with GeoJSON sources that specify `"lineMetrics": true`.',transition:!1,requires:[{"!":"line-dasharray"},{"!":"line-pattern"},{source:"geojson",has:{lineMetrics:!0}}],"sdk-support":{"basic functionality":{js:"0.45.0",android:"6.5.0",ios:"4.4.0",macos:"0.11.0"},"data-driven styling":{}},expression:{interpolated:!0,parameters:["line-progress"]},"property-type":"color-ramp"}},paint_circle:{"circle-radius":{type:"number",default:5,minimum:0,transition:!0,units:"pixels",doc:"Circle radius.","sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"},"data-driven styling":{js:"0.18.0",android:"5.0.0",ios:"3.5.0",macos:"0.4.0"}},expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"circle-color":{type:"color",default:"#000000",doc:"The fill color of the circle.",transition:!0,"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"},"data-driven styling":{js:"0.18.0",android:"5.0.0",ios:"3.5.0",macos:"0.4.0"}},expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"circle-blur":{type:"number",default:0,doc:"Amount to blur the circle. 1 blurs the circle such that only the centerpoint is full opacity.",transition:!0,"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"},"data-driven styling":{js:"0.20.0",android:"5.0.0",ios:"3.5.0",macos:"0.4.0"}},expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"circle-opacity":{type:"number",doc:"The opacity at which the circle will be drawn.",default:1,minimum:0,maximum:1,transition:!0,"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"},"data-driven styling":{js:"0.20.0",android:"5.0.0",ios:"3.5.0",macos:"0.4.0"}},expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"circle-translate":{type:"array",value:"number",length:2,default:[0,0],transition:!0,units:"pixels",doc:"The geometry's offset. Values are [x, y] where negatives indicate left and up, respectively.","sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"}},expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"circle-translate-anchor":{type:"enum",values:{map:{doc:"The circle is translated relative to the map."},viewport:{doc:"The circle is translated relative to the viewport."}},doc:"Controls the frame of reference for `circle-translate`.",default:"map",requires:["circle-translate"],"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"}},expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"circle-pitch-scale":{type:"enum",values:{map:{doc:"Circles are scaled according to their apparent distance to the camera."},viewport:{doc:"Circles are not scaled."}},default:"map",doc:"Controls the scaling behavior of the circle when the map is pitched.","sdk-support":{"basic functionality":{js:"0.21.0",android:"4.2.0",ios:"3.4.0",macos:"0.2.1"}},expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"circle-pitch-alignment":{type:"enum",values:{map:{doc:"The circle is aligned to the plane of the map."},viewport:{doc:"The circle is aligned to the plane of the viewport."}},default:"viewport",doc:"Orientation of circle when map is pitched.","sdk-support":{"basic functionality":{js:"0.39.0",android:"5.2.0",ios:"3.7.0",macos:"0.6.0"}},expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"circle-stroke-width":{type:"number",default:0,minimum:0,transition:!0,units:"pixels",doc:"The width of the circle's stroke. Strokes are placed outside of the `circle-radius`.","sdk-support":{"basic functionality":{js:"0.29.0",android:"5.0.0",ios:"3.5.0",macos:"0.4.0"},"data-driven styling":{js:"0.29.0",android:"5.0.0",ios:"3.5.0",macos:"0.4.0"}},expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"circle-stroke-color":{type:"color",default:"#000000",doc:"The stroke color of the circle.",transition:!0,"sdk-support":{"basic functionality":{js:"0.29.0",android:"5.0.0",ios:"3.5.0",macos:"0.4.0"},"data-driven styling":{js:"0.29.0",android:"5.0.0",ios:"3.5.0",macos:"0.4.0"}},expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"circle-stroke-opacity":{type:"number",doc:"The opacity of the circle's stroke.",default:1,minimum:0,maximum:1,transition:!0,"sdk-support":{"basic functionality":{js:"0.29.0",android:"5.0.0",ios:"3.5.0",macos:"0.4.0"},"data-driven styling":{js:"0.29.0",android:"5.0.0",ios:"3.5.0",macos:"0.4.0"}},expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"}},paint_heatmap:{"heatmap-radius":{type:"number",default:30,minimum:1,transition:!0,units:"pixels",doc:"Radius of influence of one heatmap point in pixels. Increasing the value makes the heatmap smoother, but less detailed.","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"},"data-driven styling":{js:"0.43.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}},expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"heatmap-weight":{type:"number",default:1,minimum:0,transition:!1,doc:"A measure of how much an individual point contributes to the heatmap. A value of 10 would be equivalent to having 10 points of weight 1 in the same spot. Especially useful when combined with clustering.","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"},"data-driven styling":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}},expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"heatmap-intensity":{type:"number",default:1,minimum:0,transition:!0,doc:"Similar to `heatmap-weight` but controls the intensity of the heatmap globally. Primarily used for adjusting the heatmap based on zoom level.","sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}},expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"heatmap-color":{type:"color",default:["interpolate",["linear"],["heatmap-density"],0,"rgba(0, 0, 255, 0)",.1,"royalblue",.3,"cyan",.5,"lime",.7,"yellow",1,"red"],doc:'Defines the color of each pixel based on its density value in a heatmap.  Should be an expression that uses `["heatmap-density"]` as input.',transition:!1,"sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"},"data-driven styling":{}},expression:{interpolated:!0,parameters:["heatmap-density"]},"property-type":"color-ramp"},"heatmap-opacity":{type:"number",doc:"The global opacity at which the heatmap layer will be drawn.",default:1,minimum:0,maximum:1,transition:!0,"sdk-support":{"basic functionality":{js:"0.41.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}},expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"}},paint_symbol:{"icon-opacity":{doc:"The opacity at which the icon will be drawn.",type:"number",default:1,minimum:0,maximum:1,transition:!0,requires:["icon-image"],"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"},"data-driven styling":{js:"0.33.0",android:"5.0.0",ios:"3.5.0",macos:"0.4.0"}},expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"icon-color":{type:"color",default:"#000000",transition:!0,doc:"The color of the icon. This can only be used with sdf icons.",requires:["icon-image"],"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"},"data-driven styling":{js:"0.33.0",android:"5.0.0",ios:"3.5.0",macos:"0.4.0"}},expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"icon-halo-color":{type:"color",default:"rgba(0, 0, 0, 0)",transition:!0,doc:"The color of the icon's halo. Icon halos can only be used with SDF icons.",requires:["icon-image"],"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"},"data-driven styling":{js:"0.33.0",android:"5.0.0",ios:"3.5.0",macos:"0.4.0"}},expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"icon-halo-width":{type:"number",default:0,minimum:0,transition:!0,units:"pixels",doc:"Distance of halo to the icon outline.",requires:["icon-image"],"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"},"data-driven styling":{js:"0.33.0",android:"5.0.0",ios:"3.5.0",macos:"0.4.0"}},expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"icon-halo-blur":{type:"number",default:0,minimum:0,transition:!0,units:"pixels",doc:"Fade out the halo towards the outside.",requires:["icon-image"],"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"},"data-driven styling":{js:"0.33.0",android:"5.0.0",ios:"3.5.0",macos:"0.4.0"}},expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"icon-translate":{type:"array",value:"number",length:2,default:[0,0],transition:!0,units:"pixels",doc:"Distance that the icon's anchor is moved from its original placement. Positive values indicate right and down, while negative values indicate left and up.",requires:["icon-image"],"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"}},expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"icon-translate-anchor":{type:"enum",values:{map:{doc:"Icons are translated relative to the map."},viewport:{doc:"Icons are translated relative to the viewport."}},doc:"Controls the frame of reference for `icon-translate`.",default:"map",requires:["icon-image","icon-translate"],"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"}},expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"text-opacity":{type:"number",doc:"The opacity at which the text will be drawn.",default:1,minimum:0,maximum:1,transition:!0,requires:["text-field"],"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"},"data-driven styling":{js:"0.33.0",android:"5.0.0",ios:"3.5.0",macos:"0.4.0"}},expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"text-color":{type:"color",doc:"The color with which the text will be drawn.",default:"#000000",transition:!0,overridable:!0,requires:["text-field"],"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"},"data-driven styling":{js:"0.33.0",android:"5.0.0",ios:"3.5.0",macos:"0.4.0"}},expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"text-halo-color":{type:"color",default:"rgba(0, 0, 0, 0)",transition:!0,doc:"The color of the text's halo, which helps it stand out from backgrounds.",requires:["text-field"],"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"},"data-driven styling":{js:"0.33.0",android:"5.0.0",ios:"3.5.0",macos:"0.4.0"}},expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"text-halo-width":{type:"number",default:0,minimum:0,transition:!0,units:"pixels",doc:"Distance of halo to the font outline. Max text halo width is 1/4 of the font-size.",requires:["text-field"],"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"},"data-driven styling":{js:"0.33.0",android:"5.0.0",ios:"3.5.0",macos:"0.4.0"}},expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"text-halo-blur":{type:"number",default:0,minimum:0,transition:!0,units:"pixels",doc:"The halo's fadeout distance towards the outside.",requires:["text-field"],"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"},"data-driven styling":{js:"0.33.0",android:"5.0.0",ios:"3.5.0",macos:"0.4.0"}},expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"text-translate":{type:"array",value:"number",length:2,default:[0,0],transition:!0,units:"pixels",doc:"Distance that the text's anchor is moved from its original placement. Positive values indicate right and down, while negative values indicate left and up.",requires:["text-field"],"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"}},expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"text-translate-anchor":{type:"enum",values:{map:{doc:"The text is translated relative to the map."},viewport:{doc:"The text is translated relative to the viewport."}},doc:"Controls the frame of reference for `text-translate`.",default:"map",requires:["text-field","text-translate"],"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"}},expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"}},paint_raster:{"raster-opacity":{type:"number",doc:"The opacity at which the image will be drawn.",default:1,minimum:0,maximum:1,transition:!0,"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"}},expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"raster-hue-rotate":{type:"number",default:0,period:360,transition:!0,units:"degrees",doc:"Rotates hues around the color wheel.","sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"}},expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"raster-brightness-min":{type:"number",doc:"Increase or reduce the brightness of the image. The value is the minimum brightness.",default:0,minimum:0,maximum:1,transition:!0,"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"}},expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"raster-brightness-max":{type:"number",doc:"Increase or reduce the brightness of the image. The value is the maximum brightness.",default:1,minimum:0,maximum:1,transition:!0,"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"}},expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"raster-saturation":{type:"number",doc:"Increase or reduce the saturation of the image.",default:0,minimum:-1,maximum:1,transition:!0,"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"}},expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"raster-contrast":{type:"number",doc:"Increase or reduce the contrast of the image.",default:0,minimum:-1,maximum:1,transition:!0,"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"}},expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"raster-resampling":{type:"enum",doc:"The resampling/interpolation method to use for overscaling, also known as texture magnification filter",values:{linear:{doc:"(Bi)linear filtering interpolates pixel values using the weighted average of the four closest original source pixels creating a smooth but blurry look when overscaled"},nearest:{doc:"Nearest neighbor filtering interpolates pixel values using the nearest original source pixel creating a sharp but pixelated look when overscaled"}},default:"linear","sdk-support":{"basic functionality":{js:"0.47.0",android:"6.3.0",ios:"4.2.0",macos:"0.9.0"}},expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"raster-fade-duration":{type:"number",default:300,minimum:0,transition:!1,units:"milliseconds",doc:"Fade duration when a new tile is added.","sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"}},expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"}},paint_hillshade:{"hillshade-illumination-direction":{type:"number",default:335,minimum:0,maximum:359,doc:"The direction of the light source used to generate the hillshading with 0 as the top of the viewport if `hillshade-illumination-anchor` is set to `viewport` and due north if `hillshade-illumination-anchor` is set to `map`.",transition:!1,"sdk-support":{"basic functionality":{js:"0.43.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}},expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"hillshade-illumination-anchor":{type:"enum",values:{map:{doc:"The hillshade illumination is relative to the north direction."},viewport:{doc:"The hillshade illumination is relative to the top of the viewport."}},default:"viewport",doc:"Direction of light source when map is rotated.","sdk-support":{"basic functionality":{js:"0.43.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}},expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"hillshade-exaggeration":{type:"number",doc:"Intensity of the hillshade",default:.5,minimum:0,maximum:1,transition:!0,"sdk-support":{"basic functionality":{js:"0.43.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}},expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"hillshade-shadow-color":{type:"color",default:"#000000",doc:"The shading color of areas that face away from the light source.",transition:!0,"sdk-support":{"basic functionality":{js:"0.43.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}},expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"hillshade-highlight-color":{type:"color",default:"#FFFFFF",doc:"The shading color of areas that faces towards the light source.",transition:!0,"sdk-support":{"basic functionality":{js:"0.43.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}},expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"hillshade-accent-color":{type:"color",default:"#000000",doc:"The shading color used to accentuate rugged terrain like sharp cliffs and gorges.",transition:!0,"sdk-support":{"basic functionality":{js:"0.43.0",android:"6.0.0",ios:"4.0.0",macos:"0.7.0"}},expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"}},paint_background:{"background-color":{type:"color",default:"#000000",doc:"The color with which the background will be drawn.",transition:!0,requires:[{"!":"background-pattern"}],"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"}},expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"background-pattern":{type:"resolvedImage",transition:!0,doc:"Name of image in sprite to use for drawing an image background. For seamless patterns, image width and height must be a factor of two (2, 4, 8, ..., 512). Note that zoom-dependent expressions will be evaluated only at integer zoom levels.","sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"},"data-driven styling":{}},expression:{interpolated:!1,parameters:["zoom"]},"property-type":"cross-faded"},"background-opacity":{type:"number",default:1,minimum:0,maximum:1,doc:"The opacity at which the background will be drawn.",transition:!0,"sdk-support":{"basic functionality":{js:"0.10.0",android:"2.0.1",ios:"2.0.0",macos:"0.1.0"}},expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"}},transition:{duration:{type:"number",default:300,minimum:0,units:"milliseconds",doc:"Time allotted for transitions to complete."},delay:{type:"number",default:0,minimum:0,units:"milliseconds",doc:"Length of time before a transition begins."}},"property-type":{"data-driven":{type:"property-type",doc:"Property is interpolable and can be represented using a property expression."},"cross-faded":{type:"property-type",doc:"Property is non-interpolable; rather, its values will be cross-faded to smoothly transition between integer zooms."},"cross-faded-data-driven":{type:"property-type",doc:"Property is non-interpolable; rather, its values will be cross-faded to smoothly transition between integer zooms. It can be represented using a property expression."},"color-ramp":{type:"property-type",doc:"Property should be specified using a color ramp from which the output color can be sampled based on a property calculation."},"data-constant":{type:"property-type",doc:"Property is interpolable but cannot be represented using a property expression."},constant:{type:"property-type",doc:"Property is constant across all zoom levels and property values."}},promoteId:{"*":{type:"string",doc:"A name of a feature property to use as ID for feature state."}}},i=/("(?:[^\\"]|\\.)*")|[:,]/g;function a(e,t){var r={};for(var n in t)void 0!==e[n]&&(r[n]=e[n]);for(var o in e)void 0===r[o]&&(r[o]=e[o]);return r}var s="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:void 0!==e?e:"undefined"!=typeof self?self:{};function l(){throw new Error("Dynamic requires are not currently supported by rollup-plugin-commonjs")}function u(e,t){return e(t={exports:{}},t.exports),t.exports}var c=u((function(e,t){!function(r){var o=t&&!t.nodeType&&t,i=e&&!e.nodeType&&e,a="object"==(void 0===s?"undefined":n(s))&&s;a.global!==a&&a.window!==a&&a.self!==a||(r=a);var l,u,c=2147483647,p=/^xn--/,d=/[^\x20-\x7E]/,h=/[\x2E\u3002\uFF0E\uFF61]/g,f={overflow:"Overflow: input needs wider integers to process","not-basic":"Illegal input >= 0x80 (not a basic code point)","invalid-input":"Invalid input"},y=Math.floor,m=String.fromCharCode;function g(e){throw RangeError(f[e])}function v(e,t){for(var r=e.length,n=[];r--;)n[r]=t(e[r]);return n}function b(e,t){var r=e.split("@"),n="";return r.length>1&&(n=r[0]+"@",e=r[1]),n+v((e=e.replace(h,".")).split("."),t).join(".")}function x(e){for(var t,r,n=[],o=0,i=e.length;o<i;)(t=e.charCodeAt(o++))>=55296&&t<=56319&&o<i?56320==(64512&(r=e.charCodeAt(o++)))?n.push(((1023&t)<<10)+(1023&r)+65536):(n.push(t),o--):n.push(t);return n}function w(e){return v(e,(function(e){var t="";return e>65535&&(t+=m((e-=65536)>>>10&1023|55296),e=56320|1023&e),t+=m(e)})).join("")}function k(e,t){return e+22+75*(e<26)-((0!=t)<<5)}function S(e,t,r){var n=0;for(e=r?y(e/700):e>>1,e+=y(e/t);e>455;n+=36)e=y(e/35);return y(n+36*e/(e+38))}function j(e){var t,r,n,o,i,a,s,l,u,p,d,h=[],f=e.length,m=0,v=128,b=72;for((r=e.lastIndexOf("-"))<0&&(r=0),n=0;n<r;++n)e.charCodeAt(n)>=128&&g("not-basic"),h.push(e.charCodeAt(n));for(o=r>0?r+1:0;o<f;){for(i=m,a=1,s=36;o>=f&&g("invalid-input"),((l=(d=e.charCodeAt(o++))-48<10?d-22:d-65<26?d-65:d-97<26?d-97:36)>=36||l>y((c-m)/a))&&g("overflow"),m+=l*a,!(l<(u=s<=b?1:s>=b+26?26:s-b));s+=36)a>y(c/(p=36-u))&&g("overflow"),a*=p;b=S(m-i,t=h.length+1,0==i),y(m/t)>c-v&&g("overflow"),v+=y(m/t),m%=t,h.splice(m++,0,v)}return w(h)}function T(e){var t,r,n,o,i,a,s,l,u,p,d,h,f,v,b,w=[];for(h=(e=x(e)).length,t=128,r=0,i=72,a=0;a<h;++a)(d=e[a])<128&&w.push(m(d));for(n=o=w.length,o&&w.push("-");n<h;){for(s=c,a=0;a<h;++a)(d=e[a])>=t&&d<s&&(s=d);for(s-t>y((c-r)/(f=n+1))&&g("overflow"),r+=(s-t)*f,t=s,a=0;a<h;++a)if((d=e[a])<t&&++r>c&&g("overflow"),d==t){for(l=r,u=36;!(l<(p=u<=i?1:u>=i+26?26:u-i));u+=36)b=l-p,v=36-p,w.push(m(k(p+b%v,0))),l=y(b/v);w.push(m(k(l,0))),i=S(r,f,n==o),r=0,++n}++r,++t}return w.join("")}if(l={version:"1.3.2",ucs2:{decode:x,encode:w},decode:j,encode:T,toASCII:function(e){return b(e,(function(e){return d.test(e)?"xn--"+T(e):e}))},toUnicode:function(e){return b(e,(function(e){return p.test(e)?j(e.slice(4).toLowerCase()):e}))}},o&&i)if(e.exports==o)i.exports=l;else for(u in l)l.hasOwnProperty(u)&&(o[u]=l[u]);else r.punycode=l}(s)})),p=function(e){return"string"==typeof e},d=function(e){return"object"===(void 0===e?"undefined":n(e))&&null!==e},h=function(e){return null===e},f=function(e){return null==e};function y(e,t){return Object.prototype.hasOwnProperty.call(e,t)}var m=function(e,t,r,n){t=t||"&",r=r||"=";var o={};if("string"!=typeof e||0===e.length)return o;var i=/\+/g;e=e.split(t);var a=1e3;n&&"number"==typeof n.maxKeys&&(a=n.maxKeys);var s=e.length;a>0&&s>a&&(s=a);for(var l=0;l<s;++l){var u,c,p,d,h=e[l].replace(i,"%20"),f=h.indexOf(r);f>=0?(u=h.substr(0,f),c=h.substr(f+1)):(u=h,c=""),p=decodeURIComponent(u),d=decodeURIComponent(c),y(o,p)?Array.isArray(o[p])?o[p].push(d):o[p]=[o[p],d]:o[p]=d}return o},g=function(e){switch(void 0===e?"undefined":n(e)){case"string":return e;case"boolean":return e?"true":"false";case"number":return isFinite(e)?e:"";default:return""}},v=function(e,t,r,o){return t=t||"&",r=r||"=",null===e&&(e=void 0),"object"===(void 0===e?"undefined":n(e))?Object.keys(e).map((function(n){var o=encodeURIComponent(g(n))+r;return Array.isArray(e[n])?e[n].map((function(e){return o+encodeURIComponent(g(e))})).join(t):o+encodeURIComponent(g(e[n]))})).join(t):o?encodeURIComponent(g(o))+r+encodeURIComponent(g(e)):""},b=u((function(e,t){t.decode=t.parse=m,t.encode=t.stringify=v})),x=(b.decode,b.parse,b.encode,b.stringify,F),w=function(e,t){return F(e,!1,!0).resolve(t)},k=function(e,t){if(!e)return t;return F(e,!1,!0).resolveObject(t)},S=function(e){p(e)&&(e=F(e));if(!(e instanceof T))return T.prototype.format.call(e);return e.format()},j=T;function T(){this.protocol=null,this.slashes=null,this.auth=null,this.host=null,this.port=null,this.hostname=null,this.hash=null,this.search=null,this.query=null,this.pathname=null,this.path=null,this.href=null}var z=/^([a-z0-9.+-]+:)/i,A=/:[0-9]*$/,_=/^(\/\/?(?!\/)[^\?\s]*)(\?[^\s]*)?$/,O=["{","}","|","\\","^","`"].concat(["<",">",'"',"`"," ","\r","\n","\t"]),C=["'"].concat(O),I=["%","/","?",";","#"].concat(C),E=["/","?","#"],M=/^[+a-z0-9A-Z_-]{0,63}$/,R=/^([+a-z0-9A-Z_-]{0,63})(.*)$/,P={javascript:!0,"javascript:":!0},q={javascript:!0,"javascript:":!0},N={http:!0,https:!0,ftp:!0,gopher:!0,file:!0,"http:":!0,"https:":!0,"ftp:":!0,"gopher:":!0,"file:":!0};function F(e,t,r){if(e&&d(e)&&e instanceof T)return e;var n=new T;return n.parse(e,t,r),n}T.prototype.parse=function(e,t,r){if(!p(e))throw new TypeError("Parameter 'url' must be a string, not "+(void 0===e?"undefined":n(e)));var o=e.indexOf("?"),i=-1!==o&&o<e.indexOf("#")?"?":"#",a=e.split(i);a[0]=a[0].replace(/\\/g,"/");var s=e=a.join(i);if(s=s.trim(),!r&&1===e.split("#").length){var l=_.exec(s);if(l)return this.path=s,this.href=s,this.pathname=l[1],l[2]?(this.search=l[2],this.query=t?b.parse(this.search.substr(1)):this.search.substr(1)):t&&(this.search="",this.query={}),this}var u=z.exec(s);if(u){var d=(u=u[0]).toLowerCase();this.protocol=d,s=s.substr(u.length)}if(r||u||s.match(/^\/\/[^@\/]+@[^@\/]+/)){var h="//"===s.substr(0,2);!h||u&&q[u]||(s=s.substr(2),this.slashes=!0)}if(!q[u]&&(h||u&&!N[u])){for(var f,y,m=-1,g=0;g<E.length;g++){-1!==(v=s.indexOf(E[g]))&&(-1===m||v<m)&&(m=v)}-1!==(y=-1===m?s.lastIndexOf("@"):s.lastIndexOf("@",m))&&(f=s.slice(0,y),s=s.slice(y+1),this.auth=decodeURIComponent(f)),m=-1;for(g=0;g<I.length;g++){var v;-1!==(v=s.indexOf(I[g]))&&(-1===m||v<m)&&(m=v)}-1===m&&(m=s.length),this.host=s.slice(0,m),s=s.slice(m),this.parseHost(),this.hostname=this.hostname||"";var x="["===this.hostname[0]&&"]"===this.hostname[this.hostname.length-1];if(!x)for(var w=this.hostname.split(/\./),k=(g=0,w.length);g<k;g++){var S=w[g];if(S&&!S.match(M)){for(var j="",T=0,A=S.length;T<A;T++)S.charCodeAt(T)>127?j+="x":j+=S[T];if(!j.match(M)){var O=w.slice(0,g),F=w.slice(g+1),L=S.match(R);L&&(O.push(L[1]),F.unshift(L[2])),F.length&&(s="/"+F.join(".")+s),this.hostname=O.join(".");break}}}this.hostname.length>255?this.hostname="":this.hostname=this.hostname.toLowerCase(),x||(this.hostname=c.toASCII(this.hostname));var D=this.port?":"+this.port:"",B=this.hostname||"";this.host=B+D,this.href+=this.host,x&&(this.hostname=this.hostname.substr(1,this.hostname.length-2),"/"!==s[0]&&(s="/"+s))}if(!P[d])for(g=0,k=C.length;g<k;g++){var U=C[g];if(-1!==s.indexOf(U)){var G=encodeURIComponent(U);G===U&&(G=escape(U)),s=s.split(U).join(G)}}var J=s.indexOf("#");-1!==J&&(this.hash=s.substr(J),s=s.slice(0,J));var $=s.indexOf("?");if(-1!==$?(this.search=s.substr($),this.query=s.substr($+1),t&&(this.query=b.parse(this.query)),s=s.slice(0,$)):t&&(this.search="",this.query={}),s&&(this.pathname=s),N[d]&&this.hostname&&!this.pathname&&(this.pathname="/"),this.pathname||this.search){D=this.pathname||"";var Y=this.search||"";this.path=D+Y}return this.href=this.format(),this},T.prototype.format=function(){var e=this.auth||"";e&&(e=(e=encodeURIComponent(e)).replace(/%3A/i,":"),e+="@");var t=this.protocol||"",r=this.pathname||"",n=this.hash||"",o=!1,i="";this.host?o=e+this.host:this.hostname&&(o=e+(-1===this.hostname.indexOf(":")?this.hostname:"["+this.hostname+"]"),this.port&&(o+=":"+this.port)),this.query&&d(this.query)&&Object.keys(this.query).length&&(i=b.stringify(this.query));var a=this.search||i&&"?"+i||"";return t&&":"!==t.substr(-1)&&(t+=":"),this.slashes||(!t||N[t])&&!1!==o?(o="//"+(o||""),r&&"/"!==r.charAt(0)&&(r="/"+r)):o||(o=""),n&&"#"!==n.charAt(0)&&(n="#"+n),a&&"?"!==a.charAt(0)&&(a="?"+a),t+o+(r=r.replace(/[?#]/g,(function(e){return encodeURIComponent(e)})))+(a=a.replace("#","%23"))+n},T.prototype.resolve=function(e){return this.resolveObject(F(e,!1,!0)).format()},T.prototype.resolveObject=function(e){if(p(e)){var t=new T;t.parse(e,!1,!0),e=t}for(var r=new T,n=Object.keys(this),o=0;o<n.length;o++){var i=n[o];r[i]=this[i]}if(r.hash=e.hash,""===e.href)return r.href=r.format(),r;if(e.slashes&&!e.protocol){for(var a=Object.keys(e),s=0;s<a.length;s++){var l=a[s];"protocol"!==l&&(r[l]=e[l])}return N[r.protocol]&&r.hostname&&!r.pathname&&(r.path=r.pathname="/"),r.href=r.format(),r}if(e.protocol&&e.protocol!==r.protocol){if(!N[e.protocol]){for(var u=Object.keys(e),c=0;c<u.length;c++){var d=u[c];r[d]=e[d]}return r.href=r.format(),r}if(r.protocol=e.protocol,e.host||q[e.protocol])r.pathname=e.pathname;else{for(var y=(e.pathname||"").split("/");y.length&&!(e.host=y.shift()););e.host||(e.host=""),e.hostname||(e.hostname=""),""!==y[0]&&y.unshift(""),y.length<2&&y.unshift(""),r.pathname=y.join("/")}if(r.search=e.search,r.query=e.query,r.host=e.host||"",r.auth=e.auth,r.hostname=e.hostname||e.host,r.port=e.port,r.pathname||r.search){var m=r.pathname||"",g=r.search||"";r.path=m+g}return r.slashes=r.slashes||e.slashes,r.href=r.format(),r}var v=r.pathname&&"/"===r.pathname.charAt(0),b=e.host||e.pathname&&"/"===e.pathname.charAt(0),x=b||v||r.host&&e.pathname,w=x,k=r.pathname&&r.pathname.split("/")||[],S=(y=e.pathname&&e.pathname.split("/")||[],r.protocol&&!N[r.protocol]);if(S&&(r.hostname="",r.port=null,r.host&&(""===k[0]?k[0]=r.host:k.unshift(r.host)),r.host="",e.protocol&&(e.hostname=null,e.port=null,e.host&&(""===y[0]?y[0]=e.host:y.unshift(e.host)),e.host=null),x=x&&(""===y[0]||""===k[0])),b)r.host=e.host||""===e.host?e.host:r.host,r.hostname=e.hostname||""===e.hostname?e.hostname:r.hostname,r.search=e.search,r.query=e.query,k=y;else if(y.length)k||(k=[]),k.pop(),k=k.concat(y),r.search=e.search,r.query=e.query;else if(!f(e.search)){if(S)r.hostname=r.host=k.shift(),(O=!!(r.host&&r.host.indexOf("@")>0)&&r.host.split("@"))&&(r.auth=O.shift(),r.host=r.hostname=O.shift());return r.search=e.search,r.query=e.query,h(r.pathname)&&h(r.search)||(r.path=(r.pathname?r.pathname:"")+(r.search?r.search:"")),r.href=r.format(),r}if(!k.length)return r.pathname=null,r.search?r.path="/"+r.search:r.path=null,r.href=r.format(),r;for(var j=k.slice(-1)[0],z=(r.host||e.host||k.length>1)&&("."===j||".."===j)||""===j,A=0,_=k.length;_>=0;_--)"."===(j=k[_])?k.splice(_,1):".."===j?(k.splice(_,1),A++):A&&(k.splice(_,1),A--);if(!x&&!w)for(;A--;A)k.unshift("..");!x||""===k[0]||k[0]&&"/"===k[0].charAt(0)||k.unshift(""),z&&"/"!==k.join("/").substr(-1)&&k.push("");var O,C=""===k[0]||k[0]&&"/"===k[0].charAt(0);S&&(r.hostname=r.host=C?"":k.length?k.shift():"",(O=!!(r.host&&r.host.indexOf("@")>0)&&r.host.split("@"))&&(r.auth=O.shift(),r.host=r.hostname=O.shift()));return(x=x||r.host&&k.length)&&!C&&k.unshift(""),k.length?r.pathname=k.join("/"):(r.pathname=null,r.path=null),h(r.pathname)&&h(r.search)||(r.path=(r.pathname?r.pathname:"")+(r.search?r.search:"")),r.auth=e.auth||r.auth,r.slashes=r.slashes||e.slashes,r.href=r.format(),r},T.prototype.parseHost=function(){var e=this.host,t=A.exec(e);t&&(":"!==(t=t[0])&&(this.port=t.substr(1)),e=e.substr(0,e.length-t.length)),e&&(this.hostname=e)};var L={parse:x,resolve:w,resolveObject:k,format:S,Url:j};function D(e){for(var t=0;t<o.layout.length;t++)for(var r in o[o.layout[t]])if(r===e)return o[o.layout[t]][r];for(var n=0;n<o.paint.length;n++)for(var i in o[o.paint[n]])if(i===e)return o[o.paint[n]][i];return null}function B(e,t){for(var r in e.sources)t(e.sources[r])}function U(e,t){for(var r=0,n=e.layers;r<n.length;r+=1){t(n[r])}}function G(e,t,r){function n(e,t){var n=e[t];n&&Object.keys(n).forEach((function(o){r({path:[e.id,t,o],key:o,value:n[o],reference:D(o),set:function(e){n[o]=e}})}))}U(e,(function(e){t.paint&&n(e,"paint"),t.layout&&n(e,"layout")}))}function J(e,t){for(var r in e)0===r.indexOf("layout")&&t(e[r],r)}function $(e,t){for(var r in e)0===r.indexOf("paint")&&t(e[r],r)}function Y(e,t){return"string"==typeof t&&"@"===t[0]?Y(e,e.constants[t]):t}function V(e,t,r){e[r]=e[t],delete e[t]}function W(e){var t,r,o;e.version=8,B(e,(function(e){"video"===e.type&&void 0!==e.url&&V(e,"url","urls"),"video"===e.type&&e.coordinates.forEach((function(e){return e.reverse()}))})),U(e,(function(e){J(e,(function(e){void 0!==e["symbol-min-distance"]&&V(e,"symbol-min-distance","symbol-spacing")})),$(e,(function(e){void 0!==e["background-image"]&&V(e,"background-image","background-pattern"),void 0!==e["line-image"]&&V(e,"line-image","line-pattern"),void 0!==e["fill-image"]&&V(e,"fill-image","fill-pattern")}))})),G(e,{paint:!0,layout:!0},(function(t){var r=Y(e,t.value);(function(e){return Array.isArray(e.stops)})(r)&&r.stops.forEach((function(t){t[1]=Y(e,t[1])})),t.set(r)})),delete e.constants,U(e,(function(e){J(e,(function(e){delete e["text-max-size"],delete e["icon-max-size"]})),$(e,(function(t){t["text-size"]&&(e.layout||(e.layout={}),e.layout["text-size"]=t["text-size"],delete t["text-size"]),t["icon-size"]&&(e.layout||(e.layout={}),e.layout["icon-size"]=t["icon-size"],delete t["icon-size"])}))})),e.glyphs&&(e.glyphs=(t=e.glyphs,r=L.parse(t),o=r.pathname.split("/"),"mapbox:"!==r.protocol?t:"fontstack"===r.hostname?"mapbox://fonts/mapbox/{fontstack}/{range}.pbf":"fonts"===r.hostname?"mapbox://fonts/"+o[2]+"/{fontstack}/{range}.pbf":void 0)),U(e,(function(e){J(e,(function(e){e["text-font"]&&(e["text-font"]=function(e){function t(e){return e.split(",").map((function(e){return e.trim()}))}if(Array.isArray(e))return e;if("string"==typeof e)return t(e);if("object"===(void 0===e?"undefined":n(e)))return e.stops.forEach((function(e){e[1]=t(e[1])})),e;throw new Error("unexpected font value")}(e["text-font"]))}))}));for(var i=0,a=e.layers.length-1;a>=0;a--){if("symbol"!==e.layers[a].type){i=a+1;break}}var s=e.layers.splice(i);return s.reverse(),e.layers=e.layers.concat(s),e}function H(e){for(var t=[],r=arguments.length-1;r-- >0;)t[r]=arguments[r+1];for(var n=0,o=t;n<o.length;n+=1){var i=o[n];for(var a in i)e[a]=i[a]}return e}var Z=function(e){function t(t,r){e.call(this,r),this.message=r,this.key=t}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t}(Error),K=function(e,t){void 0===t&&(t=[]),this.parent=e,this.bindings={};for(var r=0,n=t;r<n.length;r+=1){var o=n[r],i=o[0],a=o[1];this.bindings[i]=a}};K.prototype.concat=function(e){return new K(this,e)},K.prototype.get=function(e){if(this.bindings[e])return this.bindings[e];if(this.parent)return this.parent.get(e);throw new Error(e+" not found in scope.")},K.prototype.has=function(e){return!!this.bindings[e]||!!this.parent&&this.parent.has(e)};var X={kind:"null"},Q={kind:"number"},ee={kind:"string"},te={kind:"boolean"},re={kind:"color"},ne={kind:"object"},oe={kind:"value"},ie={kind:"collator"},ae={kind:"formatted"},se={kind:"resolvedImage"};function le(e,t){return{kind:"array",itemType:e,N:t}}function ue(e){if("array"===e.kind){var t=ue(e.itemType);return"number"==typeof e.N?"array<"+t+", "+e.N+">":"value"===e.itemType.kind?"array":"array<"+t+">"}return e.kind}var ce=[X,Q,ee,te,re,ae,ne,le(oe),se];function pe(e,t){if("error"===t.kind)return null;if("array"===e.kind){if("array"===t.kind&&(0===t.N&&"value"===t.itemType.kind||!pe(e.itemType,t.itemType))&&("number"!=typeof e.N||e.N===t.N))return null}else{if(e.kind===t.kind)return null;if("value"===e.kind)for(var r=0,n=ce;r<n.length;r+=1){if(!pe(n[r],t))return null}}return"Expected "+ue(e)+" but found "+ue(t)+" instead."}function de(e,t){return t.some((function(t){return t.kind===e.kind}))}function he(e,t){return t.some((function(t){return"null"===t?null===e:"array"===t?Array.isArray(e):"object"===t?e&&!Array.isArray(e)&&"object"===(void 0===e?"undefined":n(e)):t===(void 0===e?"undefined":n(e))}))}var fe=u((function(e,t){var r={transparent:[0,0,0,0],aliceblue:[240,248,255,1],antiquewhite:[250,235,215,1],aqua:[0,255,255,1],aquamarine:[127,255,212,1],azure:[240,255,255,1],beige:[245,245,220,1],bisque:[255,228,196,1],black:[0,0,0,1],blanchedalmond:[255,235,205,1],blue:[0,0,255,1],blueviolet:[138,43,226,1],brown:[165,42,42,1],burlywood:[222,184,135,1],cadetblue:[95,158,160,1],chartreuse:[127,255,0,1],chocolate:[210,105,30,1],coral:[255,127,80,1],cornflowerblue:[100,149,237,1],cornsilk:[255,248,220,1],crimson:[220,20,60,1],cyan:[0,255,255,1],darkblue:[0,0,139,1],darkcyan:[0,139,139,1],darkgoldenrod:[184,134,11,1],darkgray:[169,169,169,1],darkgreen:[0,100,0,1],darkgrey:[169,169,169,1],darkkhaki:[189,183,107,1],darkmagenta:[139,0,139,1],darkolivegreen:[85,107,47,1],darkorange:[255,140,0,1],darkorchid:[153,50,204,1],darkred:[139,0,0,1],darksalmon:[233,150,122,1],darkseagreen:[143,188,143,1],darkslateblue:[72,61,139,1],darkslategray:[47,79,79,1],darkslategrey:[47,79,79,1],darkturquoise:[0,206,209,1],darkviolet:[148,0,211,1],deeppink:[255,20,147,1],deepskyblue:[0,191,255,1],dimgray:[105,105,105,1],dimgrey:[105,105,105,1],dodgerblue:[30,144,255,1],firebrick:[178,34,34,1],floralwhite:[255,250,240,1],forestgreen:[34,139,34,1],fuchsia:[255,0,255,1],gainsboro:[220,220,220,1],ghostwhite:[248,248,255,1],gold:[255,215,0,1],goldenrod:[218,165,32,1],gray:[128,128,128,1],green:[0,128,0,1],greenyellow:[173,255,47,1],grey:[128,128,128,1],honeydew:[240,255,240,1],hotpink:[255,105,180,1],indianred:[205,92,92,1],indigo:[75,0,130,1],ivory:[255,255,240,1],khaki:[240,230,140,1],lavender:[230,230,250,1],lavenderblush:[255,240,245,1],lawngreen:[124,252,0,1],lemonchiffon:[255,250,205,1],lightblue:[173,216,230,1],lightcoral:[240,128,128,1],lightcyan:[224,255,255,1],lightgoldenrodyellow:[250,250,210,1],lightgray:[211,211,211,1],lightgreen:[144,238,144,1],lightgrey:[211,211,211,1],lightpink:[255,182,193,1],lightsalmon:[255,160,122,1],lightseagreen:[32,178,170,1],lightskyblue:[135,206,250,1],lightslategray:[119,136,153,1],lightslategrey:[119,136,153,1],lightsteelblue:[176,196,222,1],lightyellow:[255,255,224,1],lime:[0,255,0,1],limegreen:[50,205,50,1],linen:[250,240,230,1],magenta:[255,0,255,1],maroon:[128,0,0,1],mediumaquamarine:[102,205,170,1],mediumblue:[0,0,205,1],mediumorchid:[186,85,211,1],mediumpurple:[147,112,219,1],mediumseagreen:[60,179,113,1],mediumslateblue:[123,104,238,1],mediumspringgreen:[0,250,154,1],mediumturquoise:[72,209,204,1],mediumvioletred:[199,21,133,1],midnightblue:[25,25,112,1],mintcream:[245,255,250,1],mistyrose:[255,228,225,1],moccasin:[255,228,181,1],navajowhite:[255,222,173,1],navy:[0,0,128,1],oldlace:[253,245,230,1],olive:[128,128,0,1],olivedrab:[107,142,35,1],orange:[255,165,0,1],orangered:[255,69,0,1],orchid:[218,112,214,1],palegoldenrod:[238,232,170,1],palegreen:[152,251,152,1],paleturquoise:[175,238,238,1],palevioletred:[219,112,147,1],papayawhip:[255,239,213,1],peachpuff:[255,218,185,1],peru:[205,133,63,1],pink:[255,192,203,1],plum:[221,160,221,1],powderblue:[176,224,230,1],purple:[128,0,128,1],rebeccapurple:[102,51,153,1],red:[255,0,0,1],rosybrown:[188,143,143,1],royalblue:[65,105,225,1],saddlebrown:[139,69,19,1],salmon:[250,128,114,1],sandybrown:[244,164,96,1],seagreen:[46,139,87,1],seashell:[255,245,238,1],sienna:[160,82,45,1],silver:[192,192,192,1],skyblue:[135,206,235,1],slateblue:[106,90,205,1],slategray:[112,128,144,1],slategrey:[112,128,144,1],snow:[255,250,250,1],springgreen:[0,255,127,1],steelblue:[70,130,180,1],tan:[210,180,140,1],teal:[0,128,128,1],thistle:[216,191,216,1],tomato:[255,99,71,1],turquoise:[64,224,208,1],violet:[238,130,238,1],wheat:[245,222,179,1],white:[255,255,255,1],whitesmoke:[245,245,245,1],yellow:[255,255,0,1],yellowgreen:[154,205,50,1]};function n(e){return(e=Math.round(e))<0?0:e>255?255:e}function o(e){return e<0?0:e>1?1:e}function i(e){return"%"===e[e.length-1]?n(parseFloat(e)/100*255):n(parseInt(e))}function a(e){return"%"===e[e.length-1]?o(parseFloat(e)/100):o(parseFloat(e))}function s(e,t,r){return r<0?r+=1:r>1&&(r-=1),6*r<1?e+(t-e)*r*6:2*r<1?t:3*r<2?e+(t-e)*(2/3-r)*6:e}try{t.parseCSSColor=function(e){var t,o=e.replace(/ /g,"").toLowerCase();if(o in r)return r[o].slice();if("#"===o[0])return 4===o.length?(t=parseInt(o.substr(1),16))>=0&&t<=4095?[(3840&t)>>4|(3840&t)>>8,240&t|(240&t)>>4,15&t|(15&t)<<4,1]:null:7===o.length&&(t=parseInt(o.substr(1),16))>=0&&t<=16777215?[(16711680&t)>>16,(65280&t)>>8,255&t,1]:null;var l=o.indexOf("("),u=o.indexOf(")");if(-1!==l&&u+1===o.length){var c=o.substr(0,l),p=o.substr(l+1,u-(l+1)).split(","),d=1;switch(c){case"rgba":if(4!==p.length)return null;d=a(p.pop());case"rgb":return 3!==p.length?null:[i(p[0]),i(p[1]),i(p[2]),d];case"hsla":if(4!==p.length)return null;d=a(p.pop());case"hsl":if(3!==p.length)return null;var h=(parseFloat(p[0])%360+360)%360/360,f=a(p[1]),y=a(p[2]),m=y<=.5?y*(f+1):y+f-y*f,g=2*y-m;return[n(255*s(g,m,h+1/3)),n(255*s(g,m,h)),n(255*s(g,m,h-1/3)),d];default:return null}}return null}}catch(e){}})).parseCSSColor,ye=function(e,t,r,n){void 0===n&&(n=1),this.r=e,this.g=t,this.b=r,this.a=n};ye.parse=function(e){if(e){if(e instanceof ye)return e;if("string"==typeof e){var t=fe(e);if(t)return new ye(t[0]/255*t[3],t[1]/255*t[3],t[2]/255*t[3],t[3])}}},ye.prototype.toString=function(){var e=this.toArray(),t=e[0],r=e[1],n=e[2],o=e[3];return"rgba("+Math.round(t)+","+Math.round(r)+","+Math.round(n)+","+o+")"},ye.prototype.toArray=function(){var e=this.r,t=this.g,r=this.b,n=this.a;return 0===n?[0,0,0,0]:[255*e/n,255*t/n,255*r/n,n]},ye.black=new ye(0,0,0,1),ye.white=new ye(1,1,1,1),ye.transparent=new ye(0,0,0,0),ye.red=new ye(1,0,0,1);var me=function(e,t,r){this.sensitivity=e?t?"variant":"case":t?"accent":"base",this.locale=r,this.collator=new Intl.Collator(this.locale?this.locale:[],{sensitivity:this.sensitivity,usage:"search"})};me.prototype.compare=function(e,t){return this.collator.compare(e,t)},me.prototype.resolvedLocale=function(){return new Intl.Collator(this.locale?this.locale:[]).resolvedOptions().locale};var ge=function(e,t,r,n,o){this.text=e,this.image=t,this.scale=r,this.fontStack=n,this.textColor=o},ve=function(e){this.sections=e};ve.fromString=function(e){return new ve([new ge(e,null,null,null,null)])},ve.prototype.isEmpty=function(){return 0===this.sections.length||!this.sections.some((function(e){return 0!==e.text.length||e.image&&0!==e.image.name.length}))},ve.factory=function(e){return e instanceof ve?e:ve.fromString(e)},ve.prototype.toString=function(){return 0===this.sections.length?"":this.sections.map((function(e){return e.text})).join("")},ve.prototype.serialize=function(){for(var e=["format"],t=0,r=this.sections;t<r.length;t+=1){var n=r[t];if(n.image)e.push(["image",n.image.name]);else{e.push(n.text);var o={};n.fontStack&&(o["text-font"]=["literal",n.fontStack.split(",")]),n.scale&&(o["font-scale"]=n.scale),n.textColor&&(o["text-color"]=["rgba"].concat(n.textColor.toArray())),e.push(o)}}return e};var be=function(e){this.name=e.name,this.available=e.available};function xe(e,t,r,n){return"number"==typeof e&&e>=0&&e<=255&&"number"==typeof t&&t>=0&&t<=255&&"number"==typeof r&&r>=0&&r<=255?void 0===n||"number"==typeof n&&n>=0&&n<=1?null:"Invalid rgba value ["+[e,t,r,n].join(", ")+"]: 'a' must be between 0 and 1.":"Invalid rgba value ["+("number"==typeof n?[e,t,r,n]:[e,t,r]).join(", ")+"]: 'r', 'g', and 'b' must be between 0 and 255."}function we(e){if(null===e)return!0;if("string"==typeof e)return!0;if("boolean"==typeof e)return!0;if("number"==typeof e)return!0;if(e instanceof ye)return!0;if(e instanceof me)return!0;if(e instanceof ve)return!0;if(e instanceof be)return!0;if(Array.isArray(e)){for(var t=0,r=e;t<r.length;t+=1){if(!we(r[t]))return!1}return!0}if("object"===(void 0===e?"undefined":n(e))){for(var o in e)if(!we(e[o]))return!1;return!0}return!1}function ke(e){if(null===e)return X;if("string"==typeof e)return ee;if("boolean"==typeof e)return te;if("number"==typeof e)return Q;if(e instanceof ye)return re;if(e instanceof me)return ie;if(e instanceof ve)return ae;if(e instanceof be)return se;if(Array.isArray(e)){for(var t,r=e.length,n=0,o=e;n<o.length;n+=1){var i=ke(o[n]);if(t){if(t===i)continue;t=oe;break}t=i}return le(t||oe,r)}return ne}function Se(e){var t=void 0===e?"undefined":n(e);return null===e?"":"string"===t||"number"===t||"boolean"===t?String(e):e instanceof ye||e instanceof ve||e instanceof be?e.toString():JSON.stringify(e)}be.prototype.toString=function(){return this.name},be.fromString=function(e){return e?new be({name:e,available:!1}):null},be.prototype.serialize=function(){return["image",this.name]};var je=function(e,t){this.type=e,this.value=t};je.parse=function(e,t){if(2!==e.length)return t.error("'literal' expression requires exactly one argument, but found "+(e.length-1)+" instead.");if(!we(e[1]))return t.error("invalid value");var r=e[1],n=ke(r),o=t.expectedType;return"array"!==n.kind||0!==n.N||!o||"array"!==o.kind||"number"==typeof o.N&&0!==o.N||(n=o),new je(n,r)},je.prototype.evaluate=function(){return this.value},je.prototype.eachChild=function(){},je.prototype.outputDefined=function(){return!0},je.prototype.serialize=function(){return"array"===this.type.kind||"object"===this.type.kind?["literal",this.value]:this.value instanceof ye?["rgba"].concat(this.value.toArray()):this.value instanceof ve?this.value.serialize():this.value};var Te=function(e){this.name="ExpressionEvaluationError",this.message=e};Te.prototype.toJSON=function(){return this.message};var ze={string:ee,number:Q,boolean:te,object:ne},Ae=function(e,t){this.type=e,this.args=t};Ae.parse=function(e,t){if(e.length<2)return t.error("Expected at least one argument.");var r,n=1,o=e[0];if("array"===o){var i,a;if(e.length>2){var s=e[1];if("string"!=typeof s||!(s in ze)||"object"===s)return t.error('The item type argument of "array" must be one of string, number, boolean',1);i=ze[s],n++}else i=oe;if(e.length>3){if(null!==e[2]&&("number"!=typeof e[2]||e[2]<0||e[2]!==Math.floor(e[2])))return t.error('The length argument to "array" must be a positive integer literal',2);a=e[2],n++}r=le(i,a)}else r=ze[o];for(var l=[];n<e.length;n++){var u=t.parse(e[n],n,oe);if(!u)return null;l.push(u)}return new Ae(r,l)},Ae.prototype.evaluate=function(e){for(var t=0;t<this.args.length;t++){var r=this.args[t].evaluate(e);if(!pe(this.type,ke(r)))return r;if(t===this.args.length-1)throw new Te("Expected value to be of type "+ue(this.type)+", but found "+ue(ke(r))+" instead.")}return null},Ae.prototype.eachChild=function(e){this.args.forEach(e)},Ae.prototype.outputDefined=function(){return this.args.every((function(e){return e.outputDefined()}))},Ae.prototype.serialize=function(){var e=this.type,t=[e.kind];if("array"===e.kind){var r=e.itemType;if("string"===r.kind||"number"===r.kind||"boolean"===r.kind){t.push(r.kind);var n=e.N;("number"==typeof n||this.args.length>1)&&t.push(n)}}return t.concat(this.args.map((function(e){return e.serialize()})))};var _e=function(e){this.type=ae,this.sections=e};_e.parse=function(e,t){if(e.length<2)return t.error("Expected at least one argument.");var r=e[1];if(!Array.isArray(r)&&"object"===(void 0===r?"undefined":n(r)))return t.error("First argument must be an image or text section.");for(var o=[],i=!1,a=1;a<=e.length-1;++a){var s=e[a];if(i&&"object"===(void 0===s?"undefined":n(s))&&!Array.isArray(s)){i=!1;var l=null;if(s["font-scale"]&&!(l=t.parse(s["font-scale"],1,Q)))return null;var u=null;if(s["text-font"]&&!(u=t.parse(s["text-font"],1,le(ee))))return null;var c=null;if(s["text-color"]&&!(c=t.parse(s["text-color"],1,re)))return null;var p=o[o.length-1];p.scale=l,p.font=u,p.textColor=c}else{var d=t.parse(e[a],1,oe);if(!d)return null;var h=d.type.kind;if("string"!==h&&"value"!==h&&"null"!==h&&"resolvedImage"!==h)return t.error("Formatted text type must be 'string', 'value', 'image' or 'null'.");i=!0,o.push({content:d,scale:null,font:null,textColor:null})}}return new _e(o)},_e.prototype.evaluate=function(e){return new ve(this.sections.map((function(t){var r=t.content.evaluate(e);return ke(r)===se?new ge("",r,null,null,null):new ge(Se(r),null,t.scale?t.scale.evaluate(e):null,t.font?t.font.evaluate(e).join(","):null,t.textColor?t.textColor.evaluate(e):null)})))},_e.prototype.eachChild=function(e){for(var t=0,r=this.sections;t<r.length;t+=1){var n=r[t];e(n.content),n.scale&&e(n.scale),n.font&&e(n.font),n.textColor&&e(n.textColor)}},_e.prototype.outputDefined=function(){return!1},_e.prototype.serialize=function(){for(var e=["format"],t=0,r=this.sections;t<r.length;t+=1){var n=r[t];e.push(n.content.serialize());var o={};n.scale&&(o["font-scale"]=n.scale.serialize()),n.font&&(o["text-font"]=n.font.serialize()),n.textColor&&(o["text-color"]=n.textColor.serialize()),e.push(o)}return e};var Oe=function(e){this.type=se,this.input=e};Oe.parse=function(e,t){if(2!==e.length)return t.error("Expected two arguments.");var r=t.parse(e[1],1,ee);return r?new Oe(r):t.error("No image name provided.")},Oe.prototype.evaluate=function(e){var t=this.input.evaluate(e),r=be.fromString(t);return r&&e.availableImages&&(r.available=e.availableImages.indexOf(t)>-1),r},Oe.prototype.eachChild=function(e){e(this.input)},Oe.prototype.outputDefined=function(){return!1},Oe.prototype.serialize=function(){return["image",this.input.serialize()]};var Ce={"to-boolean":te,"to-color":re,"to-number":Q,"to-string":ee},Ie=function(e,t){this.type=e,this.args=t};Ie.parse=function(e,t){if(e.length<2)return t.error("Expected at least one argument.");var r=e[0];if(("to-boolean"===r||"to-string"===r)&&2!==e.length)return t.error("Expected one argument.");for(var n=Ce[r],o=[],i=1;i<e.length;i++){var a=t.parse(e[i],i,oe);if(!a)return null;o.push(a)}return new Ie(n,o)},Ie.prototype.evaluate=function(e){if("boolean"===this.type.kind)return Boolean(this.args[0].evaluate(e));if("color"===this.type.kind){for(var t,r,n=0,o=this.args;n<o.length;n+=1){if(r=null,(t=o[n].evaluate(e))instanceof ye)return t;if("string"==typeof t){var i=e.parseColor(t);if(i)return i}else if(Array.isArray(t)&&!(r=t.length<3||t.length>4?"Invalid rbga value "+JSON.stringify(t)+": expected an array containing either three or four numeric values.":xe(t[0],t[1],t[2],t[3])))return new ye(t[0]/255,t[1]/255,t[2]/255,t[3])}throw new Te(r||"Could not parse color from value '"+("string"==typeof t?t:String(JSON.stringify(t)))+"'")}if("number"===this.type.kind){for(var a=null,s=0,l=this.args;s<l.length;s+=1){if(null===(a=l[s].evaluate(e)))return 0;var u=Number(a);if(!isNaN(u))return u}throw new Te("Could not convert "+JSON.stringify(a)+" to number.")}return"formatted"===this.type.kind?ve.fromString(Se(this.args[0].evaluate(e))):"resolvedImage"===this.type.kind?be.fromString(Se(this.args[0].evaluate(e))):Se(this.args[0].evaluate(e))},Ie.prototype.eachChild=function(e){this.args.forEach(e)},Ie.prototype.outputDefined=function(){return this.args.every((function(e){return e.outputDefined()}))},Ie.prototype.serialize=function(){if("formatted"===this.type.kind)return new _e([{content:this.args[0],scale:null,font:null,textColor:null}]).serialize();if("resolvedImage"===this.type.kind)return new Oe(this.args[0]).serialize();var e=["to-"+this.type.kind];return this.eachChild((function(t){e.push(t.serialize())})),e};var Ee=["Unknown","Point","LineString","Polygon"],Me=function(){this.globals=null,this.feature=null,this.featureState=null,this.formattedSection=null,this._parseColorCache={},this.availableImages=null,this.canonical=null};Me.prototype.id=function(){return this.feature&&"id"in this.feature?this.feature.id:null},Me.prototype.geometryType=function(){return this.feature?"number"==typeof this.feature.type?Ee[this.feature.type]:this.feature.type:null},Me.prototype.geometry=function(){return this.feature&&"geometry"in this.feature?this.feature.geometry:null},Me.prototype.canonicalID=function(){return this.canonical},Me.prototype.properties=function(){return this.feature&&this.feature.properties||{}},Me.prototype.parseColor=function(e){var t=this._parseColorCache[e];return t||(t=this._parseColorCache[e]=ye.parse(e)),t};var Re=function(e,t,r,n){this.name=e,this.type=t,this._evaluate=r,this.args=n};Re.prototype.evaluate=function(e){return this._evaluate(e,this.args)},Re.prototype.eachChild=function(e){this.args.forEach(e)},Re.prototype.outputDefined=function(){return!1},Re.prototype.serialize=function(){return[this.name].concat(this.args.map((function(e){return e.serialize()})))},Re.parse=function(e,t){var r,n=e[0],o=Re.definitions[n];if(!o)return t.error('Unknown expression "'+n+'". If you wanted a literal array, use ["literal", [...]].',0);for(var i=Array.isArray(o)?o[0]:o.type,a=Array.isArray(o)?[[o[1],o[2]]]:o.overloads,s=a.filter((function(t){var r=t[0];return!Array.isArray(r)||r.length===e.length-1})),l=null,u=0,c=s;u<c.length;u+=1){var p=c[u],d=p[0],h=p[1];l=new rt(t.registry,t.path,null,t.scope);for(var f=[],y=!1,m=1;m<e.length;m++){var g=e[m],v=Array.isArray(d)?d[m-1]:d.type,b=l.parse(g,1+f.length,v);if(!b){y=!0;break}f.push(b)}if(!y)if(Array.isArray(d)&&d.length!==f.length)l.error("Expected "+d.length+" arguments, but found "+f.length+" instead.");else{for(var x=0;x<f.length;x++){var w=Array.isArray(d)?d[x]:d.type,k=f[x];l.concat(x+1).checkSubtype(w,k.type)}if(0===l.errors.length)return new Re(n,i,h,f)}}if(1===s.length)(r=t.errors).push.apply(r,l.errors);else{for(var S=(s.length?s:a).map((function(e){var t,r=e[0];return t=r,Array.isArray(t)?"("+t.map(ue).join(", ")+")":"("+ue(t.type)+"...)"})).join(" | "),j=[],T=1;T<e.length;T++){var z=t.parse(e[T],1+j.length);if(!z)return null;j.push(ue(z.type))}t.error("Expected arguments of type "+S+", but found ("+j.join(", ")+") instead.")}return null},Re.register=function(e,t){for(var r in Re.definitions=t,t)e[r]=Re};var Pe=function(e,t,r){this.type=ie,this.locale=r,this.caseSensitive=e,this.diacriticSensitive=t};Pe.parse=function(e,t){if(2!==e.length)return t.error("Expected one argument.");var r=e[1];if("object"!==(void 0===r?"undefined":n(r))||Array.isArray(r))return t.error("Collator options argument must be an object.");var o=t.parse(void 0!==r["case-sensitive"]&&r["case-sensitive"],1,te);if(!o)return null;var i=t.parse(void 0!==r["diacritic-sensitive"]&&r["diacritic-sensitive"],1,te);if(!i)return null;var a=null;return r.locale&&!(a=t.parse(r.locale,1,ee))?null:new Pe(o,i,a)},Pe.prototype.evaluate=function(e){return new me(this.caseSensitive.evaluate(e),this.diacriticSensitive.evaluate(e),this.locale?this.locale.evaluate(e):null)},Pe.prototype.eachChild=function(e){e(this.caseSensitive),e(this.diacriticSensitive),this.locale&&e(this.locale)},Pe.prototype.outputDefined=function(){return!1},Pe.prototype.serialize=function(){var e={};return e["case-sensitive"]=this.caseSensitive.serialize(),e["diacritic-sensitive"]=this.diacriticSensitive.serialize(),this.locale&&(e.locale=this.locale.serialize()),["collator",e]};function qe(e,t){e[0]=Math.min(e[0],t[0]),e[1]=Math.min(e[1],t[1]),e[2]=Math.max(e[2],t[0]),e[3]=Math.max(e[3],t[1])}function Ne(e,t){return!(e[0]<=t[0])&&(!(e[2]>=t[2])&&(!(e[1]<=t[1])&&!(e[3]>=t[3])))}function Fe(e,t){var r,n=(180+e[0])/360,o=(r=e[1],(180-180/Math.PI*Math.log(Math.tan(Math.PI/4+r*Math.PI/360)))/360),i=Math.pow(2,t.z);return[Math.round(n*i*8192),Math.round(o*i*8192)]}function Le(e,t,r){return t[1]>e[1]!=r[1]>e[1]&&e[0]<(r[0]-t[0])*(e[1]-t[1])/(r[1]-t[1])+t[0]}function De(e,t){for(var r,n,o,i,a,s,l,u=!1,c=0,p=t.length;c<p;c++)for(var d=t[c],h=0,f=d.length;h<f-1;h++){if(r=e,n=d[h],o=d[h+1],i=void 0,a=void 0,s=void 0,l=void 0,i=r[0]-n[0],a=r[1]-n[1],s=r[0]-o[0],l=r[1]-o[1],i*l-s*a==0&&i*s<=0&&a*l<=0)return!1;Le(e,d[h],d[h+1])&&(u=!u)}return u}function Be(e,t){for(var r=0;r<t.length;r++)if(De(e,t[r]))return!0;return!1}function Ue(e,t,r,n){var o=e[0]-r[0],i=e[1]-r[1],a=t[0]-r[0],s=t[1]-r[1],l=n[0]-r[0],u=n[1]-r[1],c=o*u-l*i,p=a*u-l*s;return c>0&&p<0||c<0&&p>0}function Ge(e,t,r){for(var n=0,o=r;n<o.length;n+=1)for(var i=o[n],a=0;a<i.length-1;++a)if(s=e,l=t,u=i[a],c=i[a+1],p=void 0,d=void 0,h=void 0,f=void 0,h=[l[0]-s[0],l[1]-s[1]],f=[c[0]-u[0],c[1]-u[1]],0!=(p=f)[0]*(d=h)[1]-p[1]*d[0]&&Ue(s,l,u,c)&&Ue(u,c,s,l))return!0;var s,l,u,c,p,d,h,f;return!1}function Je(e,t){for(var r=0;r<e.length;++r)if(!De(e[r],t))return!1;for(var n=0;n<e.length-1;++n)if(Ge(e[n],e[n+1],t))return!1;return!0}function $e(e,t){for(var r=0;r<t.length;r++)if(Je(e,t[r]))return!0;return!1}function Ye(e,t,r){for(var n=[],o=0;o<e.length;o++){for(var i=[],a=0;a<e[o].length;a++){var s=Fe(e[o][a],r);qe(t,s),i.push(s)}n.push(i)}return n}function Ve(e,t,r){for(var n=[],o=0;o<e.length;o++){var i=Ye(e[o],t,r);n.push(i)}return n}function We(e,t,r,n){if(e[0]<r[0]||e[0]>r[2]){var o=.5*n,i=e[0]-r[0]>o?-n:r[0]-e[0]>o?n:0;0===i&&(i=e[0]-r[2]>o?-n:r[2]-e[0]>o?n:0),e[0]+=i}qe(t,e)}function He(e,t,r,n){for(var o=8192*Math.pow(2,n.z),i=[8192*n.x,8192*n.y],a=[],s=0,l=e;s<l.length;s+=1)for(var u=0,c=l[s];u<c.length;u+=1){var p=c[u],d=[p.x+i[0],p.y+i[1]];We(d,t,r,o),a.push(d)}return a}function Ze(e,t,r,n){for(var o,i=8192*Math.pow(2,n.z),a=[8192*n.x,8192*n.y],s=[],l=0,u=e;l<u.length;l+=1){for(var c=[],p=0,d=u[l];p<d.length;p+=1){var h=d[p],f=[h.x+a[0],h.y+a[1]];qe(t,f),c.push(f)}s.push(c)}if(t[2]-t[0]<=i/2){(o=t)[0]=o[1]=1/0,o[2]=o[3]=-1/0;for(var y=0,m=s;y<m.length;y+=1)for(var g=0,v=m[y];g<v.length;g+=1){We(v[g],t,r,i)}}return s}var Ke=function(e,t){this.type=te,this.geojson=e,this.geometries=t};function Xe(e){if(e instanceof Re){if("get"===e.name&&1===e.args.length)return!1;if("feature-state"===e.name)return!1;if("has"===e.name&&1===e.args.length)return!1;if("properties"===e.name||"geometry-type"===e.name||"id"===e.name)return!1;if(/^filter-/.test(e.name))return!1}if(e instanceof Ke)return!1;var t=!0;return e.eachChild((function(e){t&&!Xe(e)&&(t=!1)})),t}function Qe(e){if(e instanceof Re&&"feature-state"===e.name)return!1;var t=!0;return e.eachChild((function(e){t&&!Qe(e)&&(t=!1)})),t}function et(e,t){if(e instanceof Re&&t.indexOf(e.name)>=0)return!1;var r=!0;return e.eachChild((function(e){r&&!et(e,t)&&(r=!1)})),r}Ke.parse=function(e,t){if(2!==e.length)return t.error("'within' expression requires exactly one argument, but found "+(e.length-1)+" instead.");if(we(e[1])){var r=e[1];if("FeatureCollection"===r.type)for(var n=0;n<r.features.length;++n){var o=r.features[n].geometry.type;if("Polygon"===o||"MultiPolygon"===o)return new Ke(r,r.features[n].geometry)}else if("Feature"===r.type){var i=r.geometry.type;if("Polygon"===i||"MultiPolygon"===i)return new Ke(r,r.geometry)}else if("Polygon"===r.type||"MultiPolygon"===r.type)return new Ke(r,r)}return t.error("'within' expression requires valid geojson object that contains polygon geometry type.")},Ke.prototype.evaluate=function(e){if(null!=e.geometry()&&null!=e.canonicalID()){if("Point"===e.geometryType())return function(e,t){var r=[1/0,1/0,-1/0,-1/0],n=[1/0,1/0,-1/0,-1/0],o=e.canonicalID();if("Polygon"===t.type){var i=Ye(t.coordinates,n,o),a=He(e.geometry(),r,n,o);if(!Ne(r,n))return!1;for(var s=0,l=a;s<l.length;s+=1){if(!De(l[s],i))return!1}}if("MultiPolygon"===t.type){var u=Ve(t.coordinates,n,o),c=He(e.geometry(),r,n,o);if(!Ne(r,n))return!1;for(var p=0,d=c;p<d.length;p+=1){if(!Be(d[p],u))return!1}}return!0}(e,this.geometries);if("LineString"===e.geometryType())return function(e,t){var r=[1/0,1/0,-1/0,-1/0],n=[1/0,1/0,-1/0,-1/0],o=e.canonicalID();if("Polygon"===t.type){var i=Ye(t.coordinates,n,o),a=Ze(e.geometry(),r,n,o);if(!Ne(r,n))return!1;for(var s=0,l=a;s<l.length;s+=1){if(!Je(l[s],i))return!1}}if("MultiPolygon"===t.type){var u=Ve(t.coordinates,n,o),c=Ze(e.geometry(),r,n,o);if(!Ne(r,n))return!1;for(var p=0,d=c;p<d.length;p+=1){if(!$e(d[p],u))return!1}}return!0}(e,this.geometries)}return!1},Ke.prototype.eachChild=function(){},Ke.prototype.outputDefined=function(){return!0},Ke.prototype.serialize=function(){return["within",this.geojson]};var tt=function(e,t){this.type=t.type,this.name=e,this.boundExpression=t};tt.parse=function(e,t){if(2!==e.length||"string"!=typeof e[1])return t.error("'var' expression requires exactly one string literal argument.");var r=e[1];return t.scope.has(r)?new tt(r,t.scope.get(r)):t.error('Unknown variable "'+r+'". Make sure "'+r+'" has been bound in an enclosing "let" expression before using it.',1)},tt.prototype.evaluate=function(e){return this.boundExpression.evaluate(e)},tt.prototype.eachChild=function(){},tt.prototype.outputDefined=function(){return!1},tt.prototype.serialize=function(){return["var",this.name]};var rt=function(e,t,r,n,o){void 0===t&&(t=[]),void 0===n&&(n=new K),void 0===o&&(o=[]),this.registry=e,this.path=t,this.key=t.map((function(e){return"["+e+"]"})).join(""),this.scope=n,this.errors=o,this.expectedType=r};function nt(e,t){for(var r,n,o=e.length-1,i=0,a=o,s=0;i<=a;)if(r=e[s=Math.floor((i+a)/2)],n=e[s+1],r<=t){if(s===o||t<n)return s;i=s+1}else{if(!(r>t))throw new Te("Input is not a number.");a=s-1}return 0}rt.prototype.parse=function(e,t,r,n,o){return void 0===o&&(o={}),t?this.concat(t,r,n)._parse(e,o):this._parse(e,o)},rt.prototype._parse=function(e,t){function r(e,t,r){return"assert"===r?new Ae(t,[e]):"coerce"===r?new Ie(t,[e]):e}if(null!==e&&"string"!=typeof e&&"boolean"!=typeof e&&"number"!=typeof e||(e=["literal",e]),Array.isArray(e)){if(0===e.length)return this.error('Expected an array with at least one element. If you wanted a literal array, use ["literal", []].');var o=e[0];if("string"!=typeof o)return this.error("Expression name must be a string, but found "+(void 0===o?"undefined":n(o))+' instead. If you wanted a literal array, use ["literal", [...]].',0),null;var i=this.registry[o];if(i){var a=i.parse(e,this);if(!a)return null;if(this.expectedType){var s=this.expectedType,l=a.type;if("string"!==s.kind&&"number"!==s.kind&&"boolean"!==s.kind&&"object"!==s.kind&&"array"!==s.kind||"value"!==l.kind)if("color"!==s.kind&&"formatted"!==s.kind&&"resolvedImage"!==s.kind||"value"!==l.kind&&"string"!==l.kind){if(this.checkSubtype(s,l))return null}else a=r(a,s,t.typeAnnotation||"coerce");else a=r(a,s,t.typeAnnotation||"assert")}if(!(a instanceof je)&&"resolvedImage"!==a.type.kind&&function e(t){if(t instanceof tt)return e(t.boundExpression);if(t instanceof Re&&"error"===t.name)return!1;if(t instanceof Pe)return!1;if(t instanceof Ke)return!1;var r=t instanceof Ie||t instanceof Ae,n=!0;if(t.eachChild((function(t){n=r?n&&e(t):n&&t instanceof je})),!n)return!1;return Xe(t)&&et(t,["zoom","heatmap-density","line-progress","accumulated","is-supported-script"])}(a)){var u=new Me;try{a=new je(a.type,a.evaluate(u))}catch(e){return this.error(e.message),null}}return a}return this.error('Unknown expression "'+o+'". If you wanted a literal array, use ["literal", [...]].',0)}return void 0===e?this.error("'undefined' value invalid. Use null instead."):"object"===(void 0===e?"undefined":n(e))?this.error('Bare objects invalid. Use ["literal", {...}] instead.'):this.error("Expected an array, but found "+(void 0===e?"undefined":n(e))+" instead.")},rt.prototype.concat=function(e,t,r){var n="number"==typeof e?this.path.concat(e):this.path,o=r?this.scope.concat(r):this.scope;return new rt(this.registry,n,t||null,o,this.errors)},rt.prototype.error=function(e){for(var t=[],r=arguments.length-1;r-- >0;)t[r]=arguments[r+1];var n=""+this.key+t.map((function(e){return"["+e+"]"})).join("");this.errors.push(new Z(n,e))},rt.prototype.checkSubtype=function(e,t){var r=pe(e,t);return r&&this.error(r),r};var ot=function(e,t,r){this.type=e,this.input=t,this.labels=[],this.outputs=[];for(var n=0,o=r;n<o.length;n+=1){var i=o[n],a=i[0],s=i[1];this.labels.push(a),this.outputs.push(s)}};ot.parse=function(e,t){if(e.length-1<4)return t.error("Expected at least 4 arguments, but found only "+(e.length-1)+".");if((e.length-1)%2!=0)return t.error("Expected an even number of arguments.");var r=t.parse(e[1],1,Q);if(!r)return null;var n=[],o=null;t.expectedType&&"value"!==t.expectedType.kind&&(o=t.expectedType);for(var i=1;i<e.length;i+=2){var a=1===i?-1/0:e[i],s=e[i+1],l=i,u=i+1;if("number"!=typeof a)return t.error('Input/output pairs for "step" expressions must be defined using literal numeric values (not computed expressions) for the input values.',l);if(n.length&&n[n.length-1][0]>=a)return t.error('Input/output pairs for "step" expressions must be arranged with input values in strictly ascending order.',l);var c=t.parse(s,u,o);if(!c)return null;o=o||c.type,n.push([a,c])}return new ot(o,r,n)},ot.prototype.evaluate=function(e){var t=this.labels,r=this.outputs;if(1===t.length)return r[0].evaluate(e);var n=this.input.evaluate(e);if(n<=t[0])return r[0].evaluate(e);var o=t.length;return n>=t[o-1]?r[o-1].evaluate(e):r[nt(t,n)].evaluate(e)},ot.prototype.eachChild=function(e){e(this.input);for(var t=0,r=this.outputs;t<r.length;t+=1){e(r[t])}},ot.prototype.outputDefined=function(){return this.outputs.every((function(e){return e.outputDefined()}))},ot.prototype.serialize=function(){for(var e=["step",this.input.serialize()],t=0;t<this.labels.length;t++)t>0&&e.push(this.labels[t]),e.push(this.outputs[t].serialize());return e};var it=at;function at(e,t,r,n){this.cx=3*e,this.bx=3*(r-e)-this.cx,this.ax=1-this.cx-this.bx,this.cy=3*t,this.by=3*(n-t)-this.cy,this.ay=1-this.cy-this.by,this.p1x=e,this.p1y=n,this.p2x=r,this.p2y=n}function st(e,t,r){return e*(1-r)+t*r}at.prototype.sampleCurveX=function(e){return((this.ax*e+this.bx)*e+this.cx)*e},at.prototype.sampleCurveY=function(e){return((this.ay*e+this.by)*e+this.cy)*e},at.prototype.sampleCurveDerivativeX=function(e){return(3*this.ax*e+2*this.bx)*e+this.cx},at.prototype.solveCurveX=function(e,t){var r,n,o,i,a;for(void 0===t&&(t=1e-6),o=e,a=0;a<8;a++){if(i=this.sampleCurveX(o)-e,Math.abs(i)<t)return o;var s=this.sampleCurveDerivativeX(o);if(Math.abs(s)<1e-6)break;o-=i/s}if((o=e)<(r=0))return r;if(o>(n=1))return n;for(;r<n;){if(i=this.sampleCurveX(o),Math.abs(i-e)<t)return o;e>i?r=o:n=o,o=.5*(n-r)+r}return o},at.prototype.solve=function(e,t){return this.sampleCurveY(this.solveCurveX(e,t))};var lt=Object.freeze({__proto__:null,number:st,color:function(e,t,r){return new ye(st(e.r,t.r,r),st(e.g,t.g,r),st(e.b,t.b,r),st(e.a,t.a,r))},array:function(e,t,r){return e.map((function(e,n){return st(e,t[n],r)}))}}),ut=6/29,ct=3*ut*ut,pt=Math.PI/180,dt=180/Math.PI;function ht(e){return e>.008856451679035631?Math.pow(e,1/3):e/ct+4/29}function ft(e){return e>ut?e*e*e:ct*(e-4/29)}function yt(e){return 255*(e<=.0031308?12.92*e:1.055*Math.pow(e,1/2.4)-.055)}function mt(e){return(e/=255)<=.04045?e/12.92:Math.pow((e+.055)/1.055,2.4)}function gt(e){var t=mt(e.r),r=mt(e.g),n=mt(e.b),o=ht((.4124564*t+.3575761*r+.1804375*n)/.95047),i=ht((.2126729*t+.7151522*r+.072175*n)/1);return{l:116*i-16,a:500*(o-i),b:200*(i-ht((.0193339*t+.119192*r+.9503041*n)/1.08883)),alpha:e.a}}function vt(e){var t=(e.l+16)/116,r=isNaN(e.a)?t:t+e.a/500,n=isNaN(e.b)?t:t-e.b/200;return t=1*ft(t),r=.95047*ft(r),n=1.08883*ft(n),new ye(yt(3.2404542*r-1.5371385*t-.4985314*n),yt(-.969266*r+1.8760108*t+.041556*n),yt(.0556434*r-.2040259*t+1.0572252*n),e.alpha)}function bt(e,t,r){var n=t-e;return e+r*(n>180||n<-180?n-360*Math.round(n/360):n)}var xt={forward:gt,reverse:vt,interpolate:function(e,t,r){return{l:st(e.l,t.l,r),a:st(e.a,t.a,r),b:st(e.b,t.b,r),alpha:st(e.alpha,t.alpha,r)}}},wt={forward:function(e){var t=gt(e),r=t.l,n=t.a,o=t.b,i=Math.atan2(o,n)*dt;return{h:i<0?i+360:i,c:Math.sqrt(n*n+o*o),l:r,alpha:e.a}},reverse:function(e){var t=e.h*pt,r=e.c;return vt({l:e.l,a:Math.cos(t)*r,b:Math.sin(t)*r,alpha:e.alpha})},interpolate:function(e,t,r){return{h:bt(e.h,t.h,r),c:st(e.c,t.c,r),l:st(e.l,t.l,r),alpha:st(e.alpha,t.alpha,r)}}},kt=Object.freeze({__proto__:null,lab:xt,hcl:wt}),St=function(e,t,r,n,o){this.type=e,this.operator=t,this.interpolation=r,this.input=n,this.labels=[],this.outputs=[];for(var i=0,a=o;i<a.length;i+=1){var s=a[i],l=s[0],u=s[1];this.labels.push(l),this.outputs.push(u)}};function jt(e,t,r,n){var o=n-r,i=e-r;return 0===o?0:1===t?i/o:(Math.pow(t,i)-1)/(Math.pow(t,o)-1)}St.interpolationFactor=function(e,t,r,n){var o=0;if("exponential"===e.name)o=jt(t,e.base,r,n);else if("linear"===e.name)o=jt(t,1,r,n);else if("cubic-bezier"===e.name){var i=e.controlPoints;o=new it(i[0],i[1],i[2],i[3]).solve(jt(t,1,r,n))}return o},St.parse=function(e,t){var r=e[0],n=e[1],o=e[2],i=e.slice(3);if(!Array.isArray(n)||0===n.length)return t.error("Expected an interpolation type expression.",1);if("linear"===n[0])n={name:"linear"};else if("exponential"===n[0]){var a=n[1];if("number"!=typeof a)return t.error("Exponential interpolation requires a numeric base.",1,1);n={name:"exponential",base:a}}else{if("cubic-bezier"!==n[0])return t.error("Unknown interpolation type "+String(n[0]),1,0);var s=n.slice(1);if(4!==s.length||s.some((function(e){return"number"!=typeof e||e<0||e>1})))return t.error("Cubic bezier interpolation requires four numeric arguments with values between 0 and 1.",1);n={name:"cubic-bezier",controlPoints:s}}if(e.length-1<4)return t.error("Expected at least 4 arguments, but found only "+(e.length-1)+".");if((e.length-1)%2!=0)return t.error("Expected an even number of arguments.");if(!(o=t.parse(o,2,Q)))return null;var l=[],u=null;"interpolate-hcl"===r||"interpolate-lab"===r?u=re:t.expectedType&&"value"!==t.expectedType.kind&&(u=t.expectedType);for(var c=0;c<i.length;c+=2){var p=i[c],d=i[c+1],h=c+3,f=c+4;if("number"!=typeof p)return t.error('Input/output pairs for "interpolate" expressions must be defined using literal numeric values (not computed expressions) for the input values.',h);if(l.length&&l[l.length-1][0]>=p)return t.error('Input/output pairs for "interpolate" expressions must be arranged with input values in strictly ascending order.',h);var y=t.parse(d,f,u);if(!y)return null;u=u||y.type,l.push([p,y])}return"number"===u.kind||"color"===u.kind||"array"===u.kind&&"number"===u.itemType.kind&&"number"==typeof u.N?new St(u,r,n,o,l):t.error("Type "+ue(u)+" is not interpolatable.")},St.prototype.evaluate=function(e){var t=this.labels,r=this.outputs;if(1===t.length)return r[0].evaluate(e);var n=this.input.evaluate(e);if(n<=t[0])return r[0].evaluate(e);var o=t.length;if(n>=t[o-1])return r[o-1].evaluate(e);var i=nt(t,n),a=t[i],s=t[i+1],l=St.interpolationFactor(this.interpolation,n,a,s),u=r[i].evaluate(e),c=r[i+1].evaluate(e);return"interpolate"===this.operator?lt[this.type.kind.toLowerCase()](u,c,l):"interpolate-hcl"===this.operator?wt.reverse(wt.interpolate(wt.forward(u),wt.forward(c),l)):xt.reverse(xt.interpolate(xt.forward(u),xt.forward(c),l))},St.prototype.eachChild=function(e){e(this.input);for(var t=0,r=this.outputs;t<r.length;t+=1){e(r[t])}},St.prototype.outputDefined=function(){return this.outputs.every((function(e){return e.outputDefined()}))},St.prototype.serialize=function(){var e;e="linear"===this.interpolation.name?["linear"]:"exponential"===this.interpolation.name?1===this.interpolation.base?["linear"]:["exponential",this.interpolation.base]:["cubic-bezier"].concat(this.interpolation.controlPoints);for(var t=[this.operator,e,this.input.serialize()],r=0;r<this.labels.length;r++)t.push(this.labels[r],this.outputs[r].serialize());return t};var Tt=function(e,t){this.type=e,this.args=t};Tt.parse=function(e,t){if(e.length<2)return t.error("Expectected at least one argument.");var r=null,n=t.expectedType;n&&"value"!==n.kind&&(r=n);for(var o=[],i=0,a=e.slice(1);i<a.length;i+=1){var s=a[i],l=t.parse(s,1+o.length,r,void 0,{typeAnnotation:"omit"});if(!l)return null;r=r||l.type,o.push(l)}var u=n&&o.some((function(e){return pe(n,e.type)}));return new Tt(u?oe:r,o)},Tt.prototype.evaluate=function(e){for(var t,r=null,n=0,o=0,i=this.args;o<i.length;o+=1){if(n++,(r=i[o].evaluate(e))&&r instanceof be&&!r.available&&(t||(t=r.name),r=null,n===this.args.length&&(r=t)),null!==r)break}return r},Tt.prototype.eachChild=function(e){this.args.forEach(e)},Tt.prototype.outputDefined=function(){return this.args.every((function(e){return e.outputDefined()}))},Tt.prototype.serialize=function(){var e=["coalesce"];return this.eachChild((function(t){e.push(t.serialize())})),e};var zt=function(e,t){this.type=t.type,this.bindings=[].concat(e),this.result=t};zt.prototype.evaluate=function(e){return this.result.evaluate(e)},zt.prototype.eachChild=function(e){for(var t=0,r=this.bindings;t<r.length;t+=1){e(r[t][1])}e(this.result)},zt.parse=function(e,t){if(e.length<4)return t.error("Expected at least 3 arguments, but found "+(e.length-1)+" instead.");for(var r=[],o=1;o<e.length-1;o+=2){var i=e[o];if("string"!=typeof i)return t.error("Expected string, but found "+(void 0===i?"undefined":n(i))+" instead.",o);if(/[^a-zA-Z0-9_]/.test(i))return t.error("Variable names must contain only alphanumeric characters or '_'.",o);var a=t.parse(e[o+1],o+1);if(!a)return null;r.push([i,a])}var s=t.parse(e[e.length-1],e.length-1,t.expectedType,r);return s?new zt(r,s):null},zt.prototype.outputDefined=function(){return this.result.outputDefined()},zt.prototype.serialize=function(){for(var e=["let"],t=0,r=this.bindings;t<r.length;t+=1){var n=r[t],o=n[0],i=n[1];e.push(o,i.serialize())}return e.push(this.result.serialize()),e};var At=function(e,t,r){this.type=e,this.index=t,this.input=r};At.parse=function(e,t){if(3!==e.length)return t.error("Expected 2 arguments, but found "+(e.length-1)+" instead.");var r=t.parse(e[1],1,Q),n=t.parse(e[2],2,le(t.expectedType||oe));if(!r||!n)return null;var o=n.type;return new At(o.itemType,r,n)},At.prototype.evaluate=function(e){var t=this.index.evaluate(e),r=this.input.evaluate(e);if(t<0)throw new Te("Array index out of bounds: "+t+" < 0.");if(t>=r.length)throw new Te("Array index out of bounds: "+t+" > "+(r.length-1)+".");if(t!==Math.floor(t))throw new Te("Array index must be an integer, but found "+t+" instead.");return r[t]},At.prototype.eachChild=function(e){e(this.index),e(this.input)},At.prototype.outputDefined=function(){return!1},At.prototype.serialize=function(){return["at",this.index.serialize(),this.input.serialize()]};var _t=function(e,t){this.type=te,this.needle=e,this.haystack=t};_t.parse=function(e,t){if(3!==e.length)return t.error("Expected 2 arguments, but found "+(e.length-1)+" instead.");var r=t.parse(e[1],1,oe),n=t.parse(e[2],2,oe);return r&&n?de(r.type,[te,ee,Q,X,oe])?new _t(r,n):t.error("Expected first argument to be of type boolean, string, number or null, but found "+ue(r.type)+" instead"):null},_t.prototype.evaluate=function(e){var t=this.needle.evaluate(e),r=this.haystack.evaluate(e);if(!r)return!1;if(!he(t,["boolean","string","number","null"]))throw new Te("Expected first argument to be of type boolean, string, number or null, but found "+ue(ke(t))+" instead.");if(!he(r,["string","array"]))throw new Te("Expected second argument to be of type array or string, but found "+ue(ke(r))+" instead.");return r.indexOf(t)>=0},_t.prototype.eachChild=function(e){e(this.needle),e(this.haystack)},_t.prototype.outputDefined=function(){return!0},_t.prototype.serialize=function(){return["in",this.needle.serialize(),this.haystack.serialize()]};var Ot=function(e,t,r){this.type=Q,this.needle=e,this.haystack=t,this.fromIndex=r};Ot.parse=function(e,t){if(e.length<=2||e.length>=5)return t.error("Expected 3 or 4 arguments, but found "+(e.length-1)+" instead.");var r=t.parse(e[1],1,oe),n=t.parse(e[2],2,oe);if(!r||!n)return null;if(!de(r.type,[te,ee,Q,X,oe]))return t.error("Expected first argument to be of type boolean, string, number or null, but found "+ue(r.type)+" instead");if(4===e.length){var o=t.parse(e[3],3,Q);return o?new Ot(r,n,o):null}return new Ot(r,n)},Ot.prototype.evaluate=function(e){var t=this.needle.evaluate(e),r=this.haystack.evaluate(e);if(!he(t,["boolean","string","number","null"]))throw new Te("Expected first argument to be of type boolean, string, number or null, but found "+ue(ke(t))+" instead.");if(!he(r,["string","array"]))throw new Te("Expected second argument to be of type array or string, but found "+ue(ke(r))+" instead.");if(this.fromIndex){var n=this.fromIndex.evaluate(e);return r.indexOf(t,n)}return r.indexOf(t)},Ot.prototype.eachChild=function(e){e(this.needle),e(this.haystack),this.fromIndex&&e(this.fromIndex)},Ot.prototype.outputDefined=function(){return!1},Ot.prototype.serialize=function(){if(null!=this.fromIndex&&void 0!==this.fromIndex){var e=this.fromIndex.serialize();return["index-of",this.needle.serialize(),this.haystack.serialize(),e]}return["index-of",this.needle.serialize(),this.haystack.serialize()]};var Ct=function(e,t,r,n,o,i){this.inputType=e,this.type=t,this.input=r,this.cases=n,this.outputs=o,this.otherwise=i};Ct.parse=function(e,t){if(e.length<5)return t.error("Expected at least 4 arguments, but found only "+(e.length-1)+".");if(e.length%2!=1)return t.error("Expected an even number of arguments.");var r,n;t.expectedType&&"value"!==t.expectedType.kind&&(n=t.expectedType);for(var o={},i=[],a=2;a<e.length-1;a+=2){var s=e[a],l=e[a+1];Array.isArray(s)||(s=[s]);var u=t.concat(a);if(0===s.length)return u.error("Expected at least one branch label.");for(var c=0,p=s;c<p.length;c+=1){var d=p[c];if("number"!=typeof d&&"string"!=typeof d)return u.error("Branch labels must be numbers or strings.");if("number"==typeof d&&Math.abs(d)>Number.MAX_SAFE_INTEGER)return u.error("Branch labels must be integers no larger than "+Number.MAX_SAFE_INTEGER+".");if("number"==typeof d&&Math.floor(d)!==d)return u.error("Numeric branch labels must be integer values.");if(r){if(u.checkSubtype(r,ke(d)))return null}else r=ke(d);if(void 0!==o[String(d)])return u.error("Branch labels must be unique.");o[String(d)]=i.length}var h=t.parse(l,a,n);if(!h)return null;n=n||h.type,i.push(h)}var f=t.parse(e[1],1,oe);if(!f)return null;var y=t.parse(e[e.length-1],e.length-1,n);return y?"value"!==f.type.kind&&t.concat(1).checkSubtype(r,f.type)?null:new Ct(r,n,f,o,i,y):null},Ct.prototype.evaluate=function(e){var t=this.input.evaluate(e);return(ke(t)===this.inputType&&this.outputs[this.cases[t]]||this.otherwise).evaluate(e)},Ct.prototype.eachChild=function(e){e(this.input),this.outputs.forEach(e),e(this.otherwise)},Ct.prototype.outputDefined=function(){return this.outputs.every((function(e){return e.outputDefined()}))&&this.otherwise.outputDefined()},Ct.prototype.serialize=function(){for(var e=this,t=["match",this.input.serialize()],r=[],n={},o=0,i=Object.keys(this.cases).sort();o<i.length;o+=1){var a=i[o];void 0===(p=n[this.cases[a]])?(n[this.cases[a]]=r.length,r.push([this.cases[a],[a]])):r[p][1].push(a)}for(var s=function(t){return"number"===e.inputType.kind?Number(t):t},l=0,u=r;l<u.length;l+=1){var c=u[l],p=c[0],d=c[1];1===d.length?t.push(s(d[0])):t.push(d.map(s)),t.push(this.outputs[outputIndex$1].serialize())}return t.push(this.otherwise.serialize()),t};var It=function(e,t,r){this.type=e,this.branches=t,this.otherwise=r};It.parse=function(e,t){if(e.length<4)return t.error("Expected at least 3 arguments, but found only "+(e.length-1)+".");if(e.length%2!=0)return t.error("Expected an odd number of arguments.");var r;t.expectedType&&"value"!==t.expectedType.kind&&(r=t.expectedType);for(var n=[],o=1;o<e.length-1;o+=2){var i=t.parse(e[o],o,te);if(!i)return null;var a=t.parse(e[o+1],o+1,r);if(!a)return null;n.push([i,a]),r=r||a.type}var s=t.parse(e[e.length-1],e.length-1,r);return s?new It(r,n,s):null},It.prototype.evaluate=function(e){for(var t=0,r=this.branches;t<r.length;t+=1){var n=r[t],o=n[0],i=n[1];if(o.evaluate(e))return i.evaluate(e)}return this.otherwise.evaluate(e)},It.prototype.eachChild=function(e){for(var t=0,r=this.branches;t<r.length;t+=1){var n=r[t],o=n[0],i=n[1];e(o),e(i)}e(this.otherwise)},It.prototype.outputDefined=function(){return this.branches.every((function(e){e[0];return e[1].outputDefined()}))&&this.otherwise.outputDefined()},It.prototype.serialize=function(){var e=["case"];return this.eachChild((function(t){e.push(t.serialize())})),e};var Et=function(e,t,r,n){this.type=e,this.input=t,this.beginIndex=r,this.endIndex=n};function Mt(e,t){return"=="===e||"!="===e?"boolean"===t.kind||"string"===t.kind||"number"===t.kind||"null"===t.kind||"value"===t.kind:"string"===t.kind||"number"===t.kind||"value"===t.kind}function Rt(e,t,r,n){return 0===n.compare(t,r)}function Pt(e,t,r){var n="=="!==e&&"!="!==e;return function(){function o(e,t,r){this.type=te,this.lhs=e,this.rhs=t,this.collator=r,this.hasUntypedArgument="value"===e.type.kind||"value"===t.type.kind}return o.parse=function(e,t){if(3!==e.length&&4!==e.length)return t.error("Expected two or three arguments.");var r=e[0],i=t.parse(e[1],1,oe);if(!i)return null;if(!Mt(r,i.type))return t.concat(1).error('"'+r+"\" comparisons are not supported for type '"+ue(i.type)+"'.");var a=t.parse(e[2],2,oe);if(!a)return null;if(!Mt(r,a.type))return t.concat(2).error('"'+r+"\" comparisons are not supported for type '"+ue(a.type)+"'.");if(i.type.kind!==a.type.kind&&"value"!==i.type.kind&&"value"!==a.type.kind)return t.error("Cannot compare types '"+ue(i.type)+"' and '"+ue(a.type)+"'.");n&&("value"===i.type.kind&&"value"!==a.type.kind?i=new Ae(a.type,[i]):"value"!==i.type.kind&&"value"===a.type.kind&&(a=new Ae(i.type,[a])));var s=null;if(4===e.length){if("string"!==i.type.kind&&"string"!==a.type.kind&&"value"!==i.type.kind&&"value"!==a.type.kind)return t.error("Cannot use collator to compare non-string types.");if(!(s=t.parse(e[3],3,ie)))return null}return new o(i,a,s)},o.prototype.evaluate=function(o){var i=this.lhs.evaluate(o),a=this.rhs.evaluate(o);if(n&&this.hasUntypedArgument){var s=ke(i),l=ke(a);if(s.kind!==l.kind||"string"!==s.kind&&"number"!==s.kind)throw new Te('Expected arguments for "'+e+'" to be (string, string) or (number, number), but found ('+s.kind+", "+l.kind+") instead.")}if(this.collator&&!n&&this.hasUntypedArgument){var u=ke(i),c=ke(a);if("string"!==u.kind||"string"!==c.kind)return t(o,i,a)}return this.collator?r(o,i,a,this.collator.evaluate(o)):t(o,i,a)},o.prototype.eachChild=function(e){e(this.lhs),e(this.rhs),this.collator&&e(this.collator)},o.prototype.outputDefined=function(){return!0},o.prototype.serialize=function(){var t=[e];return this.eachChild((function(e){t.push(e.serialize())})),t},o}()}Et.parse=function(e,t){if(e.length<=2||e.length>=5)return t.error("Expected 3 or 4 arguments, but found "+(e.length-1)+" instead.");var r=t.parse(e[1],1,oe),n=t.parse(e[2],2,Q);if(!r||!n)return null;if(!de(r.type,[le(oe),ee,oe]))return t.error("Expected first argument to be of type array or string, but found "+ue(r.type)+" instead");if(4===e.length){var o=t.parse(e[3],3,Q);return o?new Et(r.type,r,n,o):null}return new Et(r.type,r,n)},Et.prototype.evaluate=function(e){var t=this.input.evaluate(e),r=this.beginIndex.evaluate(e);if(!he(t,["string","array"]))throw new Te("Expected first argument to be of type array or string, but found "+ue(ke(t))+" instead.");if(this.endIndex){var n=this.endIndex.evaluate(e);return t.slice(r,n)}return t.slice(r)},Et.prototype.eachChild=function(e){e(this.input),e(this.beginIndex),this.endIndex&&e(this.endIndex)},Et.prototype.outputDefined=function(){return!1},Et.prototype.serialize=function(){if(null!=this.endIndex&&void 0!==this.endIndex){var e=this.endIndex.serialize();return["slice",this.input.serialize(),this.beginIndex.serialize(),e]}return["slice",this.input.serialize(),this.beginIndex.serialize()]};var qt=Pt("==",(function(e,t,r){return t===r}),Rt),Nt=Pt("!=",(function(e,t,r){return t!==r}),(function(e,t,r,n){return!Rt(0,t,r,n)})),Ft=Pt("<",(function(e,t,r){return t<r}),(function(e,t,r,n){return n.compare(t,r)<0})),Lt=Pt(">",(function(e,t,r){return t>r}),(function(e,t,r,n){return n.compare(t,r)>0})),Dt=Pt("<=",(function(e,t,r){return t<=r}),(function(e,t,r,n){return n.compare(t,r)<=0})),Bt=Pt(">=",(function(e,t,r){return t>=r}),(function(e,t,r,n){return n.compare(t,r)>=0})),Ut=function(e,t,r,n,o){this.type=ee,this.number=e,this.locale=t,this.currency=r,this.minFractionDigits=n,this.maxFractionDigits=o};Ut.parse=function(e,t){if(3!==e.length)return t.error("Expected two arguments.");var r=t.parse(e[1],1,Q);if(!r)return null;var o=e[2];if("object"!==(void 0===o?"undefined":n(o))||Array.isArray(o))return t.error("NumberFormat options argument must be an object.");var i=null;if(o.locale&&!(i=t.parse(o.locale,1,ee)))return null;var a=null;if(o.currency&&!(a=t.parse(o.currency,1,ee)))return null;var s=null;if(o["min-fraction-digits"]&&!(s=t.parse(o["min-fraction-digits"],1,Q)))return null;var l=null;return o["max-fraction-digits"]&&!(l=t.parse(o["max-fraction-digits"],1,Q))?null:new Ut(r,i,a,s,l)},Ut.prototype.evaluate=function(e){return new Intl.NumberFormat(this.locale?this.locale.evaluate(e):[],{style:this.currency?"currency":"decimal",currency:this.currency?this.currency.evaluate(e):void 0,minimumFractionDigits:this.minFractionDigits?this.minFractionDigits.evaluate(e):void 0,maximumFractionDigits:this.maxFractionDigits?this.maxFractionDigits.evaluate(e):void 0}).format(this.number.evaluate(e))},Ut.prototype.eachChild=function(e){e(this.number),this.locale&&e(this.locale),this.currency&&e(this.currency),this.minFractionDigits&&e(this.minFractionDigits),this.maxFractionDigits&&e(this.maxFractionDigits)},Ut.prototype.outputDefined=function(){return!1},Ut.prototype.serialize=function(){var e={};return this.locale&&(e.locale=this.locale.serialize()),this.currency&&(e.currency=this.currency.serialize()),this.minFractionDigits&&(e["min-fraction-digits"]=this.minFractionDigits.serialize()),this.maxFractionDigits&&(e["max-fraction-digits"]=this.maxFractionDigits.serialize()),["number-format",this.number.serialize(),e]};var Gt=function(e){this.type=Q,this.input=e};Gt.parse=function(e,t){if(2!==e.length)return t.error("Expected 1 argument, but found "+(e.length-1)+" instead.");var r=t.parse(e[1],1);return r?"array"!==r.type.kind&&"string"!==r.type.kind&&"value"!==r.type.kind?t.error("Expected argument of type string or array, but found "+ue(r.type)+" instead."):new Gt(r):null},Gt.prototype.evaluate=function(e){var t=this.input.evaluate(e);if("string"==typeof t)return t.length;if(Array.isArray(t))return t.length;throw new Te("Expected value to be of type string or array, but found "+ue(ke(t))+" instead.")},Gt.prototype.eachChild=function(e){e(this.input)},Gt.prototype.outputDefined=function(){return!1},Gt.prototype.serialize=function(){var e=["length"];return this.eachChild((function(t){e.push(t.serialize())})),e};var Jt={"==":qt,"!=":Nt,">":Lt,"<":Ft,">=":Bt,"<=":Dt,array:Ae,at:At,boolean:Ae,case:It,coalesce:Tt,collator:Pe,format:_e,image:Oe,in:_t,"index-of":Ot,interpolate:St,"interpolate-hcl":St,"interpolate-lab":St,length:Gt,let:zt,literal:je,match:Ct,number:Ae,"number-format":Ut,object:Ae,slice:Et,step:ot,string:Ae,"to-boolean":Ie,"to-color":Ie,"to-number":Ie,"to-string":Ie,var:tt,within:Ke};function $t(e,t){var r=t[0],n=t[1],o=t[2],i=t[3];r=r.evaluate(e),n=n.evaluate(e),o=o.evaluate(e);var a=i?i.evaluate(e):1,s=xe(r,n,o,a);if(s)throw new Te(s);return new ye(r/255*a,n/255*a,o/255*a,a)}function Yt(e,t){return e in t}function Vt(e,t){var r=t[e];return void 0===r?null:r}function Wt(e){return{type:e}}function Ht(e){return{result:"success",value:e}}function Zt(e){return{result:"error",value:e}}function Kt(e){return"data-driven"===e["property-type"]||"cross-faded-data-driven"===e["property-type"]}function Xt(e){return!!e.expression&&e.expression.parameters.indexOf("zoom")>-1}function Qt(e){return!!e.expression&&e.expression.interpolated}function er(e){return e instanceof Number?"number":e instanceof String?"string":e instanceof Boolean?"boolean":Array.isArray(e)?"array":null===e?"null":void 0===e?"undefined":n(e)}function tr(e){return"object"===(void 0===e?"undefined":n(e))&&null!==e&&!Array.isArray(e)}function rr(e){return e}function nr(e,t){var r,o,i,a="color"===t.type,s=e.stops&&"object"===n(e.stops[0][0]),l=s||void 0!==e.property,u=s||!l,c=e.type||(Qt(t)?"exponential":"interval");if(a&&((e=H({},e)).stops&&(e.stops=e.stops.map((function(e){return[e[0],ye.parse(e[1])]}))),e.default?e.default=ye.parse(e.default):e.default=ye.parse(t.default)),e.colorSpace&&"rgb"!==e.colorSpace&&!kt[e.colorSpace])throw new Error("Unknown color space: "+e.colorSpace);if("exponential"===c)r=sr;else if("interval"===c)r=ar;else if("categorical"===c){r=ir,o=Object.create(null);for(var p=0,d=e.stops;p<d.length;p+=1){var h=d[p];o[h[0]]=h[1]}i=n(e.stops[0][0])}else{if("identity"!==c)throw new Error('Unknown function type "'+c+'"');r=lr}if(s){for(var f={},y=[],m=0;m<e.stops.length;m++){var g=e.stops[m],v=g[0].zoom;void 0===f[v]&&(f[v]={zoom:v,type:e.type,property:e.property,default:e.default,stops:[]},y.push(v)),f[v].stops.push([g[0].value,g[1]])}for(var b=[],x=0,w=y;x<w.length;x+=1){var k=w[x];b.push([f[k].zoom,nr(f[k],t)])}var S={name:"linear"};return{kind:"composite",interpolationType:S,interpolationFactor:St.interpolationFactor.bind(void 0,S),zoomStops:b.map((function(e){return e[0]})),evaluate:function(r,n){var o=r.zoom;return sr({stops:b,base:e.base},t,o).evaluate(o,n)}}}if(u){var j="exponential"===c?{name:"exponential",base:void 0!==e.base?e.base:1}:null;return{kind:"camera",interpolationType:j,interpolationFactor:St.interpolationFactor.bind(void 0,j),zoomStops:e.stops.map((function(e){return e[0]})),evaluate:function(n){var a=n.zoom;return r(e,t,a,o,i)}}}return{kind:"source",evaluate:function(n,a){var s=a&&a.properties?a.properties[e.property]:void 0;return void 0===s?or(e.default,t.default):r(e,t,s,o,i)}}}function or(e,t,r){return void 0!==e?e:void 0!==t?t:void 0!==r?r:void 0}function ir(e,t,r,o,i){return or((void 0===r?"undefined":n(r))===i?o[r]:void 0,e.default,t.default)}function ar(e,t,r){if("number"!==er(r))return or(e.default,t.default);var n=e.stops.length;if(1===n)return e.stops[0][1];if(r<=e.stops[0][0])return e.stops[0][1];if(r>=e.stops[n-1][0])return e.stops[n-1][1];var o=nt(e.stops.map((function(e){return e[0]})),r);return e.stops[o][1]}function sr(e,t,r){var n=void 0!==e.base?e.base:1;if("number"!==er(r))return or(e.default,t.default);var o=e.stops.length;if(1===o)return e.stops[0][1];if(r<=e.stops[0][0])return e.stops[0][1];if(r>=e.stops[o-1][0])return e.stops[o-1][1];var i=nt(e.stops.map((function(e){return e[0]})),r),a=function(e,t,r,n){var o=n-r,i=e-r;return 0===o?0:1===t?i/o:(Math.pow(t,i)-1)/(Math.pow(t,o)-1)}(r,n,e.stops[i][0],e.stops[i+1][0]),s=e.stops[i][1],l=e.stops[i+1][1],u=lt[t.type]||rr;if(e.colorSpace&&"rgb"!==e.colorSpace){var c=kt[e.colorSpace];u=function(e,t){return c.reverse(c.interpolate(c.forward(e),c.forward(t),a))}}return"function"==typeof s.evaluate?{evaluate:function(){for(var e=[],t=arguments.length;t--;)e[t]=arguments[t];var r=s.evaluate.apply(void 0,e),n=l.evaluate.apply(void 0,e);if(void 0!==r&&void 0!==n)return u(r,n,a)}}:u(s,l,a)}function lr(e,t,r){return"color"===t.type?r=ye.parse(r):"formatted"===t.type?r=ve.fromString(r.toString()):"resolvedImage"===t.type?r=be.fromString(r.toString()):er(r)===t.type||"enum"===t.type&&t.values[r]||(r=void 0),or(r,e.default,t.default)}Re.register(Jt,{error:[{kind:"error"},[ee],function(e,t){var r=t[0];throw new Te(r.evaluate(e))}],typeof:[ee,[oe],function(e,t){return ue(ke(t[0].evaluate(e)))}],"to-rgba":[le(Q,4),[re],function(e,t){return t[0].evaluate(e).toArray()}],rgb:[re,[Q,Q,Q],$t],rgba:[re,[Q,Q,Q,Q],$t],has:{type:te,overloads:[[[ee],function(e,t){return Yt(t[0].evaluate(e),e.properties())}],[[ee,ne],function(e,t){var r=t[0],n=t[1];return Yt(r.evaluate(e),n.evaluate(e))}]]},get:{type:oe,overloads:[[[ee],function(e,t){return Vt(t[0].evaluate(e),e.properties())}],[[ee,ne],function(e,t){var r=t[0],n=t[1];return Vt(r.evaluate(e),n.evaluate(e))}]]},"feature-state":[oe,[ee],function(e,t){return Vt(t[0].evaluate(e),e.featureState||{})}],properties:[ne,[],function(e){return e.properties()}],"geometry-type":[ee,[],function(e){return e.geometryType()}],id:[oe,[],function(e){return e.id()}],zoom:[Q,[],function(e){return e.globals.zoom}],"heatmap-density":[Q,[],function(e){return e.globals.heatmapDensity||0}],"line-progress":[Q,[],function(e){return e.globals.lineProgress||0}],accumulated:[oe,[],function(e){return void 0===e.globals.accumulated?null:e.globals.accumulated}],"+":[Q,Wt(Q),function(e,t){for(var r=0,n=0,o=t;n<o.length;n+=1){r+=o[n].evaluate(e)}return r}],"*":[Q,Wt(Q),function(e,t){for(var r=1,n=0,o=t;n<o.length;n+=1){r*=o[n].evaluate(e)}return r}],"-":{type:Q,overloads:[[[Q,Q],function(e,t){var r=t[0],n=t[1];return r.evaluate(e)-n.evaluate(e)}],[[Q],function(e,t){return-t[0].evaluate(e)}]]},"/":[Q,[Q,Q],function(e,t){var r=t[0],n=t[1];return r.evaluate(e)/n.evaluate(e)}],"%":[Q,[Q,Q],function(e,t){var r=t[0],n=t[1];return r.evaluate(e)%n.evaluate(e)}],ln2:[Q,[],function(){return Math.LN2}],pi:[Q,[],function(){return Math.PI}],e:[Q,[],function(){return Math.E}],"^":[Q,[Q,Q],function(e,t){var r=t[0],n=t[1];return Math.pow(r.evaluate(e),n.evaluate(e))}],sqrt:[Q,[Q],function(e,t){var r=t[0];return Math.sqrt(r.evaluate(e))}],log10:[Q,[Q],function(e,t){var r=t[0];return Math.log(r.evaluate(e))/Math.LN10}],ln:[Q,[Q],function(e,t){var r=t[0];return Math.log(r.evaluate(e))}],log2:[Q,[Q],function(e,t){var r=t[0];return Math.log(r.evaluate(e))/Math.LN2}],sin:[Q,[Q],function(e,t){var r=t[0];return Math.sin(r.evaluate(e))}],cos:[Q,[Q],function(e,t){var r=t[0];return Math.cos(r.evaluate(e))}],tan:[Q,[Q],function(e,t){var r=t[0];return Math.tan(r.evaluate(e))}],asin:[Q,[Q],function(e,t){var r=t[0];return Math.asin(r.evaluate(e))}],acos:[Q,[Q],function(e,t){var r=t[0];return Math.acos(r.evaluate(e))}],atan:[Q,[Q],function(e,t){var r=t[0];return Math.atan(r.evaluate(e))}],min:[Q,Wt(Q),function(e,t){return Math.min.apply(Math,t.map((function(t){return t.evaluate(e)})))}],max:[Q,Wt(Q),function(e,t){return Math.max.apply(Math,t.map((function(t){return t.evaluate(e)})))}],abs:[Q,[Q],function(e,t){var r=t[0];return Math.abs(r.evaluate(e))}],round:[Q,[Q],function(e,t){var r=t[0].evaluate(e);return r<0?-Math.round(-r):Math.round(r)}],floor:[Q,[Q],function(e,t){var r=t[0];return Math.floor(r.evaluate(e))}],ceil:[Q,[Q],function(e,t){var r=t[0];return Math.ceil(r.evaluate(e))}],"filter-==":[te,[ee,oe],function(e,t){var r=t[0],n=t[1];return e.properties()[r.value]===n.value}],"filter-id-==":[te,[oe],function(e,t){var r=t[0];return e.id()===r.value}],"filter-type-==":[te,[ee],function(e,t){var r=t[0];return e.geometryType()===r.value}],"filter-<":[te,[ee,oe],function(e,t){var r=t[0],o=t[1],i=e.properties()[r.value],a=o.value;return(void 0===i?"undefined":n(i))===(void 0===a?"undefined":n(a))&&i<a}],"filter-id-<":[te,[oe],function(e,t){var r=t[0],o=e.id(),i=r.value;return(void 0===o?"undefined":n(o))===(void 0===i?"undefined":n(i))&&o<i}],"filter->":[te,[ee,oe],function(e,t){var r=t[0],o=t[1],i=e.properties()[r.value],a=o.value;return(void 0===i?"undefined":n(i))===(void 0===a?"undefined":n(a))&&i>a}],"filter-id->":[te,[oe],function(e,t){var r=t[0],o=e.id(),i=r.value;return(void 0===o?"undefined":n(o))===(void 0===i?"undefined":n(i))&&o>i}],"filter-<=":[te,[ee,oe],function(e,t){var r=t[0],o=t[1],i=e.properties()[r.value],a=o.value;return(void 0===i?"undefined":n(i))===(void 0===a?"undefined":n(a))&&i<=a}],"filter-id-<=":[te,[oe],function(e,t){var r=t[0],o=e.id(),i=r.value;return(void 0===o?"undefined":n(o))===(void 0===i?"undefined":n(i))&&o<=i}],"filter->=":[te,[ee,oe],function(e,t){var r=t[0],o=t[1],i=e.properties()[r.value],a=o.value;return(void 0===i?"undefined":n(i))===(void 0===a?"undefined":n(a))&&i>=a}],"filter-id->=":[te,[oe],function(e,t){var r=t[0],o=e.id(),i=r.value;return(void 0===o?"undefined":n(o))===(void 0===i?"undefined":n(i))&&o>=i}],"filter-has":[te,[oe],function(e,t){return t[0].value in e.properties()}],"filter-has-id":[te,[],function(e){return null!==e.id()&&void 0!==e.id()}],"filter-type-in":[te,[le(ee)],function(e,t){return t[0].value.indexOf(e.geometryType())>=0}],"filter-id-in":[te,[le(oe)],function(e,t){return t[0].value.indexOf(e.id())>=0}],"filter-in-small":[te,[ee,le(oe)],function(e,t){var r=t[0];return t[1].value.indexOf(e.properties()[r.value])>=0}],"filter-in-large":[te,[ee,le(oe)],function(e,t){var r=t[0],n=t[1];return function(e,t,r,n){for(;r<=n;){var o=r+n>>1;if(t[o]===e)return!0;t[o]>e?n=o-1:r=o+1}return!1}(e.properties()[r.value],n.value,0,n.value.length-1)}],all:{type:te,overloads:[[[te,te],function(e,t){var r=t[0],n=t[1];return r.evaluate(e)&&n.evaluate(e)}],[Wt(te),function(e,t){for(var r=0,n=t;r<n.length;r+=1){if(!n[r].evaluate(e))return!1}return!0}]]},any:{type:te,overloads:[[[te,te],function(e,t){var r=t[0],n=t[1];return r.evaluate(e)||n.evaluate(e)}],[Wt(te),function(e,t){for(var r=0,n=t;r<n.length;r+=1){if(n[r].evaluate(e))return!0}return!1}]]},"!":[te,[te],function(e,t){return!t[0].evaluate(e)}],"is-supported-script":[te,[ee],function(e,t){var r=t[0],n=e.globals&&e.globals.isSupportedScript;return!n||n(r.evaluate(e))}],upcase:[ee,[ee],function(e,t){return t[0].evaluate(e).toUpperCase()}],downcase:[ee,[ee],function(e,t){return t[0].evaluate(e).toLowerCase()}],concat:[ee,Wt(oe),function(e,t){return t.map((function(t){return Se(t.evaluate(e))})).join("")}],"resolved-locale":[ee,[ie],function(e,t){return t[0].evaluate(e).resolvedLocale()}]});var ur=function(e,t){var r;this.expression=e,this._warningHistory={},this._evaluator=new Me,this._defaultValue=t?"color"===(r=t).type&&tr(r.default)?new ye(0,0,0,0):"color"===r.type?ye.parse(r.default)||null:void 0===r.default?null:r.default:null,this._enumValues=t&&"enum"===t.type?t.values:null};function cr(e){return Array.isArray(e)&&e.length>0&&"string"==typeof e[0]&&e[0]in Jt}function pr(e,t){var r=new rt(Jt,[],t?function(e){var t={color:re,string:ee,number:Q,enum:ee,boolean:te,formatted:ae,resolvedImage:se};if("array"===e.type)return le(t[e.value]||oe,e.length);return t[e.type]}(t):void 0),n=r.parse(e,void 0,void 0,void 0,t&&"string"===t.type?{typeAnnotation:"coerce"}:void 0);return n?Ht(new ur(n,t)):Zt(r.errors)}ur.prototype.evaluateWithoutErrorHandling=function(e,t,r,n,o,i){return this._evaluator.globals=e,this._evaluator.feature=t,this._evaluator.featureState=r,this._evaluator.canonical=n,this._evaluator.availableImages=o||null,this._evaluator.formattedSection=i,this.expression.evaluate(this._evaluator)},ur.prototype.evaluate=function(e,t,r,n,o,i){this._evaluator.globals=e,this._evaluator.feature=t||null,this._evaluator.featureState=r||null,this._evaluator.canonical=n,this._evaluator.availableImages=o||null,this._evaluator.formattedSection=i||null;try{var a=this.expression.evaluate(this._evaluator);if(null==a||"number"==typeof a&&a!=a)return this._defaultValue;if(this._enumValues&&!(a in this._enumValues))throw new Te("Expected value to be one of "+Object.keys(this._enumValues).map((function(e){return JSON.stringify(e)})).join(", ")+", but found "+JSON.stringify(a)+" instead.");return a}catch(e){return this._warningHistory[e.message]||(this._warningHistory[e.message]=!0,"undefined"!=typeof console&&console.warn(e.message)),this._defaultValue}};var dr=function(e,t){this.kind=e,this._styleExpression=t,this.isStateDependent="constant"!==e&&!Qe(t.expression)};dr.prototype.evaluateWithoutErrorHandling=function(e,t,r,n,o,i){return this._styleExpression.evaluateWithoutErrorHandling(e,t,r,n,o,i)},dr.prototype.evaluate=function(e,t,r,n,o,i){return this._styleExpression.evaluate(e,t,r,n,o,i)};var hr=function(e,t,r,n){this.kind=e,this.zoomStops=r,this._styleExpression=t,this.isStateDependent="camera"!==e&&!Qe(t.expression),this.interpolationType=n};function fr(e,t){if("error"===(e=pr(e,t)).result)return e;var r=e.value.expression,n=Xe(r);if(!n&&!Kt(t))return Zt([new Z("","data expressions not supported")]);var o=et(r,["zoom"]);if(!o&&!Xt(t))return Zt([new Z("","zoom expressions not supported")]);var i=function e(t){var r=null;if(t instanceof zt)r=e(t.result);else if(t instanceof Tt)for(var n=0,o=t.args;n<o.length;n+=1){var i=o[n];if(r=e(i))break}else(t instanceof ot||t instanceof St)&&t.input instanceof Re&&"zoom"===t.input.name&&(r=t);if(r instanceof Z)return r;return t.eachChild((function(t){var n=e(t);n instanceof Z?r=n:!r&&n?r=new Z("",'"zoom" expression may only be used as input to a top-level "step" or "interpolate" expression.'):r&&n&&r!==n&&(r=new Z("",'Only one zoom-based "step" or "interpolate" subexpression may be used in an expression.'))})),r}(r);if(!i&&!o)return Zt([new Z("",'"zoom" expression may only be used as input to a top-level "step" or "interpolate" expression.')]);if(i instanceof Z)return Zt([i]);if(i instanceof St&&!Qt(t))return Zt([new Z("",'"interpolate" expressions cannot be used with this property')]);if(!i)return Ht(new dr(n?"constant":"source",e.value));var a=i instanceof St?i.interpolation:void 0;return Ht(new hr(n?"camera":"composite",e.value,i.labels,a))}hr.prototype.evaluateWithoutErrorHandling=function(e,t,r,n,o,i){return this._styleExpression.evaluateWithoutErrorHandling(e,t,r,n,o,i)},hr.prototype.evaluate=function(e,t,r,n,o,i){return this._styleExpression.evaluate(e,t,r,n,o,i)},hr.prototype.interpolationFactor=function(e,t,r){return this.interpolationType?St.interpolationFactor(this.interpolationType,e,t,r):0};var yr=function(e,t){this._parameters=e,this._specification=t,H(this,nr(this._parameters,this._specification))};function mr(e){return"object"===(void 0===e?"undefined":n(e))?["literal",e]:e}function gr(e,t){var r=e.stops;if(!r)return function(e,t){var r=["get",e.property];if(void 0===e.default)return"string"===t.type?["string",r]:r;if("enum"===t.type)return["match",r,Object.keys(t.values),r,e.default];var n=["color"===t.type?"to-color":t.type,r,mr(e.default)];return"array"===t.type&&n.splice(1,0,t.value,t.length||null),n}(e,t);var o=r&&"object"===n(r[0][0]),i=o||void 0!==e.property,a=o||!i;return r=r.map((function(e){return!i&&t.tokens&&"string"==typeof e[1]?[e[0],jr(e[1])]:[e[0],mr(e[1])]})),o?function(e,t,r){for(var n={},o={},i=[],a=0;a<r.length;a++){var s=r[a],l=s[0].zoom;void 0===n[l]&&(n[l]={zoom:l,type:e.type,property:e.property,default:e.default},o[l]=[],i.push(l)),o[l].push([s[0].value,s[1]])}if("exponential"===Sr({},t)){for(var u=[vr(e),["linear"],["zoom"]],c=0,p=i;c<p.length;c+=1){var d=p[c],h=xr(n[d],t,o[d]);kr(u,d,h,!1)}return u}for(var f=["step",["zoom"]],y=0,m=i;y<m.length;y+=1){var g=m[y],v=xr(n[g],t,o[g]);kr(f,g,v,!0)}return wr(f),f}(e,t,r):a?function(e,t,r,n){void 0===n&&(n=["zoom"]);var o,i=Sr(e,t),a=!1;if("interval"===i)o=["step",n],a=!0;else{if("exponential"!==i)throw new Error('Unknown zoom function type "'+i+'"');var s=void 0!==e.base?e.base:1;o=[vr(e),1===s?["linear"]:["exponential",s],n]}for(var l=0,u=r;l<u.length;l+=1){var c=u[l];kr(o,c[0],c[1],a)}return wr(o),o}(e,t,r):xr(e,t,r)}function vr(e){switch(e.colorSpace){case"hcl":return"interpolate-hcl";case"lab":return"interpolate-lab";default:return"interpolate"}}function br(e,t){return void 0!==e?e:void 0!==t?t:void 0}function xr(e,t,r){var n=Sr(e,t),o=["get",e.property];if("categorical"===n&&"boolean"==typeof r[0][0]){for(var i=["case"],a=0,s=r;a<s.length;a+=1){var l=s[a];i.push(["==",o,l[0]],l[1])}return i.push(mr(br(e.default,t.default))),i}if("categorical"===n){for(var u=["match",o],c=0,p=r;c<p.length;c+=1){var d=p[c];kr(u,d[0],d[1],!1)}return u.push(mr(br(e.default,t.default))),u}if("interval"===n){for(var h=["step",["number",o]],f=0,y=r;f<y.length;f+=1){var m=y[f];kr(h,m[0],m[1],!0)}return wr(h),void 0===e.default?h:["case",["==",["typeof",o],"number"],h,mr(e.default)]}if("exponential"===n){for(var g=void 0!==e.base?e.base:1,v=[vr(e),1===g?["linear"]:["exponential",g],["number",o]],b=0,x=r;b<x.length;b+=1){var w=x[b];kr(v,w[0],w[1],!1)}return void 0===e.default?v:["case",["==",["typeof",o],"number"],v,mr(e.default)]}throw new Error("Unknown property function type "+n)}function wr(e){"step"===e[0]&&3===e.length&&(e.push(0),e.push(e[3]))}function kr(e,t,r,n){e.length>3&&t===e[e.length-2]||(n&&2===e.length||e.push(t),e.push(r))}function Sr(e,t){return e.type?e.type:t.expression.interpolated?"exponential":"interval"}function jr(e){for(var t=["concat"],r=/{([^{}]+)}/g,n=0,o=r.exec(e);null!==o;o=r.exec(e)){var i=e.slice(n,r.lastIndex-o[0].length);n=r.lastIndex,i.length>0&&t.push(i),t.push(["get",o[1]])}if(1===t.length)return e;if(n<e.length)t.push(e.slice(n));else if(2===t.length)return["to-string",t[1]];return t}function Tr(e){if(!0===e||!1===e)return!0;if(!Array.isArray(e)||0===e.length)return!1;switch(e[0]){case"has":return e.length>=2&&"$id"!==e[1]&&"$type"!==e[1];case"in":return e.length>=3&&("string"!=typeof e[1]||Array.isArray(e[2]));case"!in":case"!has":case"none":return!1;case"==":case"!=":case">":case">=":case"<":case"<=":return 3!==e.length||Array.isArray(e[1])||Array.isArray(e[2]);case"any":case"all":for(var t=0,r=e.slice(1);t<r.length;t+=1){var n=r[t];if(!Tr(n)&&"boolean"!=typeof n)return!1}return!0;default:return!0}}yr.deserialize=function(e){return new yr(e._parameters,e._specification)},yr.serialize=function(e){return{_parameters:e._parameters,_specification:e._specification}};var zr={type:"boolean",default:!1,transition:!1,"property-type":"data-driven",expression:{interpolated:!1,parameters:["zoom","feature"]}};function Ar(e,t){return e<t?-1:e>t?1:0}function _r(e){if(!e)return!0;var t,r=e[0];return e.length<=1?"any"!==r:"=="===r?Or(e[1],e[2],"=="):"!="===r?Er(Or(e[1],e[2],"==")):"<"===r||">"===r||"<="===r||">="===r?Or(e[1],e[2],r):"any"===r?(t=e.slice(1),["any"].concat(t.map(_r))):"all"===r?["all"].concat(e.slice(1).map(_r)):"none"===r?["all"].concat(e.slice(1).map(_r).map(Er)):"in"===r?Cr(e[1],e.slice(2)):"!in"===r?Er(Cr(e[1],e.slice(2))):"has"===r?Ir(e[1]):"!has"!==r||Er(Ir(e[1]))}function Or(e,t,r){switch(e){case"$type":return["filter-type-"+r,t];case"$id":return["filter-id-"+r,t];default:return["filter-"+r,e,t]}}function Cr(e,t){if(0===t.length)return!1;switch(e){case"$type":return["filter-type-in",["literal",t]];case"$id":return["filter-id-in",["literal",t]];default:return t.length>200&&!t.some((function(e){return(void 0===e?"undefined":n(e))!==n(t[0])}))?["filter-in-large",e,["literal",t.sort(Ar)]]:["filter-in-small",e,["literal",t]]}}function Ir(e){switch(e){case"$type":return!0;case"$id":return["filter-has-id"];default:return["filter-has",e]}}function Er(e){return["!",e]}function Mr(e){return function e(t,r){var o;if(Tr(t))return t;if(!t)return!0;var i,a=t[0];if(t.length<=1)return"any"!==a;if("=="===a||"!="===a||"<"===a||">"===a||"<="===a||">="===a){var s=t,l=s[1],u=s[2];i=function(e,t,r,o){var i;if("$type"===e)return[r,["geometry-type"],t];i="$id"===e?["id"]:["get",e];if(o&&null!==t){var a=void 0===t?"undefined":n(t);o[e]=a}if("=="===r&&"$id"!==e&&null===t)return["all",["has",e],["==",i,null]];if("!="===r&&"$id"!==e&&null===t)return["any",["!",["has",e]],["!=",i,null]];return[r,i,t]}(l,u,a,r)}else{if("any"===a){var c=t.slice(1).map((function(t){var r={},n=e(t,r),o=function(e){var t=[];for(var r in e){var n="$id"===r?["id"]:["get",r];t.push(["==",["typeof",n],e[r]])}if(0===t.length)return!0;if(1===t.length)return t[0];return["all"].concat(t)}(r);return!0===o?n:["case",o,n,!1]}));return["any"].concat(c)}if("all"===a){var p=t.slice(1).map((function(t){return e(t,r)}));return p.length>1?["all"].concat(p):(o=[]).concat.apply(o,p)}if("none"===a)return["!",e(["any"].concat(t.slice(1)),{})];i="in"===a?Rr(t[1],t.slice(2)):"!in"===a?Rr(t[1],t.slice(2),!0):"has"===a?Pr(t[1]):"!has"!==a||["!",Pr(t[1])]}return i}(e,{})}function Rr(e,t,r){if(void 0===r&&(r=!1),0===t.length)return r;var o;o="$type"===e?["geometry-type"]:"$id"===e?["id"]:["get",e];for(var i=!0,a=n(t[0]),s=0,l=t;s<l.length;s+=1){var u=l[s];if((void 0===u?"undefined":n(u))!==a){i=!1;break}}if(i&&("string"===a||"number"===a)){var c=t.sort().filter((function(e,r){return 0===r||t[r-1]!==e}));return["match",o,c,!r,r]}return[r?"all":"any"].concat(t.map((function(e){return[r?"!=":"==",o,e]})))}function Pr(e){return"$type"===e||("$id"===e?["!=",["id"],null]:["has",e])}var qr=["type","source","source-layer","minzoom","maxzoom","filter","layout"];function Nr(e,t){var r={};for(var n in e)"ref"!==n&&(r[n]=e[n]);return qr.forEach((function(e){e in t&&(r[e]=t[e])})),r}function Fr(e,t){if(Array.isArray(e)){if(!Array.isArray(t)||e.length!==t.length)return!1;for(var r=0;r<e.length;r++)if(!Fr(e[r],t[r]))return!1;return!0}if("object"===(void 0===e?"undefined":n(e))&&null!==e&&null!==t){if("object"!==(void 0===t?"undefined":n(t)))return!1;if(Object.keys(e).length!==Object.keys(t).length)return!1;for(var o in e)if(!Fr(e[o],t[o]))return!1;return!0}return e===t}var Lr="setStyle",Dr="addLayer",Br="removeLayer",Ur="setPaintProperty",Gr="setLayoutProperty",Jr="setFilter",$r="addSource",Yr="removeSource",Vr="setGeoJSONSourceData",Wr="setLayerZoomRange",Hr="setLayerProperty",Zr="setCenter",Kr="setZoom",Xr="setBearing",Qr="setPitch",en="setSprite",tn="setGlyphs",rn="setTransition",nn="setLight";function on(e,t,r){r.push({command:$r,args:[e,t[e]]})}function an(e,t,r){t.push({command:Yr,args:[e]}),r[e]=!0}function sn(e,t,r,n){an(e,r,n),on(e,t,r)}function ln(e,t,r){var n;for(n in e[r])if(e[r].hasOwnProperty(n)&&"data"!==n&&!Fr(e[r][n],t[r][n]))return!1;for(n in t[r])if(t[r].hasOwnProperty(n)&&"data"!==n&&!Fr(e[r][n],t[r][n]))return!1;return!0}function un(e,t,r,n,o,i){var a;for(a in t=t||{},e=e||{})e.hasOwnProperty(a)&&(Fr(e[a],t[a])||r.push({command:i,args:[n,a,t[a],o]}));for(a in t)t.hasOwnProperty(a)&&!e.hasOwnProperty(a)&&(Fr(e[a],t[a])||r.push({command:i,args:[n,a,t[a],o]}))}function cn(e){return e.id}function pn(e,t){return e[t.id]=t,e}var dn=function(e,t,r,n){this.message=(e?e+": ":"")+r,n&&(this.identifier=n),null!=t&&t.__line__&&(this.line=t.__line__)},hn=function(e){this.error=e,this.message=e.message;var t=e.message.match(/line (\d+)/);this.line=t?parseInt(t[1],10):0};function fn(e){var t=e.key,r=e.value;return r?[new dn(t,r,"constants have been deprecated as of v8")]:[]}function yn(e){return e instanceof Number||e instanceof String||e instanceof Boolean?e.valueOf():e}function mn(e){if(Array.isArray(e))return e.map(mn);if(e instanceof Object&&!(e instanceof Number||e instanceof String||e instanceof Boolean)){var t={};for(var r in e)t[r]=mn(e[r]);return t}return yn(e)}function gn(e){var t=e.key,r=e.value,n=e.valueSpec||{},o=e.objectElementValidators||{},i=e.style,a=e.styleSpec,s=[],l=er(r);if("object"!==l)return[new dn(t,r,"object expected, "+l+" found")];for(var u in r){var c=u.split(".")[0],p=n[c]||n["*"],d=void 0;if(o[c])d=o[c];else if(n[c])d=Mn;else if(o["*"])d=o["*"];else{if(!n["*"]){s.push(new dn(t,r[u],'unknown property "'+u+'"'));continue}d=Mn}s=s.concat(d({key:(t?t+".":t)+u,value:r[u],valueSpec:p,style:i,styleSpec:a,object:r,objectKey:u},r))}for(var h in n)o[h]||n[h].required&&void 0===n[h].default&&void 0===r[h]&&s.push(new dn(t,r,'missing required property "'+h+'"'));return s}function vn(e){var t=e.value,r=e.valueSpec,n=e.style,o=e.styleSpec,i=e.key,a=e.arrayElementValidator||Mn;if("array"!==er(t))return[new dn(i,t,"array expected, "+er(t)+" found")];if(r.length&&t.length!==r.length)return[new dn(i,t,"array length "+r.length+" expected, length "+t.length+" found")];if(r["min-length"]&&t.length<r["min-length"])return[new dn(i,t,"array length at least "+r["min-length"]+" expected, length "+t.length+" found")];var s={type:r.value,values:r.values};o.$version<7&&(s.function=r.function),"object"===er(r.value)&&(s=r.value);for(var l=[],u=0;u<t.length;u++)l=l.concat(a({array:t,arrayIndex:u,value:t[u],valueSpec:s,style:n,styleSpec:o,key:i+"["+u+"]"}));return l}function bn(e){var t=e.key,r=e.value,n=e.valueSpec,o=er(r);return"number"===o&&r!=r&&(o="NaN"),"number"!==o?[new dn(t,r,"number expected, "+o+" found")]:"minimum"in n&&r<n.minimum?[new dn(t,r,r+" is less than the minimum value "+n.minimum)]:"maximum"in n&&r>n.maximum?[new dn(t,r,r+" is greater than the maximum value "+n.maximum)]:[]}function xn(e){var t,r,n,o=e.valueSpec,i=yn(e.value.type),a={},s="categorical"!==i&&void 0===e.value.property,l=!s,u="array"===er(e.value.stops)&&"array"===er(e.value.stops[0])&&"object"===er(e.value.stops[0][0]),c=gn({key:e.key,value:e.value,valueSpec:e.styleSpec.function,style:e.style,styleSpec:e.styleSpec,objectElementValidators:{stops:function(e){if("identity"===i)return[new dn(e.key,e.value,'identity function may not have a "stops" property')];var t=[],r=e.value;t=t.concat(vn({key:e.key,value:r,valueSpec:e.valueSpec,style:e.style,styleSpec:e.styleSpec,arrayElementValidator:p})),"array"===er(r)&&0===r.length&&t.push(new dn(e.key,r,"array must have at least one stop"));return t},default:function(e){return Mn({key:e.key,value:e.value,valueSpec:o,style:e.style,styleSpec:e.styleSpec})}}});return"identity"===i&&s&&c.push(new dn(e.key,e.value,'missing required property "property"')),"identity"===i||e.value.stops||c.push(new dn(e.key,e.value,'missing required property "stops"')),"exponential"===i&&e.valueSpec.expression&&!Qt(e.valueSpec)&&c.push(new dn(e.key,e.value,"exponential functions not supported")),e.styleSpec.$version>=8&&(l&&!Kt(e.valueSpec)?c.push(new dn(e.key,e.value,"property functions not supported")):s&&!Xt(e.valueSpec)&&c.push(new dn(e.key,e.value,"zoom functions not supported"))),"categorical"!==i&&!u||void 0!==e.value.property||c.push(new dn(e.key,e.value,'"property" property is required')),c;function p(e){var t=[],i=e.value,s=e.key;if("array"!==er(i))return[new dn(s,i,"array expected, "+er(i)+" found")];if(2!==i.length)return[new dn(s,i,"array length 2 expected, length "+i.length+" found")];if(u){if("object"!==er(i[0]))return[new dn(s,i,"object expected, "+er(i[0])+" found")];if(void 0===i[0].zoom)return[new dn(s,i,"object stop key must have zoom")];if(void 0===i[0].value)return[new dn(s,i,"object stop key must have value")];if(n&&n>yn(i[0].zoom))return[new dn(s,i[0].zoom,"stop zoom values must appear in ascending order")];yn(i[0].zoom)!==n&&(n=yn(i[0].zoom),r=void 0,a={}),t=t.concat(gn({key:s+"[0]",value:i[0],valueSpec:{zoom:{}},style:e.style,styleSpec:e.styleSpec,objectElementValidators:{zoom:bn,value:d}}))}else t=t.concat(d({key:s+"[0]",value:i[0],valueSpec:{},style:e.style,styleSpec:e.styleSpec},i));return cr(mn(i[1]))?t.concat([new dn(s+"[1]",i[1],"expressions are not allowed in function stops.")]):t.concat(Mn({key:s+"[1]",value:i[1],valueSpec:o,style:e.style,styleSpec:e.styleSpec}))}function d(e,n){var s=er(e.value),l=yn(e.value),u=null!==e.value?e.value:n;if(t){if(s!==t)return[new dn(e.key,u,s+" stop domain type must match previous stop domain type "+t)]}else t=s;if("number"!==s&&"string"!==s&&"boolean"!==s)return[new dn(e.key,u,"stop domain value must be a number, string, or boolean")];if("number"!==s&&"categorical"!==i){var c="number expected, "+s+" found";return Kt(o)&&void 0===i&&(c+='\nIf you intended to use a categorical function, specify `"type": "categorical"`.'),[new dn(e.key,u,c)]}return"categorical"!==i||"number"!==s||isFinite(l)&&Math.floor(l)===l?"categorical"!==i&&"number"===s&&void 0!==r&&l<r?[new dn(e.key,u,"stop domain values must appear in ascending order")]:(r=l,"categorical"===i&&l in a?[new dn(e.key,u,"stop domain values must be unique")]:(a[l]=!0,[])):[new dn(e.key,u,"integer expected, found "+l)]}}function wn(e){var t=("property"===e.expressionContext?fr:pr)(mn(e.value),e.valueSpec);if("error"===t.result)return t.value.map((function(t){return new dn(""+e.key+t.key,e.value,t.message)}));var r=t.value.expression||t.value._styleExpression.expression;if("property"===e.expressionContext&&"text-font"===e.propertyKey&&!r.outputDefined())return[new dn(e.key,e.value,'Invalid data expression for "'+e.propertyKey+'". Output values must be contained as literals within the expression.')];if("property"===e.expressionContext&&"layout"===e.propertyType&&!Qe(r))return[new dn(e.key,e.value,'"feature-state" data expressions are not supported with layout properties.')];if("filter"===e.expressionContext&&!Qe(r))return[new dn(e.key,e.value,'"feature-state" data expressions are not supported with filters.')];if(e.expressionContext&&0===e.expressionContext.indexOf("cluster")){if(!et(r,["zoom","feature-state"]))return[new dn(e.key,e.value,'"zoom" and "feature-state" expressions are not supported with cluster properties.')];if("cluster-initial"===e.expressionContext&&!Xe(r))return[new dn(e.key,e.value,"Feature data expressions are not supported with initial expression part of cluster properties.")]}return[]}function kn(e){var t=e.key,r=e.value,n=e.valueSpec,o=[];return Array.isArray(n.values)?-1===n.values.indexOf(yn(r))&&o.push(new dn(t,r,"expected one of ["+n.values.join(", ")+"], "+JSON.stringify(r)+" found")):-1===Object.keys(n.values).indexOf(yn(r))&&o.push(new dn(t,r,"expected one of ["+Object.keys(n.values).join(", ")+"], "+JSON.stringify(r)+" found")),o}function Sn(e){return Tr(mn(e.value))?wn(H({},e,{expressionContext:"filter",valueSpec:{value:"boolean"}})):function e(t){var r=t.value,n=t.key;if("array"!==er(r))return[new dn(n,r,"array expected, "+er(r)+" found")];var o,i=t.styleSpec,a=[];if(r.length<1)return[new dn(n,r,"filter array must have at least 1 element")];switch(a=a.concat(kn({key:n+"[0]",value:r[0],valueSpec:i.filter_operator,style:t.style,styleSpec:t.styleSpec})),yn(r[0])){case"<":case"<=":case">":case">=":r.length>=2&&"$type"===yn(r[1])&&a.push(new dn(n,r,'"$type" cannot be use with operator "'+r[0]+'"'));case"==":case"!=":3!==r.length&&a.push(new dn(n,r,'filter array for operator "'+r[0]+'" must have 3 elements'));case"in":case"!in":r.length>=2&&"string"!==(o=er(r[1]))&&a.push(new dn(n+"[1]",r[1],"string expected, "+o+" found"));for(var s=2;s<r.length;s++)o=er(r[s]),"$type"===yn(r[1])?a=a.concat(kn({key:n+"["+s+"]",value:r[s],valueSpec:i.geometry_type,style:t.style,styleSpec:t.styleSpec})):"string"!==o&&"number"!==o&&"boolean"!==o&&a.push(new dn(n+"["+s+"]",r[s],"string, number, or boolean expected, "+o+" found"));break;case"any":case"all":case"none":for(var l=1;l<r.length;l++)a=a.concat(e({key:n+"["+l+"]",value:r[l],style:t.style,styleSpec:t.styleSpec}));break;case"has":case"!has":o=er(r[1]),2!==r.length?a.push(new dn(n,r,'filter array for "'+r[0]+'" operator must have 2 elements')):"string"!==o&&a.push(new dn(n+"[1]",r[1],"string expected, "+o+" found"))}return a}(e)}function jn(e,t){var r=e.key,n=e.style,o=e.styleSpec,i=e.value,a=e.objectKey,s=o[t+"_"+e.layerType];if(!s)return[];var l=a.match(/^(.*)-transition$/);if("paint"===t&&l&&s[l[1]]&&s[l[1]].transition)return Mn({key:r,value:i,valueSpec:o.transition,style:n,styleSpec:o});var u,c=e.valueSpec||s[a];if(!c)return[new dn(r,i,'unknown property "'+a+'"')];if("string"===er(i)&&Kt(c)&&!c.tokens&&(u=/^{([^}]+)}$/.exec(i)))return[new dn(r,i,'"'+a+'" does not support interpolation syntax\nUse an identity property function instead: `{ "type": "identity", "property": '+JSON.stringify(u[1])+" }`.")];var p=[];return"symbol"===e.layerType&&("text-field"===a&&n&&!n.glyphs&&p.push(new dn(r,i,'use of "text-field" requires a style "glyphs" property')),"text-font"===a&&tr(mn(i))&&"identity"===yn(i.type)&&p.push(new dn(r,i,'"text-font" does not support identity functions'))),p.concat(Mn({key:e.key,value:i,valueSpec:c,style:n,styleSpec:o,expressionContext:"property",propertyType:t,propertyKey:a}))}function Tn(e){return jn(e,"paint")}function zn(e){return jn(e,"layout")}function An(e){var t=[],r=e.value,n=e.key,o=e.style,i=e.styleSpec;r.type||r.ref||t.push(new dn(n,r,'either "type" or "ref" is required'));var a,s=yn(r.type),l=yn(r.ref);if(r.id)for(var u=yn(r.id),c=0;c<e.arrayIndex;c++){var p=o.layers[c];yn(p.id)===u&&t.push(new dn(n,r.id,'duplicate layer id "'+r.id+'", previously used at line '+p.id.__line__))}if("ref"in r)["type","source","source-layer","filter","layout"].forEach((function(e){e in r&&t.push(new dn(n,r[e],'"'+e+'" is prohibited for ref layers'))})),o.layers.forEach((function(e){yn(e.id)===l&&(a=e)})),a?a.ref?t.push(new dn(n,r.ref,"ref cannot reference another ref layer")):s=yn(a.type):t.push(new dn(n,r.ref,'ref layer "'+l+'" not found'));else if("background"!==s)if(r.source){var d=o.sources&&o.sources[r.source],h=d&&yn(d.type);d?"vector"===h&&"raster"===s?t.push(new dn(n,r.source,'layer "'+r.id+'" requires a raster source')):"raster"===h&&"raster"!==s?t.push(new dn(n,r.source,'layer "'+r.id+'" requires a vector source')):"vector"!==h||r["source-layer"]?"raster-dem"===h&&"hillshade"!==s?t.push(new dn(n,r.source,"raster-dem source can only be used with layer type 'hillshade'.")):"line"!==s||!r.paint||!r.paint["line-gradient"]||"geojson"===h&&d.lineMetrics||t.push(new dn(n,r,'layer "'+r.id+'" specifies a line-gradient, which requires a GeoJSON source with `lineMetrics` enabled.')):t.push(new dn(n,r,'layer "'+r.id+'" must specify a "source-layer"')):t.push(new dn(n,r.source,'source "'+r.source+'" not found'))}else t.push(new dn(n,r,'missing required property "source"'));return t=t.concat(gn({key:n,value:r,valueSpec:i.layer,style:e.style,styleSpec:e.styleSpec,objectElementValidators:{"*":function(){return[]},type:function(){return Mn({key:n+".type",value:r.type,valueSpec:i.layer.type,style:e.style,styleSpec:e.styleSpec,object:r,objectKey:"type"})},filter:Sn,layout:function(e){return gn({layer:r,key:e.key,value:e.value,style:e.style,styleSpec:e.styleSpec,objectElementValidators:{"*":function(e){return zn(H({layerType:s},e))}}})},paint:function(e){return gn({layer:r,key:e.key,value:e.value,style:e.style,styleSpec:e.styleSpec,objectElementValidators:{"*":function(e){return Tn(H({layerType:s},e))}}})}}}))}function _n(e){var t=e.value,r=e.key,n=er(t);return"string"!==n?[new dn(r,t,"string expected, "+n+" found")]:[]}var On={promoteId:function(e){var t=e.key,r=e.value;if("string"===er(r))return _n({key:t,value:r});var n=[];for(var o in r)n.push.apply(n,_n({key:t+"."+o,value:r[o]}));return n}};function Cn(e){var t=e.value,r=e.key,n=e.styleSpec,o=e.style;if(!t.type)return[new dn(r,t,'"type" is required')];var i,a=yn(t.type);switch(a){case"vector":case"raster":case"raster-dem":return i=gn({key:r,value:t,valueSpec:n["source_"+a.replace("-","_")],style:e.style,styleSpec:n,objectElementValidators:On});case"geojson":if(i=gn({key:r,value:t,valueSpec:n.source_geojson,style:o,styleSpec:n,objectElementValidators:On}),t.cluster)for(var s in t.clusterProperties){var l=t.clusterProperties[s],u=l[0],c=l[1],p="string"==typeof u?[u,["accumulated"],["get",s]]:u;i.push.apply(i,wn({key:r+"."+s+".map",value:c,expressionContext:"cluster-map"})),i.push.apply(i,wn({key:r+"."+s+".reduce",value:p,expressionContext:"cluster-reduce"}))}return i;case"video":return gn({key:r,value:t,valueSpec:n.source_video,style:o,styleSpec:n});case"image":return gn({key:r,value:t,valueSpec:n.source_image,style:o,styleSpec:n});case"canvas":return[new dn(r,null,"Please use runtime APIs to add canvas sources, rather than including them in stylesheets.","source.canvas")];default:return kn({key:r+".type",value:t.type,valueSpec:{values:["vector","raster","raster-dem","geojson","video","image"]},style:o,styleSpec:n})}}function In(e){var t=e.value,r=e.styleSpec,n=r.light,o=e.style,i=[],a=er(t);if(void 0===t)return i;if("object"!==a)return i=i.concat([new dn("light",t,"object expected, "+a+" found")]);for(var s in t){var l=s.match(/^(.*)-transition$/);i=l&&n[l[1]]&&n[l[1]].transition?i.concat(Mn({key:s,value:t[s],valueSpec:r.transition,style:o,styleSpec:r})):n[s]?i.concat(Mn({key:s,value:t[s],valueSpec:n[s],style:o,styleSpec:r})):i.concat([new dn(s,t[s],'unknown property "'+s+'"')])}return i}var En={"*":function(){return[]},array:vn,boolean:function(e){var t=e.value,r=e.key,n=er(t);return"boolean"!==n?[new dn(r,t,"boolean expected, "+n+" found")]:[]},number:bn,color:function(e){var t=e.key,r=e.value,n=er(r);return"string"!==n?[new dn(t,r,"color expected, "+n+" found")]:null===fe(r)?[new dn(t,r,'color expected, "'+r+'" found')]:[]},constants:fn,enum:kn,filter:Sn,function:xn,layer:An,object:gn,source:Cn,light:In,string:_n,formatted:function(e){return 0===_n(e).length?[]:wn(e)},resolvedImage:function(e){return 0===_n(e).length?[]:wn(e)}};function Mn(e){var t=e.value,r=e.valueSpec,n=e.styleSpec;return r.expression&&tr(yn(t))?xn(e):r.expression&&cr(mn(t))?wn(e):r.type&&En[r.type]?En[r.type](e):gn(H({},e,{valueSpec:r.type?n[r.type]:r}))}function Rn(e){var t=e.value,r=e.key,n=_n(e);return n.length||(-1===t.indexOf("{fontstack}")&&n.push(new dn(r,t,'"glyphs" url must include a "{fontstack}" token')),-1===t.indexOf("{range}")&&n.push(new dn(r,t,'"glyphs" url must include a "{range}" token'))),n}function Pn(e,t){void 0===t&&(t=o);var r=[];return r=r.concat(Mn({key:"",value:e,valueSpec:t.$root,styleSpec:t,style:e,objectElementValidators:{glyphs:Rn,"*":function(){return[]}}})),e.constants&&(r=r.concat(fn({key:"constants",value:e.constants,style:e,styleSpec:t}))),qn(r)}function qn(e){return[].concat(e).sort((function(e,t){return e.line-t.line}))}function Nn(e){return function(){for(var t=[],r=arguments.length;r--;)t[r]=arguments[r];return qn(e.apply(this,t))}}Pn.source=Nn(Cn),Pn.light=Nn(In),Pn.layer=Nn(An),Pn.filter=Nn(Sn),Pn.paintProperty=Nn(Tn),Pn.layoutProperty=Nn(zn);var Fn=u((function(e,t){var r=function(){var e=function(e,t,r,n){for(r=r||{},n=e.length;n--;r[e[n]]=t);return r},t=[1,12],r=[1,13],n=[1,9],o=[1,10],i=[1,11],a=[1,14],s=[1,15],l=[14,18,22,24],u=[18,22],c=[22,24],p={trace:function(){},yy:{},symbols_:{error:2,JSONString:3,STRING:4,JSONNumber:5,NUMBER:6,JSONNullLiteral:7,NULL:8,JSONBooleanLiteral:9,TRUE:10,FALSE:11,JSONText:12,JSONValue:13,EOF:14,JSONObject:15,JSONArray:16,"{":17,"}":18,JSONMemberList:19,JSONMember:20,":":21,",":22,"[":23,"]":24,JSONElementList:25,$accept:0,$end:1},terminals_:{2:"error",4:"STRING",6:"NUMBER",8:"NULL",10:"TRUE",11:"FALSE",14:"EOF",17:"{",18:"}",21:":",22:",",23:"[",24:"]"},productions_:[0,[3,1],[5,1],[7,1],[9,1],[9,1],[12,2],[13,1],[13,1],[13,1],[13,1],[13,1],[13,1],[15,2],[15,3],[20,3],[19,1],[19,3],[16,2],[16,3],[25,1],[25,3]],performAction:function(e,t,r,n,o,i,a){var s=i.length-1;switch(o){case 1:this.$=new String(e.replace(/\\(\\|")/g,"$1").replace(/\\n/g,"\n").replace(/\\r/g,"\r").replace(/\\t/g,"\t").replace(/\\v/g,"\v").replace(/\\f/g,"\f").replace(/\\b/g,"\b")),this.$.__line__=this._$.first_line;break;case 2:this.$=new Number(e),this.$.__line__=this._$.first_line;break;case 3:this.$=null;break;case 4:this.$=new Boolean(!0),this.$.__line__=this._$.first_line;break;case 5:this.$=new Boolean(!1),this.$.__line__=this._$.first_line;break;case 6:return this.$=i[s-1];case 13:this.$={},Object.defineProperty(this.$,"__line__",{value:this._$.first_line,enumerable:!1});break;case 14:case 19:this.$=i[s-1],Object.defineProperty(this.$,"__line__",{value:this._$.first_line,enumerable:!1});break;case 15:this.$=[i[s-2],i[s]];break;case 16:this.$={},this.$[i[s][0]]=i[s][1];break;case 17:this.$=i[s-2],i[s-2][i[s][0]]=i[s][1];break;case 18:this.$=[],Object.defineProperty(this.$,"__line__",{value:this._$.first_line,enumerable:!1});break;case 20:this.$=[i[s]];break;case 21:this.$=i[s-2],i[s-2].push(i[s])}},table:[{3:5,4:t,5:6,6:r,7:3,8:n,9:4,10:o,11:i,12:1,13:2,15:7,16:8,17:a,23:s},{1:[3]},{14:[1,16]},e(l,[2,7]),e(l,[2,8]),e(l,[2,9]),e(l,[2,10]),e(l,[2,11]),e(l,[2,12]),e(l,[2,3]),e(l,[2,4]),e(l,[2,5]),e([14,18,21,22,24],[2,1]),e(l,[2,2]),{3:20,4:t,18:[1,17],19:18,20:19},{3:5,4:t,5:6,6:r,7:3,8:n,9:4,10:o,11:i,13:23,15:7,16:8,17:a,23:s,24:[1,21],25:22},{1:[2,6]},e(l,[2,13]),{18:[1,24],22:[1,25]},e(u,[2,16]),{21:[1,26]},e(l,[2,18]),{22:[1,28],24:[1,27]},e(c,[2,20]),e(l,[2,14]),{3:20,4:t,20:29},{3:5,4:t,5:6,6:r,7:3,8:n,9:4,10:o,11:i,13:30,15:7,16:8,17:a,23:s},e(l,[2,19]),{3:5,4:t,5:6,6:r,7:3,8:n,9:4,10:o,11:i,13:31,15:7,16:8,17:a,23:s},e(u,[2,17]),e(u,[2,15]),e(c,[2,21])],defaultActions:{16:[2,6]},parseError:function(e,t){if(!t.recoverable)throw new Error(e);this.trace(e)},parse:function(e){var t=this,r=[0],n=[null],o=[],i=this.table,a="",s=0,l=0,u=2,c=1,p=o.slice.call(arguments,1),d=Object.create(this.lexer),h={yy:{}};for(var f in this.yy)Object.prototype.hasOwnProperty.call(this.yy,f)&&(h.yy[f]=this.yy[f]);d.setInput(e,h.yy),h.yy.lexer=d,h.yy.parser=this,void 0===d.yylloc&&(d.yylloc={});var y=d.yylloc;o.push(y);var m=d.options&&d.options.ranges;function g(){var e;return"number"!=typeof(e=d.lex()||c)&&(e=t.symbols_[e]||e),e}"function"==typeof h.yy.parseError?this.parseError=h.yy.parseError:this.parseError=Object.getPrototypeOf(this).parseError;for(var v,b,x,w,k,S,j,T,z={};;){if(b=r[r.length-1],this.defaultActions[b]?x=this.defaultActions[b]:(null==v&&(v=g()),x=i[b]&&i[b][v]),void 0===x||!x.length||!x[0]){var A="";for(k in T=[],i[b])this.terminals_[k]&&k>u&&T.push("'"+this.terminals_[k]+"'");A=d.showPosition?"Parse error on line "+(s+1)+":\n"+d.showPosition()+"\nExpecting "+T.join(", ")+", got '"+(this.terminals_[v]||v)+"'":"Parse error on line "+(s+1)+": Unexpected "+(v==c?"end of input":"'"+(this.terminals_[v]||v)+"'"),this.parseError(A,{text:d.match,token:this.terminals_[v]||v,line:d.yylineno,loc:y,expected:T})}if(x[0]instanceof Array&&x.length>1)throw new Error("Parse Error: multiple actions possible at state: "+b+", token: "+v);switch(x[0]){case 1:r.push(v),n.push(d.yytext),o.push(d.yylloc),r.push(x[1]),v=null,l=d.yyleng,a=d.yytext,s=d.yylineno,y=d.yylloc;break;case 2:if(S=this.productions_[x[1]][1],z.$=n[n.length-S],z._$={first_line:o[o.length-(S||1)].first_line,last_line:o[o.length-1].last_line,first_column:o[o.length-(S||1)].first_column,last_column:o[o.length-1].last_column},m&&(z._$.range=[o[o.length-(S||1)].range[0],o[o.length-1].range[1]]),void 0!==(w=this.performAction.apply(z,[a,l,s,h.yy,x[1],n,o].concat(p))))return w;S&&(r=r.slice(0,-1*S*2),n=n.slice(0,-1*S),o=o.slice(0,-1*S)),r.push(this.productions_[x[1]][0]),n.push(z.$),o.push(z._$),j=i[r[r.length-2]][r[r.length-1]],r.push(j);break;case 3:return!0}}return!0}},d={EOF:1,parseError:function(e,t){if(!this.yy.parser)throw new Error(e);this.yy.parser.parseError(e,t)},setInput:function(e,t){return this.yy=t||this.yy||{},this._input=e,this._more=this._backtrack=this.done=!1,this.yylineno=this.yyleng=0,this.yytext=this.matched=this.match="",this.conditionStack=["INITIAL"],this.yylloc={first_line:1,first_column:0,last_line:1,last_column:0},this.options.ranges&&(this.yylloc.range=[0,0]),this.offset=0,this},input:function(){var e=this._input[0];return this.yytext+=e,this.yyleng++,this.offset++,this.match+=e,this.matched+=e,e.match(/(?:\r\n?|\n).*/g)?(this.yylineno++,this.yylloc.last_line++):this.yylloc.last_column++,this.options.ranges&&this.yylloc.range[1]++,this._input=this._input.slice(1),e},unput:function(e){var t=e.length,r=e.split(/(?:\r\n?|\n)/g);this._input=e+this._input,this.yytext=this.yytext.substr(0,this.yytext.length-t),this.offset-=t;var n=this.match.split(/(?:\r\n?|\n)/g);this.match=this.match.substr(0,this.match.length-1),this.matched=this.matched.substr(0,this.matched.length-1),r.length-1&&(this.yylineno-=r.length-1);var o=this.yylloc.range;return this.yylloc={first_line:this.yylloc.first_line,last_line:this.yylineno+1,first_column:this.yylloc.first_column,last_column:r?(r.length===n.length?this.yylloc.first_column:0)+n[n.length-r.length].length-r[0].length:this.yylloc.first_column-t},this.options.ranges&&(this.yylloc.range=[o[0],o[0]+this.yyleng-t]),this.yyleng=this.yytext.length,this},more:function(){return this._more=!0,this},reject:function(){return this.options.backtrack_lexer?(this._backtrack=!0,this):this.parseError("Lexical error on line "+(this.yylineno+1)+". You can only invoke reject() in the lexer when the lexer is of the backtracking persuasion (options.backtrack_lexer = true).\n"+this.showPosition(),{text:"",token:null,line:this.yylineno})},less:function(e){this.unput(this.match.slice(e))},pastInput:function(){var e=this.matched.substr(0,this.matched.length-this.match.length);return(e.length>20?"...":"")+e.substr(-20).replace(/\n/g,"")},upcomingInput:function(){var e=this.match;return e.length<20&&(e+=this._input.substr(0,20-e.length)),(e.substr(0,20)+(e.length>20?"...":"")).replace(/\n/g,"")},showPosition:function(){var e=this.pastInput(),t=new Array(e.length+1).join("-");return e+this.upcomingInput()+"\n"+t+"^"},test_match:function(e,t){var r,n,o;if(this.options.backtrack_lexer&&(o={yylineno:this.yylineno,yylloc:{first_line:this.yylloc.first_line,last_line:this.last_line,first_column:this.yylloc.first_column,last_column:this.yylloc.last_column},yytext:this.yytext,match:this.match,matches:this.matches,matched:this.matched,yyleng:this.yyleng,offset:this.offset,_more:this._more,_input:this._input,yy:this.yy,conditionStack:this.conditionStack.slice(0),done:this.done},this.options.ranges&&(o.yylloc.range=this.yylloc.range.slice(0))),(n=e[0].match(/(?:\r\n?|\n).*/g))&&(this.yylineno+=n.length),this.yylloc={first_line:this.yylloc.last_line,last_line:this.yylineno+1,first_column:this.yylloc.last_column,last_column:n?n[n.length-1].length-n[n.length-1].match(/\r?\n?/)[0].length:this.yylloc.last_column+e[0].length},this.yytext+=e[0],this.match+=e[0],this.matches=e,this.yyleng=this.yytext.length,this.options.ranges&&(this.yylloc.range=[this.offset,this.offset+=this.yyleng]),this._more=!1,this._backtrack=!1,this._input=this._input.slice(e[0].length),this.matched+=e[0],r=this.performAction.call(this,this.yy,this,t,this.conditionStack[this.conditionStack.length-1]),this.done&&this._input&&(this.done=!1),r)return r;if(this._backtrack){for(var i in o)this[i]=o[i];return!1}return!1},next:function(){if(this.done)return this.EOF;var e,t,r,n;this._input||(this.done=!0),this._more||(this.yytext="",this.match="");for(var o=this._currentRules(),i=0;i<o.length;i++)if((r=this._input.match(this.rules[o[i]]))&&(!t||r[0].length>t[0].length)){if(t=r,n=i,this.options.backtrack_lexer){if(!1!==(e=this.test_match(r,o[i])))return e;if(this._backtrack){t=!1;continue}return!1}if(!this.options.flex)break}return t?!1!==(e=this.test_match(t,o[n]))&&e:""===this._input?this.EOF:this.parseError("Lexical error on line "+(this.yylineno+1)+". Unrecognized text.\n"+this.showPosition(),{text:"",token:null,line:this.yylineno})},lex:function(){var e=this.next();return e||this.lex()},begin:function(e){this.conditionStack.push(e)},popState:function(){return this.conditionStack.length-1>0?this.conditionStack.pop():this.conditionStack[0]},_currentRules:function(){return this.conditionStack.length&&this.conditionStack[this.conditionStack.length-1]?this.conditions[this.conditionStack[this.conditionStack.length-1]].rules:this.conditions.INITIAL.rules},topState:function(e){return(e=this.conditionStack.length-1-Math.abs(e||0))>=0?this.conditionStack[e]:"INITIAL"},pushState:function(e){this.begin(e)},stateStackSize:function(){return this.conditionStack.length},options:{},performAction:function(e,t,r,n){switch(r){case 0:break;case 1:return 6;case 2:return t.yytext=t.yytext.substr(1,t.yyleng-2),4;case 3:return 17;case 4:return 18;case 5:return 23;case 6:return 24;case 7:return 22;case 8:return 21;case 9:return 10;case 10:return 11;case 11:return 8;case 12:return 14;case 13:return"INVALID"}},rules:[/^(?:\s+)/,/^(?:(-?([0-9]|[1-9][0-9]+))(\.[0-9]+)?([eE][-+]?[0-9]+)?\b)/,/^(?:"(?:\\[\\"bfnrt/]|\\u[a-fA-F0-9]{4}|[^\\\0-\x09\x0a-\x1f"])*")/,/^(?:\{)/,/^(?:\})/,/^(?:\[)/,/^(?:\])/,/^(?:,)/,/^(?::)/,/^(?:true\b)/,/^(?:false\b)/,/^(?:null\b)/,/^(?:$)/,/^(?:.)/],conditions:{INITIAL:{rules:[0,1,2,3,4,5,6,7,8,9,10,11,12,13],inclusive:!0}}};function h(){this.yy={}}return p.lexer=d,h.prototype=p,p.Parser=h,new h}();void 0!==l&&(t.parser=r,t.Parser=r.Parser,t.parse=function(){return r.parse.apply(r,arguments)})}));Fn.parser,Fn.Parser,Fn.parse;function Ln(e){if(e instanceof String||"string"==typeof e||e instanceof r)try{return Fn.parse(e.toString())}catch(e){throw new hn(e)}return e}function Dn(e,t){void 0===t&&(t=o);var r=e;try{r=Ln(r)}catch(e){return[e]}return Pn(r,t)}function Bn(e,t){return!e||"string"!==er(e)||!!e.match(t)}function Un(e,t,r){var n=new Set(t),o=[];return Object.keys(e).forEach((function(t){if(!n.has(t)){var i=r?r+"."+t:null;o.push(new dn(i,e[t],'Unsupported property "'+t+'"'))}})),o}function Gn(e){var t=[],r=0;return Object.keys(e).forEach((function(n,o){var i=function(e,t){var r=[];return r.push.apply(r,Un(e,["type","url","tileSize"],"source")),Bn(e.url,/^mapbox:\/\/([^/]*)$/)||r.push(new dn("sources["+t+"]",e.url,"Source url must be a valid Mapbox tileset url")),r}(e[n],o);i.length||(r+=function(e){return e.url?e.url.split(",").length:0}(e[n])),t.push.apply(t,i)})),r>15&&t.push(new dn("sources",null,"Styles must contain 15 or fewer sources")),t}var Jn={StyleExpression:ur,isExpression:cr,isExpressionFilter:Tr,createExpression:pr,createPropertyExpression:fr,normalizePropertyExpression:function(e,t){if(tr(e))return new yr(e,t);if(cr(e)){var r=fr(e,t);if("error"===r.result)throw new Error(r.value.map((function(e){return e.key+": "+e.message})).join(", "));return r.value}var n=e;return"string"==typeof e&&"color"===t.type&&(n=ye.parse(e)),{kind:"constant",evaluate:function(){return n}}},ZoomConstantExpression:dr,ZoomDependentExpression:hr,StylePropertyFunction:yr},$n={convertFunction:gr,createFunction:nr,isFunction:tr},Yn={eachSource:B,eachLayer:U,eachProperty:G};Dn.parsed=Dn,Dn.latest=Dn,t.Color=ye,t.ParsingError=hn,t.ValidationError=dn,t.composite=function(e){var t=[],r=[],n=[];for(var o in e.sources){var i=e.sources[o];if("vector"===i.type){var a=/^mapbox:\/\/(.*)/.exec(i.url);a&&(t.push(o),r.push(a[1]))}}if(t.length<2)return e;t.forEach((function(t){delete e.sources[t]}));var s=r.join(",");return e.sources[s]={type:"vector",url:"mapbox://"+s},e.layers.forEach((function(e){if(t.indexOf(e.source)>=0&&(e.source=s,"source-layer"in e)){if(n.indexOf(e["source-layer"])>=0)throw new Error("Conflicting source layer names");n.push(e["source-layer"])}})),e},t.convertFilter=Mr,t.derefLayers=function(e){e=e.slice();for(var t=Object.create(null),r=0;r<e.length;r++)t[e[r].id]=e[r];for(var n=0;n<e.length;n++)"ref"in e[n]&&(e[n]=Nr(e[n],t[e[n].ref]));return e},t.diff=function(e,t){if(!e)return[{command:Lr,args:[t]}];var r=[];try{if(!Fr(e.version,t.version))return[{command:Lr,args:[t]}];Fr(e.center,t.center)||r.push({command:Zr,args:[t.center]}),Fr(e.zoom,t.zoom)||r.push({command:Kr,args:[t.zoom]}),Fr(e.bearing,t.bearing)||r.push({command:Xr,args:[t.bearing]}),Fr(e.pitch,t.pitch)||r.push({command:Qr,args:[t.pitch]}),Fr(e.sprite,t.sprite)||r.push({command:en,args:[t.sprite]}),Fr(e.glyphs,t.glyphs)||r.push({command:tn,args:[t.glyphs]}),Fr(e.transition,t.transition)||r.push({command:rn,args:[t.transition]}),Fr(e.light,t.light)||r.push({command:nn,args:[t.light]});var n={},o=[];!function(e,t,r,n){var o;for(o in t=t||{},e=e||{})e.hasOwnProperty(o)&&(t.hasOwnProperty(o)||an(o,r,n));for(o in t)t.hasOwnProperty(o)&&(e.hasOwnProperty(o)?Fr(e[o],t[o])||("geojson"===e[o].type&&"geojson"===t[o].type&&ln(e,t,o)?r.push({command:Vr,args:[o,t[o].data]}):sn(o,t,r,n)):on(o,t,r))}(e.sources,t.sources,o,n);var i=[];e.layers&&e.layers.forEach((function(e){n[e.source]?r.push({command:Br,args:[e.id]}):i.push(e)})),r=r.concat(o),function(e,t,r){t=t||[];var n,o,i,a,s,l,u,c=(e=e||[]).map(cn),p=t.map(cn),d=e.reduce(pn,{}),h=t.reduce(pn,{}),f=c.slice(),y=Object.create(null);for(n=0,o=0;n<c.length;n++)i=c[n],h.hasOwnProperty(i)?o++:(r.push({command:Br,args:[i]}),f.splice(f.indexOf(i,o),1));for(n=0,o=0;n<p.length;n++)i=p[p.length-1-n],f[f.length-1-n]!==i&&(d.hasOwnProperty(i)?(r.push({command:Br,args:[i]}),f.splice(f.lastIndexOf(i,f.length-o),1)):o++,l=f[f.length-n],r.push({command:Dr,args:[h[i],l]}),f.splice(f.length-n,0,i),y[i]=!0);for(n=0;n<p.length;n++)if(a=d[i=p[n]],s=h[i],!y[i]&&!Fr(a,s))if(Fr(a.source,s.source)&&Fr(a["source-layer"],s["source-layer"])&&Fr(a.type,s.type)){for(u in un(a.layout,s.layout,r,i,null,Gr),un(a.paint,s.paint,r,i,null,Ur),Fr(a.filter,s.filter)||r.push({command:Jr,args:[i,s.filter]}),Fr(a.minzoom,s.minzoom)&&Fr(a.maxzoom,s.maxzoom)||r.push({command:Wr,args:[i,s.minzoom,s.maxzoom]}),a)a.hasOwnProperty(u)&&"layout"!==u&&"paint"!==u&&"filter"!==u&&"metadata"!==u&&"minzoom"!==u&&"maxzoom"!==u&&(0===u.indexOf("paint.")?un(a[u],s[u],r,i,u.slice(6),Ur):Fr(a[u],s[u])||r.push({command:Hr,args:[i,u,s[u]]}));for(u in s)s.hasOwnProperty(u)&&!a.hasOwnProperty(u)&&"layout"!==u&&"paint"!==u&&"filter"!==u&&"metadata"!==u&&"minzoom"!==u&&"maxzoom"!==u&&(0===u.indexOf("paint.")?un(a[u],s[u],r,i,u.slice(6),Ur):Fr(a[u],s[u])||r.push({command:Hr,args:[i,u,s[u]]}))}else r.push({command:Br,args:[i]}),l=f[f.lastIndexOf(i)+1],r.push({command:Dr,args:[s,l]})}(i,t.layers,r)}catch(e){console.warn("Unable to compute style diff:",e),r=[{command:Lr,args:[t]}]}return r},t.expression=Jn,t.featureFilter=function(e){if(null==e)return{filter:function(){return!0},needGeometry:!1};Tr(e)||(e=_r(e));var t=pr(e,zr);if("error"===t.result)throw new Error(t.value.map((function(e){return e.key+": "+e.message})).join(", "));return{filter:function(e,r,n){return t.value.evaluate(e,r,{},n)},needGeometry:Array.isArray(e)&&0!==e.length&&"within"===e[0]}},t.format=function(e,t){return void 0===t&&(t=2),(e=a(e,o.$root)).layers&&(e.layers=e.layers.map((function(e){return a(e,o.layer)}))),r=e,s=(s={indent:t})||{},l=JSON.stringify([1],void 0,void 0===s.indent?2:s.indent).slice(2,-3),u=""===l?1/0:void 0===s.maxLength?80:s.maxLength,c=s.replacer,function e(t,r,o){var a,s,p,d,h,f,y,m,g,v,b,x;if(t&&"function"==typeof t.toJSON&&(t=t.toJSON()),void 0===(b=JSON.stringify(t,c)))return b;if(y=u-r.length-o,b.length<=y&&(g=b.replace(i,(function(e,t){return t||e+" "}))).length<=y)return g;if(null!=c&&(t=JSON.parse(b),c=void 0),"object"===(void 0===t?"undefined":n(t))&&null!==t){if(m=r+l,p=[],s=0,Array.isArray(t))for(v="[",a="]",y=t.length;s<y;s++)p.push(e(t[s],m,s===y-1?0:1)||"null");else for(v="{",a="}",y=(f=Object.keys(t)).length;s<y;s++)d=f[s],h=JSON.stringify(d)+": ",void 0!==(x=e(t[d],m,h.length+(s===y-1?0:1)))&&p.push(h+x);if(p.length>0)return[v,l+p.join(",\n"+m),a].join("\n"+r)}return b}(r,"",0);var r,s,l,u,c},t.function=$n,t.latest=o,t.migrate=function(e){var t=!1;if(7===e.version&&(e=W(e),t=!0),8===e.version&&(t=function(e){var t=[];return U(e,(function(e){e.filter&&(e.filter=Mr(e.filter))})),G(e,{paint:!0,layout:!0},(function(e){var r=e.path,o=e.value,i=e.reference,a=e.set;cr(o)||("object"!==(void 0===o?"undefined":n(o))||Array.isArray(o)?i.tokens&&"string"==typeof o&&a(jr(o)):(a(gr(o,i)),t.push(r.join("."))))})),e}(e),t=!0),!t)throw new Error("cannot migrate from",e.version);return e},t.v8=o,t.validate=Dn,t.validateMapboxApiSupported=function(e){var t=e;try{t=Ln(t)}catch(e){return[e]}var r=Pn(t,o).concat(function(e,t){var r=[],n=Un(e,t.concat(["owner","id","cacheControl","draft","created","modified","visibility"]));return r.push.apply(r,n),(e.version>8||e.version<8)&&r.push(new dn("version",e.version,"Style version must be 8")),Bn(e.glyphs,/^mapbox:\/\/fonts\/([^/]*)\/{fontstack}\/{range}.pbf$/)||r.push(new dn("glyphs",e.glyphs,"Styles must reference glyphs hosted by Mapbox")),Bn(e.sprite,/^mapbox:\/\/sprites\/([^/]*)\/([^/]*)\/?([^/]*)?$/)||r.push(new dn("sprite",e.sprite,"Styles must reference sprites hosted by Mapbox")),Bn(e.visibility,/^(public|private)$/)||r.push(new dn("visibility",e.visibility,"Style visibility must be public or private")),r}(t,Object.keys(o.$root)));return t.sources&&(r=r.concat(Gn(t.sources))),r},t.visit=Yn}).call(this,r(1),r(6).Buffer)},function(e,t,r){"use strict";var n,o="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e};n=function(){return this}();try{n=n||new Function("return this")()}catch(e){"object"===("undefined"==typeof window?"undefined":o(window))&&(n=window)}e.exports=n},function(e,t,r){"use strict";var n={thin:100,hairline:100,"ultra-light":100,"extra-light":100,light:200,book:300,regular:400,normal:400,plain:400,roman:400,standard:400,medium:500,"semi-bold":600,"demi-bold":600,bold:700,heavy:800,black:800,"extra-bold":800,"ultra-black":900,"extra-black":900,"ultra-bold":900,"heavy-black":900,fat:900,poster:900},o=/(italic|oblique)$/i,i={};e.exports=function(e,t,r){var a=i[e];if(!a){Array.isArray(e)||(e=[e]);for(var s=400,l="normal",u=[],c=0,p=e.length;c<p;++c){var d=e[c].split(" "),h=d[d.length-1].toLowerCase();for(var f in"normal"==h||"italic"==h||"oblique"==h?(l=h,d.pop(),h=d[d.length-1].toLowerCase()):o.test(h)&&(h=h.replace(o,""),l=d[d.length-1].replace(h,"")),n)if(h==f||h==f.replace("-","")||h==f.replace("-"," ")){s=n[f],d.pop();break}"number"==typeof h&&(s=h);var y=d.join(" ").replace("Klokantech Noto Sans","Noto Sans");-1!==y.indexOf(" ")&&(y='"'+y+'"'),u.push(y)}a=i[e]=[l,s,u]}return a[0]+" "+a[1]+" "+t+"px"+(r?"/"+r:"")+" "+a[2]}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getValue=k,t.default=function(e,t,r,h,f,y,m,g){if(!h){h=[];for(var x=78271.51696402048;h.length<21;x/=2)h.push(x)}if("string"==typeof t&&(t=JSON.parse(t)),8!=t.version)throw new Error("glStyle version 8 required.");if(y&&!m){var j=new Image;j.crossOrigin="anonymous",j.onload=function(){m=j,[j.width,j.height],e.changed()},j.src=y}var O=document.createElement("CANVAS").getContext("2d"),I={};function E(e,t,r){var n=r+","+t+","+e,o=I[n];if(!o){O.font=t;for(var i=O.measureText("M").width*r,a=e.split(" "),s="",l=[],u=0,c=a.length;u<c;++u){var p=a[u];O.measureText(s+p).width<=i?s+=(s?" ":"")+p:(s&&l.push(s),s=p)}s&&l.push(s),I[n]=o=l.join("\n")}return o}for(var M=(0,c.derefLayers)(t.layers),R={},P=[],q=void 0,N=0,F=M.length;N<F;++N){var L=M[N],D=L.id;if("string"==typeof r&&L.source==r||-1!==r.indexOf(D)){var B=L["source-layer"];q||(q=L.source);var U=R[B];U||(U=R[B]=[]),U.push({layer:L,index:N}),P.push(D)}delete w[D],delete z[D]}var G={},J=[],$={},Y=function(e,t){var r=e.getProperties();e.styleIds=e.styleIds||{};var c=R[r.layer];if(c){var y=h.indexOf(t);-1==y&&(y=Math.round((0,d.getZoomForResolution)(t,h)));for(var g=v[e.getGeometry().getType()],x={properties:r,type:g},w=-1,j=0,z=c.length;j<z;++j){var O=c[j],I=O.layer,M=I.id,P=I.layout||b,q=I.paint||b;if(!("none"===P.visibility||"minzoom"in I&&y<I.minzoom||"maxzoom"in I&&y>=I.maxzoom)){e.styleIds[y]=e.styleIds[y]||[];var N=I.filter,F=void 0,L=void 0;if(!N||A(M,N,x,y)){var D=void 0,B=void 0,U=void 0,Y=void 0,V=void 0,W=void 0,H=O.index;if(3==g&&"fill"==I.type)if(B=k(I,"paint","fill-opacity",y,x),"fill-pattern"in q){var Z=k(I,"paint","fill-pattern",y,x);if(Z&&(F="string"==typeof Z?C(Z,r):Z.toString(),m&&f&&f[F])){++w,-1===e.styleIds[y].indexOf(M)&&e.styleIds[y].push(M),(W=J[w])&&W.getFill()&&!W.getStroke()&&!W.getText()||(W=J[w]=new n.default({fill:new o.default})),U=W.getFill(),W.setZIndex(H);var K=F+"."+B,X=$[K];if(!X){var Q=f[F],ee=document.createElement("canvas");ee.width=Q.width,ee.height=Q.height;var te=ee.getContext("2d");te.globalAlpha=B,te.drawImage(m,Q.x,Q.y,Q.width,Q.height,0,0,Q.width,Q.height),X=te.createPattern(ee,"repeat"),$[K]=X}U.setColor(X)}}else"fill-color"in q&&((D=_(k(I,"paint","fill-color",y,x),B))&&(++w,-1===e.styleIds[y].indexOf(M)&&e.styleIds[y].push(M),(W=J[w])&&W.getFill()&&!W.getStroke()&&!W.getText()||(W=J[w]=new n.default({fill:new o.default})),(U=W.getFill()).setColor(D),W.setZIndex(H)),"fill-outline-color"in q?V=_(k(I,"paint","fill-outline-color",y,r),B):"fill-antialias"in q&&(V=D),V&&(++w,-1===e.styleIds[y].indexOf(M)&&e.styleIds[y].push(M),(W=J[w])&&W.getStroke()&&!W.getFill()&&!W.getText()||(W=J[w]=new n.default({stroke:new i.default})),(Y=W.getStroke()).setColor(V),Y.setWidth(1),W.setZIndex(H)));1!=g&&"line"==I.type&&function(){D=!("line-pattern"in q)&&"line-color"in q?_(k(I,"paint","line-color",y,x),k(I,"paint","line-opacity",y,x)):void 0;var t=k(I,"paint","line-width",y,x);D&&t>0&&(++w,-1===e.styleIds[y].indexOf(M)&&e.styleIds[y].push(M),(W=J[w])&&W.getStroke()&&!W.getFill()&&!W.getText()||(W=J[w]=new n.default({stroke:new i.default})),(Y=W.getStroke()).setLineCap(k(I,"layout","line-cap",y,x)),Y.setLineJoin(k(I,"layout","line-join",y,x)),Y.setMiterLimit(k(I,"layout","line-miter-limit",y,x)),Y.setColor(D),Y.setWidth(t),Y.setLineDash(q["line-dasharray"]?k(I,"paint","line-dasharray",y,x).map((function(e){return e*t})):null),W.setZIndex(H))}();var re=!1,ne=null,oe=void 0;if((1==g||2==g)&&"icon-image"in P){var ie=k(I,"layout","icon-image",y,x);if(ie){F="string"==typeof ie?C(ie,r):ie.toString();var ae=void 0;if(m&&f&&f[F]){if(2==g){var se=e.getGeometry();if(se.getFlatMidpoint){var le=se.getExtent();Math.sqrt(Math.max(Math.pow((le[2]-le[0])/t,2),Math.pow((le[3]-le[1])/t,2)))>150&&(ae=new u.default(se.getFlatMidpoint()))}}if(2!==g||ae){++w,-1===e.styleIds[y].indexOf(M)&&e.styleIds[y].push(M),(W=J[w])&&W.getImage()&&!W.getFill()&&!W.getStroke()||(W=J[w]=new n.default),W.setGeometry(ae);var ue=k(I,"layout","icon-size",y,x),ce=void 0!==q["icon-color"]?k(I,"paint","icon-color",y,x):null,pe=k(I,"paint","icon-translate",y,x),de=k(I,"paint","icon-translate-anchor",y,x),he=k(I,"layout","icon-anchor",y,x),fe=k(I,"layout","icon-offset",y,x),ye=S(he),me=ye.anchorOffset,ge=ye.iconAnchor,ve=void 0===ge?he:ge,be=F+"."+ue+"."+pe+"."+de+"."+ve+"."+fe+"."+me;if(null!==ce&&(be+="."+ce),!(L=G[be])){var xe=f[F],we=document.createElement("canvas");we.width=xe.width,we.height=xe.height;var ke=we.getContext("2d");ke.drawImage(m,xe.x,xe.y,xe.width,xe.height,0,0,xe.width,xe.height);var Se=ke.getImageData(0,0,we.width,we.height);if(null!==ce){D=_(ce,1);for(var je=0,Te=Se.data.length;je<Te;je+=4)Se.data[je]=D[0],Se.data[je+1]=D[1],Se.data[je+2]=D[2]}ke.putImageData(Se,0,0);var ze=[pe[0]/xe.width,pe[1]/xe.height];L=G[be]=new a.default({img:we,anchorOrigin:ve,anchor:[fe[0]+me[0]+ze[0],fe[1]+me[1]-ze[1]],imgSize:[we.width,we.height],scale:ue/xe.pixelRatio})}var Ae=k(I,"layout","icon-rotate",y,x);Ae.indexOf&&0===Ae.indexOf("{")&&(Ae=360-C(Ae,r)),L.setRotation((0,d.deg2rad)(Ae)),L.setOpacity(k(I,"paint","icon-opacity",y,x)),W.setImage(L),ne=W.getText(),W.setText(void 0),W.setZIndex(99999-H),re=!0,oe=!1}else oe=!0}}}if(1==g&&"circle-radius"in q){++w,-1===e.styleIds[y].indexOf(M)&&e.styleIds[y].push(M),(W=J[w])&&W.getImage()&&!W.getFill()&&!W.getStroke()||(W=J[w]=new n.default);var _e=k(I,"paint","circle-radius",y,x),Oe=k(I,"paint","circle-stroke-color",y,x),Ce=k(I,"paint","circle-color",y,x),Ie=k(I,"paint","circle-opacity",y,x),Ee=k(I,"paint","circle-stroke-width",y,x),Me=k(I,"paint","circle-stroke-opacity",y,x);(L=G[_e+"."+Oe+"."+Ce+"."+Ie+"."+Ee+"."+Me])||(L=new l.default({radius:_e,stroke:0===Ee?void 0:new i.default({width:Ee,color:_(Oe,Me)}),fill:new o.default({color:_(Ce,Ie)})})),W.setImage(L),ne=W.getText(),W.setText(void 0),W.setGeometry(void 0),W.setZIndex(99999-H),re=!0}var Re=void 0;if("text-field"in P)Re=C(k(I,"layout","text-field",y,x),r);if(Re&&!oe){re||(++w,-1===e.styleIds[y].indexOf(M)&&e.styleIds[y].push(M),(W=J[w])&&W.getText()&&!W.getFill()&&!W.getStroke()||(W=J[w]=new n.default),W.setImage(void 0),W.setGeometry(void 0)),W.getText()||W.setText(ne||new s.default),ne=W.getText();var Pe=k(I,"layout","text-size",y,x),qe=k(I,"layout","text-line-height",y,x),Ne=(0,p.default)(T(k(I,"layout","text-font",y,x)),Pe),Fe=P["text-transform"];"uppercase"==Fe?Re=Re.toUpperCase():"lowercase"==Fe&&(Re=Re.toLowerCase());var Le=2==g?Re:E(Re,Ne,k(I,"layout","text-max-width",y,x));ne.setText(Le),ne.setFont(Ne),ne.setRotation((0,d.deg2rad)(k(I,"layout","text-rotate",y,x)));var De=k(I,"layout","text-anchor",y,x),Be=re||1==g?"point":k(I,"layout","symbol-placement",y,x);ne.setPlacement(Be);var Ue=k(I,"paint","text-halo-width",y,x),Ge=k(I,"layout","text-offset",y,x),Je=k(I,"paint","text-translate",y,x),$e=0,Ye=0,Ve="center";-1!==De.indexOf("left")?(Ve="left",Ye=Ue):-1!==De.indexOf("right")&&(Ve="right",Ye=-Ue),"point"==Be?ne.setTextAlign(Ve):(ne.setMaxAngle((0,d.deg2rad)(k(I,"layout","text-max-angle",y,x))*Re.length/Le.length),ne.setTextAlign());var We="middle";0==De.indexOf("bottom")?(We="bottom",$e=-Ue-.5*(qe-1)*Pe):0==De.indexOf("top")&&(We="top",$e=Ue+.5*(qe-1)*Pe),ne.setTextBaseline(We),ne.setOffsetX(Ge[0]*Pe+Ye+Je[0]),ne.setOffsetY(Ge[1]*Pe+$e+Je[1]),B=k(I,"paint","text-opacity",y,x);var He=new o.default;He.setColor(_(k(I,"paint","text-color",y,x),B)),ne.setFill(He);var Ze=_(k(I,"paint","text-halo-color",y,x),B);if(Ze){var Ke=new i.default;Ke.setColor(Ze),Ke.setWidth(k(I,"paint","text-halo-width",y,x)),ne.setStroke(Ke)}else ne.setStroke(void 0);W.setZIndex(99999-H)}}}}return w>-1?(J.length=w+1,J):void 0}};return e.setStyle(Y),e.set("mapbox-source",q),e.set("mapbox-layers",P),Y};var n=h(r(10)),o=h(r(11)),i=h(r(12)),a=h(r(13)),s=h(r(14)),l=h(r(15)),u=h(r(16)),c=r(0),p=h(r(2)),d=r(17);function h(e){return e&&e.__esModule?e:{default:e}}var f=c.function.isFunction,y=c.function.convertFunction,m=c.expression.isExpression,g=c.expression.createPropertyExpression,v={Point:1,MultiPoint:1,LineString:2,MultiLineString:2,Polygon:3,MultiPolygon:3},b={},x={zoom:0},w={};function k(e,t,r,n,o){var i=e.id;w[i]||(w[i]={});var a=w[i];if(!a[r]){var s=(e[t]||b)[r],l=c.latest[t+"_"+e.type][r];void 0===s&&(s=l.default);var u=m(s);if(!u&&f(s)&&(s=y(s,l),u=!0),u){var p=function(e,t){var r=g(e,t);if("error"===r.result)throw new Error(r.value.map((function(e){return e.key+": "+e.message})).join(", "));return r.value}(s,l);a[r]=p.evaluate.bind(p)}else"color"==l.type&&(s=c.Color.parse(s)),a[r]=function(){return s}}return x.zoom=n,a[r](x,o)}function S(e){var t=[.5,.5];return["top-left","top-right","bottom-left","bottom-right"].indexOf(e)>-1&&(t=[0,0]),"left"===e&&(e="top-left",t=[0,.5]),"right"===e&&(e="top-left",t=[1,.5]),"bottom"===e&&(e="top-left",t=[.5,1]),"top"===e&&(e="top-left",t=[.5,0]),{anchorOffset:t,iconAnchor:e}}var j={};function T(e,t){if(j[e])return j[e];if(t){for(var r=0,n=e.length;r<n;++r){var o=e[r];if(-1!=t.indexOf(o)){j[e]=o;break}}j[e]||(j[e]=e[e.length-1])}else j[e]=e[0];return j[e]}var z={};function A(e,t,r,n){return e in z||(z[e]=(0,c.featureFilter)(t).filter),x.zoom=n,z[e](x,r)}function _(e,t){if(e){if(0===e.a||0===t)return;var r=e.a;return t=void 0===t?1:t,"rgba("+Math.round(255*e.r/r)+","+Math.round(255*e.g/r)+","+Math.round(255*e.b/r)+","+r*t+")"}return e}var O=/^([^]*)\{(.*)\}([^]*)$/;function C(e,t){var r=void 0;do{if(r=e.match(O)){var n=t[r[2]]||"";e=r[1]+n+r[3]}}while(r);return e}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n,o=r(5),i=r(3),a=(n=i)&&n.__esModule?n:{default:n};t.default={apply:o.apply,applyBackground:o.applyBackground,applyStyle:o.applyStyle,stylefunction:a.default}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e};t.applyStyle=O,t.applyBackground=function(e,t){t.layers.some((function(t){if("background"==t.type)return C(e,t),!0}))},t.apply=function(e,t){var r,n,o,i;r=n=o=i="",e instanceof d.default||(e=new d.default({target:e}));if("string"==typeof t){var a=t.match(z);a&&(n=a[1],r=a.length>2?a[2]:""),fetch(t,{credentials:"same-origin"}).then((function(e){return e.json()})).then((function(a){var s=document.createElement("A");s.href=t,i=s.pathname.split("/").slice(0,-1).join("/")+"/",o=t.substr(0,t.indexOf(i)),E(a,e,n,o,i,r)})).catch((function(e){throw console.error(e),new Error("Could not load "+t)}))}else setTimeout((function(){E(t,e)}),0);return e},t.getLayer=function(e,t){for(var r=e.getLayers().getArray(),n=0,o=r.length;n<o;++n)if(-1!==r[n].get("mapbox-layers").indexOf(t))return r[n]},t.getSource=function(e,t){for(var r=e.getLayers().getArray(),n=0,o=r.length;n<o;++n){var i=r[n].getSource();if(-1!==r[n].get("mapbox-source").indexOf(t))return i}};var o,i=r(0),a=S(r(2)),s=r(3),l=S(s),u=S(r(18)),c=r(19),p=r(20),d=S(r(21)),h=S(r(22)),f=S(r(23)),y=r(24),m=S(r(25)),g=S(r(26)),v=S(r(27)),b=S(r(28)),x=S(r(29)),w=S(r(30)),k=S(r(31));function S(e){return e&&e.__esModule?e:{default:e}}var j=["Open Sans Regular","Arial Regular"];function T(e){"layout"in e&&"text-field"in e.layout&&function e(t){var r,n;if(Array.isArray(t)){var i=u.default.getNames(),s=t.map((function(e){return(0,a.default)(e,1).split(" 1px ")[1].replace(/"/g,"")}));for(r=0,n=s.length;r<n;++r){var l=s[r],c=t[r];if(-1!==i.indexOf(l)){if(o||(o=[]),-1==o.indexOf(c)){o.push(c);var p="https://fonts.googleapis.com/css?family="+l.replace(/ /g,"+");if(!document.querySelector('link[href="'+p+'"]')){var d=document.createElement("link");d.href=p,d.rel="stylesheet",document.getElementsByTagName("head")[0].appendChild(d)}}break}}}else{var h=t.stops;if(h)for(r=0,n=h.length;r<n;++r)e(h[r][1])}}(e.layout["text-font"]||j)}var z=/^(.*)(\?.*)$/;function A(e,t){return t&&0!=e.indexOf("http")&&(e=t+e),e}function _(e,t,r){var n=(e=A(e,t)).match(z);return n?n[1]+r+(n.length>2?n[2]:""):e+r}function O(e,t,r,i,a){return new Promise((function(s,u){var c,p,d;if("object"!=(void 0===t?"undefined":n(t))&&(t=JSON.parse(t)),8!=t.version&&u(new Error("glStyle version 8 required.")),t.sprite){var h=.5==(window.devicePixelRatio>=1.5?.5:1)?"@2x":"",f=_(t.sprite,i,h+".json");fetch(f,{credentials:"same-origin"}).then((function(e){return 200===e.status?e.json():""!==h?(h="",f=_(t.sprite,i,".json"),fetch(f,{credentials:"same-origin"}).then((function(e){return e.json()}))):void 0})).then((function(e){if(void 0===e)throw"No sprites found.";c=e,p=_(t.sprite,i,h+".png"),y()})).catch((function(e){console.error(e),u(new Error("Sprites cannot be loaded from "+f))}))}function y(){d||t.sprite&&!c||o&&!(o.length>0)?d&&e.setStyle(d):(d=(0,l.default)(e,t,r,a,c,p,o),s())}if(e instanceof v.default||e instanceof g.default)try{for(var m=t.layers,b=0,x=m.length;b<x;++b)("string"==typeof r&&m[b].source==r||r.indexOf(m[b].id)>=0)&&T(m[b]);y()}catch(e){setTimeout((function(){u(e)}),0)}}))}function C(e,t){var r={type:t.type};function n(){var n=e.getTargetElement();if(n){var o=t.layout||{},a=t.paint||{};r.paint=a,r.id="olms-bg-"+a["background-opacity"]+a["background-color"];var l=e.getView().getZoom();if(void 0!==a["background-color"]){var u=(0,s.getValue)(r,"paint","background-color",l,{});n.style.background=i.Color.parse(u).toString()}void 0!==a["background-opacity"]&&(n.style.opacity=(0,s.getValue)(r,"paint","background-opacity",l,{})),"none"==o.visibility&&(n.style.backgroundColor="",n.style.opacity="")}}e.getTargetElement()&&n(),e.on(["change:resolution","change:target"],n)}function I(e,t){var r;return e.some((function(e){if(e.id==t)return r=e.source,!0})),r}function E(e,t,r,n,o,i){var a=t.getView();"center"in e&&!a.getCenter()&&a.setCenter((0,c.fromLonLat)(e.center)),"zoom"in e&&void 0===a.getZoom()&&a.setZoom(e.zoom),a.getCenter()&&void 0!==a.getZoom()||a.fit(a.getProjection().getExtent(),{nearest:!0,size:t.getSize()}),e.sprite&&(0==e.sprite.indexOf("mapbox://")?e.sprite=r+"/sprite"+i:0!=e.sprite.indexOf("http")&&(e.sprite=(n?n+o:"")+e.sprite+i));var s,l,u,d,S,j,T,z,_=e.layers,E=new h.default,M=[];function R(r){if(M.length>0){t.addLayer(r);var n=function(){O(r,e,M,o).then((function(){r.setVisible(!0)}),(function(e){console.error(e)}))};r.getSource()?n():r.once("change:source",n)}}for(var P=0,q=_.length;P<q;++P)if("background"==(s=_[P]).type)C(t,s);else{if((d=s.source||I(_,s.ref))!=u){R(S),M=[],l=e.sources[d],T=l.url;var N=l.tiles;if(T&&0==T.indexOf("mapbox://")&&(j=T.replace("mapbox://",""),N=["a","b","c","d"].map((function(e){return"https://"+e+".tiles.mapbox.com/v4/"+j+"/{z}/{x}/{y}."+("vector"==l.type?"vector.pbf":"png")+i}))),"vector"==l.type)S=N?(z=void 0,z=(0,p.createXYZ)({tileSize:512,maxZoom:"maxzoom"in l?l.maxzoom:22,minZoom:l.minzoom}),new v.default({declutter:!0,maxResolution:z.getMinZoom()>0?z.getResolution(z.getMinZoom()):void 0,source:new w.default({attributions:l.attribution,format:new f.default,tileGrid:z,urls:N}),visible:!1,zIndex:P})):function(){var e=new v.default({declutter:!0,visible:!1,zIndex:P}),t=new b.default({url:T}),r=t.on("change",(function(){if("ready"==t.getState()){for(var n=t.getTileJSON(),o=Array.isArray(n.tiles)?n.tiles:[n.tiles],i=0,a=o.length;i<a;++i){var s=o[i];0!=s.indexOf("http")&&(o[i]=l.url+s)}var u=t.getTileGrid();e.setSource(new w.default({attributions:t.getAttributions()||n.attribution,format:new f.default,tileGrid:(0,p.createXYZ)({minZoom:u.getMinZoom(),maxZoom:u.getMaxZoom(),tileSize:512}),urls:o})),u.getMinZoom()>0&&e.setMaxResolution(u.getResolution(u.getMinZoom())),(0,y.unByKey)(r)}}));return e}();else if("raster"==l.type){var F;(F=l.tiles?new k.default({attributions:l.attribution,minZoom:l.minzoom,maxZoom:"maxzoom"in l?l.maxzoom:22,tileSize:l.tileSize||512,url:T,urls:l.tiles,crossOrigin:"anonymous"}):new b.default({url:T,crossOrigin:"anonymous"})).setTileLoadFunction((function(e,t){if(-1!=t.indexOf("{bbox-epsg-3857}")){var r=F.getTileGrid().getTileCoordExtent(e.getTileCoord());t=t.replace("{bbox-epsg-3857}",r.toString())}e.getImage().src=t})),S=new m.default({source:F,visible:!s.layout||"none"!==s.layout.visibility})}else if("geojson"==l.type){var L,D,B=l.data;"string"==typeof B?D=A(B,o):L=E.readFeatures(B,{featureProjection:"EPSG:3857"}),S=new g.default({source:new x.default({attributions:l.attribution,features:L,format:E,url:D}),visible:!1,zIndex:P})}u=d}M.push(s.id)}R(S),t.set("mapbox-style",e)}},function(e,t,r){"use strict";(function(e){
/*!
 * The buffer module from node.js, for the browser.
 *
 * @author   Feross Aboukhadijeh <http://feross.org>
 * @license  MIT
 */
var n=r(7),o=r(8),i=r(9);function a(){return l.TYPED_ARRAY_SUPPORT?2147483647:1073741823}function s(e,t){if(a()<t)throw new RangeError("Invalid typed array length");return l.TYPED_ARRAY_SUPPORT?(e=new Uint8Array(t)).__proto__=l.prototype:(null===e&&(e=new l(t)),e.length=t),e}function l(e,t,r){if(!(l.TYPED_ARRAY_SUPPORT||this instanceof l))return new l(e,t,r);if("number"==typeof e){if("string"==typeof t)throw new Error("If encoding is specified then the first argument must be a string");return p(this,e)}return u(this,e,t,r)}function u(e,t,r,n){if("number"==typeof t)throw new TypeError('"value" argument must not be a number');return"undefined"!=typeof ArrayBuffer&&t instanceof ArrayBuffer?function(e,t,r,n){if(t.byteLength,r<0||t.byteLength<r)throw new RangeError("'offset' is out of bounds");if(t.byteLength<r+(n||0))throw new RangeError("'length' is out of bounds");t=void 0===r&&void 0===n?new Uint8Array(t):void 0===n?new Uint8Array(t,r):new Uint8Array(t,r,n);l.TYPED_ARRAY_SUPPORT?(e=t).__proto__=l.prototype:e=d(e,t);return e}(e,t,r,n):"string"==typeof t?function(e,t,r){"string"==typeof r&&""!==r||(r="utf8");if(!l.isEncoding(r))throw new TypeError('"encoding" must be a valid string encoding');var n=0|f(t,r),o=(e=s(e,n)).write(t,r);o!==n&&(e=e.slice(0,o));return e}(e,t,r):function(e,t){if(l.isBuffer(t)){var r=0|h(t.length);return 0===(e=s(e,r)).length||t.copy(e,0,0,r),e}if(t){if("undefined"!=typeof ArrayBuffer&&t.buffer instanceof ArrayBuffer||"length"in t)return"number"!=typeof t.length||(n=t.length)!=n?s(e,0):d(e,t);if("Buffer"===t.type&&i(t.data))return d(e,t.data)}var n;throw new TypeError("First argument must be a string, Buffer, ArrayBuffer, Array, or array-like object.")}(e,t)}function c(e){if("number"!=typeof e)throw new TypeError('"size" argument must be a number');if(e<0)throw new RangeError('"size" argument must not be negative')}function p(e,t){if(c(t),e=s(e,t<0?0:0|h(t)),!l.TYPED_ARRAY_SUPPORT)for(var r=0;r<t;++r)e[r]=0;return e}function d(e,t){var r=t.length<0?0:0|h(t.length);e=s(e,r);for(var n=0;n<r;n+=1)e[n]=255&t[n];return e}function h(e){if(e>=a())throw new RangeError("Attempt to allocate Buffer larger than maximum size: 0x"+a().toString(16)+" bytes");return 0|e}function f(e,t){if(l.isBuffer(e))return e.length;if("undefined"!=typeof ArrayBuffer&&"function"==typeof ArrayBuffer.isView&&(ArrayBuffer.isView(e)||e instanceof ArrayBuffer))return e.byteLength;"string"!=typeof e&&(e=""+e);var r=e.length;if(0===r)return 0;for(var n=!1;;)switch(t){case"ascii":case"latin1":case"binary":return r;case"utf8":case"utf-8":case void 0:return D(e).length;case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return 2*r;case"hex":return r>>>1;case"base64":return B(e).length;default:if(n)return D(e).length;t=(""+t).toLowerCase(),n=!0}}function y(e,t,r){var n=!1;if((void 0===t||t<0)&&(t=0),t>this.length)return"";if((void 0===r||r>this.length)&&(r=this.length),r<=0)return"";if((r>>>=0)<=(t>>>=0))return"";for(e||(e="utf8");;)switch(e){case"hex":return O(this,t,r);case"utf8":case"utf-8":return z(this,t,r);case"ascii":return A(this,t,r);case"latin1":case"binary":return _(this,t,r);case"base64":return T(this,t,r);case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return C(this,t,r);default:if(n)throw new TypeError("Unknown encoding: "+e);e=(e+"").toLowerCase(),n=!0}}function m(e,t,r){var n=e[t];e[t]=e[r],e[r]=n}function g(e,t,r,n,o){if(0===e.length)return-1;if("string"==typeof r?(n=r,r=0):r>2147483647?r=2147483647:r<-2147483648&&(r=-2147483648),r=+r,isNaN(r)&&(r=o?0:e.length-1),r<0&&(r=e.length+r),r>=e.length){if(o)return-1;r=e.length-1}else if(r<0){if(!o)return-1;r=0}if("string"==typeof t&&(t=l.from(t,n)),l.isBuffer(t))return 0===t.length?-1:v(e,t,r,n,o);if("number"==typeof t)return t&=255,l.TYPED_ARRAY_SUPPORT&&"function"==typeof Uint8Array.prototype.indexOf?o?Uint8Array.prototype.indexOf.call(e,t,r):Uint8Array.prototype.lastIndexOf.call(e,t,r):v(e,[t],r,n,o);throw new TypeError("val must be string, number or Buffer")}function v(e,t,r,n,o){var i,a=1,s=e.length,l=t.length;if(void 0!==n&&("ucs2"===(n=String(n).toLowerCase())||"ucs-2"===n||"utf16le"===n||"utf-16le"===n)){if(e.length<2||t.length<2)return-1;a=2,s/=2,l/=2,r/=2}function u(e,t){return 1===a?e[t]:e.readUInt16BE(t*a)}if(o){var c=-1;for(i=r;i<s;i++)if(u(e,i)===u(t,-1===c?0:i-c)){if(-1===c&&(c=i),i-c+1===l)return c*a}else-1!==c&&(i-=i-c),c=-1}else for(r+l>s&&(r=s-l),i=r;i>=0;i--){for(var p=!0,d=0;d<l;d++)if(u(e,i+d)!==u(t,d)){p=!1;break}if(p)return i}return-1}function b(e,t,r,n){r=Number(r)||0;var o=e.length-r;n?(n=Number(n))>o&&(n=o):n=o;var i=t.length;if(i%2!=0)throw new TypeError("Invalid hex string");n>i/2&&(n=i/2);for(var a=0;a<n;++a){var s=parseInt(t.substr(2*a,2),16);if(isNaN(s))return a;e[r+a]=s}return a}function x(e,t,r,n){return U(D(t,e.length-r),e,r,n)}function w(e,t,r,n){return U(function(e){for(var t=[],r=0;r<e.length;++r)t.push(255&e.charCodeAt(r));return t}(t),e,r,n)}function k(e,t,r,n){return w(e,t,r,n)}function S(e,t,r,n){return U(B(t),e,r,n)}function j(e,t,r,n){return U(function(e,t){for(var r,n,o,i=[],a=0;a<e.length&&!((t-=2)<0);++a)r=e.charCodeAt(a),n=r>>8,o=r%256,i.push(o),i.push(n);return i}(t,e.length-r),e,r,n)}function T(e,t,r){return 0===t&&r===e.length?n.fromByteArray(e):n.fromByteArray(e.slice(t,r))}function z(e,t,r){r=Math.min(e.length,r);for(var n=[],o=t;o<r;){var i,a,s,l,u=e[o],c=null,p=u>239?4:u>223?3:u>191?2:1;if(o+p<=r)switch(p){case 1:u<128&&(c=u);break;case 2:128==(192&(i=e[o+1]))&&(l=(31&u)<<6|63&i)>127&&(c=l);break;case 3:i=e[o+1],a=e[o+2],128==(192&i)&&128==(192&a)&&(l=(15&u)<<12|(63&i)<<6|63&a)>2047&&(l<55296||l>57343)&&(c=l);break;case 4:i=e[o+1],a=e[o+2],s=e[o+3],128==(192&i)&&128==(192&a)&&128==(192&s)&&(l=(15&u)<<18|(63&i)<<12|(63&a)<<6|63&s)>65535&&l<1114112&&(c=l)}null===c?(c=65533,p=1):c>65535&&(c-=65536,n.push(c>>>10&1023|55296),c=56320|1023&c),n.push(c),o+=p}return function(e){var t=e.length;if(t<=4096)return String.fromCharCode.apply(String,e);var r="",n=0;for(;n<t;)r+=String.fromCharCode.apply(String,e.slice(n,n+=4096));return r}(n)}t.Buffer=l,t.SlowBuffer=function(e){+e!=e&&(e=0);return l.alloc(+e)},t.INSPECT_MAX_BYTES=50,l.TYPED_ARRAY_SUPPORT=void 0!==e.TYPED_ARRAY_SUPPORT?e.TYPED_ARRAY_SUPPORT:function(){try{var e=new Uint8Array(1);return e.__proto__={__proto__:Uint8Array.prototype,foo:function(){return 42}},42===e.foo()&&"function"==typeof e.subarray&&0===e.subarray(1,1).byteLength}catch(e){return!1}}(),t.kMaxLength=a(),l.poolSize=8192,l._augment=function(e){return e.__proto__=l.prototype,e},l.from=function(e,t,r){return u(null,e,t,r)},l.TYPED_ARRAY_SUPPORT&&(l.prototype.__proto__=Uint8Array.prototype,l.__proto__=Uint8Array,"undefined"!=typeof Symbol&&Symbol.species&&l[Symbol.species]===l&&Object.defineProperty(l,Symbol.species,{value:null,configurable:!0})),l.alloc=function(e,t,r){return function(e,t,r,n){return c(t),t<=0?s(e,t):void 0!==r?"string"==typeof n?s(e,t).fill(r,n):s(e,t).fill(r):s(e,t)}(null,e,t,r)},l.allocUnsafe=function(e){return p(null,e)},l.allocUnsafeSlow=function(e){return p(null,e)},l.isBuffer=function(e){return!(null==e||!e._isBuffer)},l.compare=function(e,t){if(!l.isBuffer(e)||!l.isBuffer(t))throw new TypeError("Arguments must be Buffers");if(e===t)return 0;for(var r=e.length,n=t.length,o=0,i=Math.min(r,n);o<i;++o)if(e[o]!==t[o]){r=e[o],n=t[o];break}return r<n?-1:n<r?1:0},l.isEncoding=function(e){switch(String(e).toLowerCase()){case"hex":case"utf8":case"utf-8":case"ascii":case"latin1":case"binary":case"base64":case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return!0;default:return!1}},l.concat=function(e,t){if(!i(e))throw new TypeError('"list" argument must be an Array of Buffers');if(0===e.length)return l.alloc(0);var r;if(void 0===t)for(t=0,r=0;r<e.length;++r)t+=e[r].length;var n=l.allocUnsafe(t),o=0;for(r=0;r<e.length;++r){var a=e[r];if(!l.isBuffer(a))throw new TypeError('"list" argument must be an Array of Buffers');a.copy(n,o),o+=a.length}return n},l.byteLength=f,l.prototype._isBuffer=!0,l.prototype.swap16=function(){var e=this.length;if(e%2!=0)throw new RangeError("Buffer size must be a multiple of 16-bits");for(var t=0;t<e;t+=2)m(this,t,t+1);return this},l.prototype.swap32=function(){var e=this.length;if(e%4!=0)throw new RangeError("Buffer size must be a multiple of 32-bits");for(var t=0;t<e;t+=4)m(this,t,t+3),m(this,t+1,t+2);return this},l.prototype.swap64=function(){var e=this.length;if(e%8!=0)throw new RangeError("Buffer size must be a multiple of 64-bits");for(var t=0;t<e;t+=8)m(this,t,t+7),m(this,t+1,t+6),m(this,t+2,t+5),m(this,t+3,t+4);return this},l.prototype.toString=function(){var e=0|this.length;return 0===e?"":0===arguments.length?z(this,0,e):y.apply(this,arguments)},l.prototype.equals=function(e){if(!l.isBuffer(e))throw new TypeError("Argument must be a Buffer");return this===e||0===l.compare(this,e)},l.prototype.inspect=function(){var e="",r=t.INSPECT_MAX_BYTES;return this.length>0&&(e=this.toString("hex",0,r).match(/.{2}/g).join(" "),this.length>r&&(e+=" ... ")),"<Buffer "+e+">"},l.prototype.compare=function(e,t,r,n,o){if(!l.isBuffer(e))throw new TypeError("Argument must be a Buffer");if(void 0===t&&(t=0),void 0===r&&(r=e?e.length:0),void 0===n&&(n=0),void 0===o&&(o=this.length),t<0||r>e.length||n<0||o>this.length)throw new RangeError("out of range index");if(n>=o&&t>=r)return 0;if(n>=o)return-1;if(t>=r)return 1;if(this===e)return 0;for(var i=(o>>>=0)-(n>>>=0),a=(r>>>=0)-(t>>>=0),s=Math.min(i,a),u=this.slice(n,o),c=e.slice(t,r),p=0;p<s;++p)if(u[p]!==c[p]){i=u[p],a=c[p];break}return i<a?-1:a<i?1:0},l.prototype.includes=function(e,t,r){return-1!==this.indexOf(e,t,r)},l.prototype.indexOf=function(e,t,r){return g(this,e,t,r,!0)},l.prototype.lastIndexOf=function(e,t,r){return g(this,e,t,r,!1)},l.prototype.write=function(e,t,r,n){if(void 0===t)n="utf8",r=this.length,t=0;else if(void 0===r&&"string"==typeof t)n=t,r=this.length,t=0;else{if(!isFinite(t))throw new Error("Buffer.write(string, encoding, offset[, length]) is no longer supported");t|=0,isFinite(r)?(r|=0,void 0===n&&(n="utf8")):(n=r,r=void 0)}var o=this.length-t;if((void 0===r||r>o)&&(r=o),e.length>0&&(r<0||t<0)||t>this.length)throw new RangeError("Attempt to write outside buffer bounds");n||(n="utf8");for(var i=!1;;)switch(n){case"hex":return b(this,e,t,r);case"utf8":case"utf-8":return x(this,e,t,r);case"ascii":return w(this,e,t,r);case"latin1":case"binary":return k(this,e,t,r);case"base64":return S(this,e,t,r);case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return j(this,e,t,r);default:if(i)throw new TypeError("Unknown encoding: "+n);n=(""+n).toLowerCase(),i=!0}},l.prototype.toJSON=function(){return{type:"Buffer",data:Array.prototype.slice.call(this._arr||this,0)}};function A(e,t,r){var n="";r=Math.min(e.length,r);for(var o=t;o<r;++o)n+=String.fromCharCode(127&e[o]);return n}function _(e,t,r){var n="";r=Math.min(e.length,r);for(var o=t;o<r;++o)n+=String.fromCharCode(e[o]);return n}function O(e,t,r){var n=e.length;(!t||t<0)&&(t=0),(!r||r<0||r>n)&&(r=n);for(var o="",i=t;i<r;++i)o+=L(e[i]);return o}function C(e,t,r){for(var n=e.slice(t,r),o="",i=0;i<n.length;i+=2)o+=String.fromCharCode(n[i]+256*n[i+1]);return o}function I(e,t,r){if(e%1!=0||e<0)throw new RangeError("offset is not uint");if(e+t>r)throw new RangeError("Trying to access beyond buffer length")}function E(e,t,r,n,o,i){if(!l.isBuffer(e))throw new TypeError('"buffer" argument must be a Buffer instance');if(t>o||t<i)throw new RangeError('"value" argument is out of bounds');if(r+n>e.length)throw new RangeError("Index out of range")}function M(e,t,r,n){t<0&&(t=65535+t+1);for(var o=0,i=Math.min(e.length-r,2);o<i;++o)e[r+o]=(t&255<<8*(n?o:1-o))>>>8*(n?o:1-o)}function R(e,t,r,n){t<0&&(t=4294967295+t+1);for(var o=0,i=Math.min(e.length-r,4);o<i;++o)e[r+o]=t>>>8*(n?o:3-o)&255}function P(e,t,r,n,o,i){if(r+n>e.length)throw new RangeError("Index out of range");if(r<0)throw new RangeError("Index out of range")}function q(e,t,r,n,i){return i||P(e,0,r,4),o.write(e,t,r,n,23,4),r+4}function N(e,t,r,n,i){return i||P(e,0,r,8),o.write(e,t,r,n,52,8),r+8}l.prototype.slice=function(e,t){var r,n=this.length;if((e=~~e)<0?(e+=n)<0&&(e=0):e>n&&(e=n),(t=void 0===t?n:~~t)<0?(t+=n)<0&&(t=0):t>n&&(t=n),t<e&&(t=e),l.TYPED_ARRAY_SUPPORT)(r=this.subarray(e,t)).__proto__=l.prototype;else{var o=t-e;r=new l(o,void 0);for(var i=0;i<o;++i)r[i]=this[i+e]}return r},l.prototype.readUIntLE=function(e,t,r){e|=0,t|=0,r||I(e,t,this.length);for(var n=this[e],o=1,i=0;++i<t&&(o*=256);)n+=this[e+i]*o;return n},l.prototype.readUIntBE=function(e,t,r){e|=0,t|=0,r||I(e,t,this.length);for(var n=this[e+--t],o=1;t>0&&(o*=256);)n+=this[e+--t]*o;return n},l.prototype.readUInt8=function(e,t){return t||I(e,1,this.length),this[e]},l.prototype.readUInt16LE=function(e,t){return t||I(e,2,this.length),this[e]|this[e+1]<<8},l.prototype.readUInt16BE=function(e,t){return t||I(e,2,this.length),this[e]<<8|this[e+1]},l.prototype.readUInt32LE=function(e,t){return t||I(e,4,this.length),(this[e]|this[e+1]<<8|this[e+2]<<16)+16777216*this[e+3]},l.prototype.readUInt32BE=function(e,t){return t||I(e,4,this.length),16777216*this[e]+(this[e+1]<<16|this[e+2]<<8|this[e+3])},l.prototype.readIntLE=function(e,t,r){e|=0,t|=0,r||I(e,t,this.length);for(var n=this[e],o=1,i=0;++i<t&&(o*=256);)n+=this[e+i]*o;return n>=(o*=128)&&(n-=Math.pow(2,8*t)),n},l.prototype.readIntBE=function(e,t,r){e|=0,t|=0,r||I(e,t,this.length);for(var n=t,o=1,i=this[e+--n];n>0&&(o*=256);)i+=this[e+--n]*o;return i>=(o*=128)&&(i-=Math.pow(2,8*t)),i},l.prototype.readInt8=function(e,t){return t||I(e,1,this.length),128&this[e]?-1*(255-this[e]+1):this[e]},l.prototype.readInt16LE=function(e,t){t||I(e,2,this.length);var r=this[e]|this[e+1]<<8;return 32768&r?4294901760|r:r},l.prototype.readInt16BE=function(e,t){t||I(e,2,this.length);var r=this[e+1]|this[e]<<8;return 32768&r?4294901760|r:r},l.prototype.readInt32LE=function(e,t){return t||I(e,4,this.length),this[e]|this[e+1]<<8|this[e+2]<<16|this[e+3]<<24},l.prototype.readInt32BE=function(e,t){return t||I(e,4,this.length),this[e]<<24|this[e+1]<<16|this[e+2]<<8|this[e+3]},l.prototype.readFloatLE=function(e,t){return t||I(e,4,this.length),o.read(this,e,!0,23,4)},l.prototype.readFloatBE=function(e,t){return t||I(e,4,this.length),o.read(this,e,!1,23,4)},l.prototype.readDoubleLE=function(e,t){return t||I(e,8,this.length),o.read(this,e,!0,52,8)},l.prototype.readDoubleBE=function(e,t){return t||I(e,8,this.length),o.read(this,e,!1,52,8)},l.prototype.writeUIntLE=function(e,t,r,n){(e=+e,t|=0,r|=0,n)||E(this,e,t,r,Math.pow(2,8*r)-1,0);var o=1,i=0;for(this[t]=255&e;++i<r&&(o*=256);)this[t+i]=e/o&255;return t+r},l.prototype.writeUIntBE=function(e,t,r,n){(e=+e,t|=0,r|=0,n)||E(this,e,t,r,Math.pow(2,8*r)-1,0);var o=r-1,i=1;for(this[t+o]=255&e;--o>=0&&(i*=256);)this[t+o]=e/i&255;return t+r},l.prototype.writeUInt8=function(e,t,r){return e=+e,t|=0,r||E(this,e,t,1,255,0),l.TYPED_ARRAY_SUPPORT||(e=Math.floor(e)),this[t]=255&e,t+1},l.prototype.writeUInt16LE=function(e,t,r){return e=+e,t|=0,r||E(this,e,t,2,65535,0),l.TYPED_ARRAY_SUPPORT?(this[t]=255&e,this[t+1]=e>>>8):M(this,e,t,!0),t+2},l.prototype.writeUInt16BE=function(e,t,r){return e=+e,t|=0,r||E(this,e,t,2,65535,0),l.TYPED_ARRAY_SUPPORT?(this[t]=e>>>8,this[t+1]=255&e):M(this,e,t,!1),t+2},l.prototype.writeUInt32LE=function(e,t,r){return e=+e,t|=0,r||E(this,e,t,4,4294967295,0),l.TYPED_ARRAY_SUPPORT?(this[t+3]=e>>>24,this[t+2]=e>>>16,this[t+1]=e>>>8,this[t]=255&e):R(this,e,t,!0),t+4},l.prototype.writeUInt32BE=function(e,t,r){return e=+e,t|=0,r||E(this,e,t,4,4294967295,0),l.TYPED_ARRAY_SUPPORT?(this[t]=e>>>24,this[t+1]=e>>>16,this[t+2]=e>>>8,this[t+3]=255&e):R(this,e,t,!1),t+4},l.prototype.writeIntLE=function(e,t,r,n){if(e=+e,t|=0,!n){var o=Math.pow(2,8*r-1);E(this,e,t,r,o-1,-o)}var i=0,a=1,s=0;for(this[t]=255&e;++i<r&&(a*=256);)e<0&&0===s&&0!==this[t+i-1]&&(s=1),this[t+i]=(e/a>>0)-s&255;return t+r},l.prototype.writeIntBE=function(e,t,r,n){if(e=+e,t|=0,!n){var o=Math.pow(2,8*r-1);E(this,e,t,r,o-1,-o)}var i=r-1,a=1,s=0;for(this[t+i]=255&e;--i>=0&&(a*=256);)e<0&&0===s&&0!==this[t+i+1]&&(s=1),this[t+i]=(e/a>>0)-s&255;return t+r},l.prototype.writeInt8=function(e,t,r){return e=+e,t|=0,r||E(this,e,t,1,127,-128),l.TYPED_ARRAY_SUPPORT||(e=Math.floor(e)),e<0&&(e=255+e+1),this[t]=255&e,t+1},l.prototype.writeInt16LE=function(e,t,r){return e=+e,t|=0,r||E(this,e,t,2,32767,-32768),l.TYPED_ARRAY_SUPPORT?(this[t]=255&e,this[t+1]=e>>>8):M(this,e,t,!0),t+2},l.prototype.writeInt16BE=function(e,t,r){return e=+e,t|=0,r||E(this,e,t,2,32767,-32768),l.TYPED_ARRAY_SUPPORT?(this[t]=e>>>8,this[t+1]=255&e):M(this,e,t,!1),t+2},l.prototype.writeInt32LE=function(e,t,r){return e=+e,t|=0,r||E(this,e,t,4,2147483647,-2147483648),l.TYPED_ARRAY_SUPPORT?(this[t]=255&e,this[t+1]=e>>>8,this[t+2]=e>>>16,this[t+3]=e>>>24):R(this,e,t,!0),t+4},l.prototype.writeInt32BE=function(e,t,r){return e=+e,t|=0,r||E(this,e,t,4,2147483647,-2147483648),e<0&&(e=4294967295+e+1),l.TYPED_ARRAY_SUPPORT?(this[t]=e>>>24,this[t+1]=e>>>16,this[t+2]=e>>>8,this[t+3]=255&e):R(this,e,t,!1),t+4},l.prototype.writeFloatLE=function(e,t,r){return q(this,e,t,!0,r)},l.prototype.writeFloatBE=function(e,t,r){return q(this,e,t,!1,r)},l.prototype.writeDoubleLE=function(e,t,r){return N(this,e,t,!0,r)},l.prototype.writeDoubleBE=function(e,t,r){return N(this,e,t,!1,r)},l.prototype.copy=function(e,t,r,n){if(r||(r=0),n||0===n||(n=this.length),t>=e.length&&(t=e.length),t||(t=0),n>0&&n<r&&(n=r),n===r)return 0;if(0===e.length||0===this.length)return 0;if(t<0)throw new RangeError("targetStart out of bounds");if(r<0||r>=this.length)throw new RangeError("sourceStart out of bounds");if(n<0)throw new RangeError("sourceEnd out of bounds");n>this.length&&(n=this.length),e.length-t<n-r&&(n=e.length-t+r);var o,i=n-r;if(this===e&&r<t&&t<n)for(o=i-1;o>=0;--o)e[o+t]=this[o+r];else if(i<1e3||!l.TYPED_ARRAY_SUPPORT)for(o=0;o<i;++o)e[o+t]=this[o+r];else Uint8Array.prototype.set.call(e,this.subarray(r,r+i),t);return i},l.prototype.fill=function(e,t,r,n){if("string"==typeof e){if("string"==typeof t?(n=t,t=0,r=this.length):"string"==typeof r&&(n=r,r=this.length),1===e.length){var o=e.charCodeAt(0);o<256&&(e=o)}if(void 0!==n&&"string"!=typeof n)throw new TypeError("encoding must be a string");if("string"==typeof n&&!l.isEncoding(n))throw new TypeError("Unknown encoding: "+n)}else"number"==typeof e&&(e&=255);if(t<0||this.length<t||this.length<r)throw new RangeError("Out of range index");if(r<=t)return this;var i;if(t>>>=0,r=void 0===r?this.length:r>>>0,e||(e=0),"number"==typeof e)for(i=t;i<r;++i)this[i]=e;else{var a=l.isBuffer(e)?e:D(new l(e,n).toString()),s=a.length;for(i=0;i<r-t;++i)this[i+t]=a[i%s]}return this};var F=/[^+\/0-9A-Za-z-_]/g;function L(e){return e<16?"0"+e.toString(16):e.toString(16)}function D(e,t){var r;t=t||1/0;for(var n=e.length,o=null,i=[],a=0;a<n;++a){if((r=e.charCodeAt(a))>55295&&r<57344){if(!o){if(r>56319){(t-=3)>-1&&i.push(239,191,189);continue}if(a+1===n){(t-=3)>-1&&i.push(239,191,189);continue}o=r;continue}if(r<56320){(t-=3)>-1&&i.push(239,191,189),o=r;continue}r=65536+(o-55296<<10|r-56320)}else o&&(t-=3)>-1&&i.push(239,191,189);if(o=null,r<128){if((t-=1)<0)break;i.push(r)}else if(r<2048){if((t-=2)<0)break;i.push(r>>6|192,63&r|128)}else if(r<65536){if((t-=3)<0)break;i.push(r>>12|224,r>>6&63|128,63&r|128)}else{if(!(r<1114112))throw new Error("Invalid code point");if((t-=4)<0)break;i.push(r>>18|240,r>>12&63|128,r>>6&63|128,63&r|128)}}return i}function B(e){return n.toByteArray(function(e){if((e=function(e){return e.trim?e.trim():e.replace(/^\s+|\s+$/g,"")}(e).replace(F,"")).length<2)return"";for(;e.length%4!=0;)e+="=";return e}(e))}function U(e,t,r,n){for(var o=0;o<n&&!(o+r>=t.length||o>=e.length);++o)t[o+r]=e[o];return o}}).call(this,r(1))},function(e,t,r){"use strict";t.byteLength=function(e){var t=u(e),r=t[0],n=t[1];return 3*(r+n)/4-n},t.toByteArray=function(e){var t,r,n=u(e),a=n[0],s=n[1],l=new i(function(e,t,r){return 3*(t+r)/4-r}(0,a,s)),c=0,p=s>0?a-4:a;for(r=0;r<p;r+=4)t=o[e.charCodeAt(r)]<<18|o[e.charCodeAt(r+1)]<<12|o[e.charCodeAt(r+2)]<<6|o[e.charCodeAt(r+3)],l[c++]=t>>16&255,l[c++]=t>>8&255,l[c++]=255&t;2===s&&(t=o[e.charCodeAt(r)]<<2|o[e.charCodeAt(r+1)]>>4,l[c++]=255&t);1===s&&(t=o[e.charCodeAt(r)]<<10|o[e.charCodeAt(r+1)]<<4|o[e.charCodeAt(r+2)]>>2,l[c++]=t>>8&255,l[c++]=255&t);return l},t.fromByteArray=function(e){for(var t,r=e.length,o=r%3,i=[],a=0,s=r-o;a<s;a+=16383)i.push(c(e,a,a+16383>s?s:a+16383));1===o?(t=e[r-1],i.push(n[t>>2]+n[t<<4&63]+"==")):2===o&&(t=(e[r-2]<<8)+e[r-1],i.push(n[t>>10]+n[t>>4&63]+n[t<<2&63]+"="));return i.join("")};for(var n=[],o=[],i="undefined"!=typeof Uint8Array?Uint8Array:Array,a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s=0,l=a.length;s<l;++s)n[s]=a[s],o[a.charCodeAt(s)]=s;function u(e){var t=e.length;if(t%4>0)throw new Error("Invalid string. Length must be a multiple of 4");var r=e.indexOf("=");return-1===r&&(r=t),[r,r===t?0:4-r%4]}function c(e,t,r){for(var o,i,a=[],s=t;s<r;s+=3)o=(e[s]<<16&16711680)+(e[s+1]<<8&65280)+(255&e[s+2]),a.push(n[(i=o)>>18&63]+n[i>>12&63]+n[i>>6&63]+n[63&i]);return a.join("")}o["-".charCodeAt(0)]=62,o["_".charCodeAt(0)]=63},function(e,t,r){"use strict";t.read=function(e,t,r,n,o){var i,a,s=8*o-n-1,l=(1<<s)-1,u=l>>1,c=-7,p=r?o-1:0,d=r?-1:1,h=e[t+p];for(p+=d,i=h&(1<<-c)-1,h>>=-c,c+=s;c>0;i=256*i+e[t+p],p+=d,c-=8);for(a=i&(1<<-c)-1,i>>=-c,c+=n;c>0;a=256*a+e[t+p],p+=d,c-=8);if(0===i)i=1-u;else{if(i===l)return a?NaN:1/0*(h?-1:1);a+=Math.pow(2,n),i-=u}return(h?-1:1)*a*Math.pow(2,i-n)},t.write=function(e,t,r,n,o,i){var a,s,l,u=8*i-o-1,c=(1<<u)-1,p=c>>1,d=23===o?Math.pow(2,-24)-Math.pow(2,-77):0,h=n?0:i-1,f=n?1:-1,y=t<0||0===t&&1/t<0?1:0;for(t=Math.abs(t),isNaN(t)||t===1/0?(s=isNaN(t)?1:0,a=c):(a=Math.floor(Math.log(t)/Math.LN2),t*(l=Math.pow(2,-a))<1&&(a--,l*=2),(t+=a+p>=1?d/l:d*Math.pow(2,1-p))*l>=2&&(a++,l/=2),a+p>=c?(s=0,a=c):a+p>=1?(s=(t*l-1)*Math.pow(2,o),a+=p):(s=t*Math.pow(2,p-1)*Math.pow(2,o),a=0));o>=8;e[r+h]=255&s,h+=f,s/=256,o-=8);for(a=a<<o|s,u+=o;u>0;e[r+h]=255&a,h+=f,a/=256,u-=8);e[r+h-f]|=128*y}},function(e,t,r){"use strict";var n={}.toString;e.exports=Array.isArray||function(e){return"[object Array]"==n.call(e)}},function(e,t){e.exports=ol.style.Style},function(e,t){e.exports=ol.style.Fill},function(e,t){e.exports=ol.style.Stroke},function(e,t){e.exports=ol.style.Icon},function(e,t){e.exports=ol.style.Text},function(e,t){e.exports=ol.style.Circle},function(e,t){e.exports=ol.geom.Point},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.deg2rad=function(e){return e*Math.PI/180},t.getZoomForResolution=function(e,t){for(var r=0,n=t.length;r<n;++r){if(t[r]<e&&r+1<n){var o=t[r]/t[r+1];return r+Math.log(t[r]/e)/Math.log(o)}}return n-1}},function(e,t,r){"use strict";(function(){var t;e.exports={icon:"icons/google.svg",name:"google",title:"Google Fonts",link:"google.com/fonts",getNames:function(){return t},getLink:function(e){return"https://fonts.google.com/specimen/"+e.replace(/( )/g,"+")},normalizeName:function(e){return e}},t=["ABeeZee","Abel","Abril Fatface","Aclonica","Acme","Actor","Adamina","Advent Pro","Aguafina Script","Akronim","Aladin","Aldrich","Alef","Alegreya","Alegreya SC","Alegreya Sans","Alegreya Sans SC","Alex Brush","Alfa Slab One","Alice","Alike","Alike Angular","Allan","Allerta","Allerta Stencil","Allura","Almendra","Almendra Display","Almendra SC","Amarante","Amaranth","Amatic SC","Amethysta","Amiri","Amita","Anaheim","Andada","Andika","Angkor","Annie Use Your Telescope","Anonymous Pro","Antic","Antic Didone","Antic Slab","Anton","Arapey","Arbutus","Arbutus Slab","Architects Daughter","Archivo Black","Archivo Narrow","Arimo","Arizonia","Armata","Artifika","Arvo","Arya","Asap","Asar","Asset","Astloch","Asul","Atomic Age","Aubrey","Audiowide","Autour One","Average","Average Sans","Averia Gruesa Libre","Averia Libre","Averia Sans Libre","Averia Serif Libre","Bad Script","Balthazar","Bangers","Basic","Battambang","Baumans","Bayon","Belgrano","Belleza","BenchNine","Bentham","Berkshire Swash","Bevan","Bigelow Rules","Bigshot One","Bilbo","Bilbo Swash Caps","Biryani","Bitter","Black Ops One","Bokor","Bonbon","Boogaloo","Bowlby One","Bowlby One SC","Brawler","Bree Serif","Bubblegum Sans","Bubbler One","Buda","Buenard","Butcherman","Butterfly Kids","Cabin","Cabin Condensed","Cabin Sketch","Caesar Dressing","Cagliostro","Calligraffitti","Cambay","Cambo","Candal","Cantarell","Cantata One","Cantora One","Capriola","Cardo","Carme","Carrois Gothic","Carrois Gothic SC","Carter One","Catamaran","Caudex","Caveat","Caveat Brush","Cedarville Cursive","Ceviche One","Changa One","Chango","Chau Philomene One","Chela One","Chelsea Market","Chenla","Cherry Cream Soda","Cherry Swash","Chewy","Chicle","Chivo","Chonburi","Cinzel","Cinzel Decorative","Clicker Script","Coda","Coda Caption","Codystar","Combo","Comfortaa","Coming Soon","Concert One","Condiment","Content","Contrail One","Convergence","Cookie","Copse","Corben","Courgette","Cousine","Coustard","Covered By Your Grace","Crafty Girls","Creepster","Crete Round","Crimson Text","Croissant One","Crushed","Cuprum","Cutive","Cutive Mono","Damion","Dancing Script","Dangrek","Dawning of a New Day","Days One","Dekko","Delius","Delius Swash Caps","Delius Unicase","Della Respira","Denk One","Devonshire","Dhurjati","Didact Gothic","Diplomata","Diplomata SC","Domine","Donegal One","Doppio One","Dorsa","Dosis","Dr Sugiyama","Droid Sans","Droid Sans Mono","Droid Serif","Duru Sans","Dynalight","EB Garamond","Eagle Lake","Eater","Economica","Eczar","Ek Mukta","Electrolize","Elsie","Elsie Swash Caps","Emblema One","Emilys Candy","Engagement","Englebert","Enriqueta","Erica One","Esteban","Euphoria Script","Ewert","Exo","Exo 2","Expletus Sans","Fanwood Text","Fascinate","Fascinate Inline","Faster One","Fasthand","Fauna One","Federant","Federo","Felipa","Fenix","Finger Paint","Fira Mono","Fira Sans","Fjalla One","Fjord One","Flamenco","Flavors","Fondamento","Fontdiner Swanky","Forum","Francois One","Freckle Face","Fredericka the Great","Fredoka One","Freehand","Fresca","Frijole","Fruktur","Fugaz One","GFS Didot","GFS Neohellenic","Gabriela","Gafata","Galdeano","Galindo","Gentium Basic","Gentium Book Basic","Geo","Geostar","Geostar Fill","Germania One","Gidugu","Gilda Display","Give You Glory","Glass Antiqua","Glegoo","Gloria Hallelujah","Goblin One","Gochi Hand","Gorditas","Goudy Bookletter 1911","Graduate","Grand Hotel","Gravitas One","Great Vibes","Griffy","Gruppo","Gudea","Gurajada","Habibi","Halant","Hammersmith One","Hanalei","Hanalei Fill","Handlee","Hanuman","Happy Monkey","Headland One","Henny Penny","Herr Von Muellerhoff","Hind","Hind Siliguri","Hind Vadodara","Holtwood One SC","Homemade Apple","Homenaje","IM Fell DW Pica","IM Fell DW Pica SC","IM Fell Double Pica","IM Fell Double Pica SC","IM Fell English","IM Fell English SC","IM Fell French Canon","IM Fell French Canon SC","IM Fell Great Primer","IM Fell Great Primer SC","Iceberg","Iceland","Imprima","Inconsolata","Inder","Indie Flower","Inika","Inknut Antiqua","Irish Grover","Istok Web","Italiana","Italianno","Itim","Jacques Francois","Jacques Francois Shadow","Jaldi","Jim Nightshade","Jockey One","Jolly Lodger","Josefin Sans","Josefin Slab","Joti One","Judson","Julee","Julius Sans One","Junge","Jura","Just Another Hand","Just Me Again Down Here","Kadwa","Kalam","Kameron","Kantumruy","Karla","Karma","Kaushan Script","Kavoon","Kdam Thmor","Keania One","Kelly Slab","Kenia","Khand","Khmer","Khula","Kite One","Knewave","Kotta One","Koulen","Kranky","Kreon","Kristi","Krona One","Kurale","La Belle Aurore","Laila","Lakki Reddy","Lancelot","Lateef","Lato","League Script","Leckerli One","Ledger","Lekton","Lemon","Libre Baskerville","Life Savers","Lilita One","Lily Script One","Limelight","Linden Hill","Lobster","Lobster Two","Londrina Outline","Londrina Shadow","Londrina Sketch","Londrina Solid","Lora","Love Ya Like A Sister","Loved by the King","Lovers Quarrel","Luckiest Guy","Lusitana","Lustria","Macondo","Macondo Swash Caps","Magra","Maiden Orange","Mako","Mallanna","Mandali","Marcellus","Marcellus SC","Marck Script","Margarine","Marko One","Marmelad","Martel","Martel Sans","Marvel","Mate","Mate SC","Maven Pro","McLaren","Meddon","MedievalSharp","Medula One","Megrim","Meie Script","Merienda","Merienda One","Merriweather","Merriweather Sans","Metal","Metal Mania","Metamorphous","Metrophobic","Michroma","Milonga","Miltonian","Miltonian Tattoo","Miniver","Miss Fajardose","Modak","Modern Antiqua","Molengo","Molle","Monda","Monofett","Monoton","Monsieur La Doulaise","Montaga","Montez","Montserrat","Montserrat Alternates","Montserrat Subrayada","Moul","Moulpali","Mountains of Christmas","Mouse Memoirs","Mr Bedfort","Mr Dafoe","Mr De Haviland","Mrs Saint Delafield","Mrs Sheppards","Muli","Mystery Quest","NTR","Neucha","Neuton","New Rocker","News Cycle","Niconne","Nixie One","Nobile","Nokora","Norican","Nosifer","Nothing You Could Do","Noticia Text","Noto Sans","Noto Serif","Nova Cut","Nova Flat","Nova Mono","Nova Oval","Nova Round","Nova Script","Nova Slim","Nova Square","Numans","Nunito","Odor Mean Chey","Offside","Old Standard TT","Oldenburg","Oleo Script","Oleo Script Swash Caps","Open Sans","Open Sans Condensed","Oranienbaum","Orbitron","Oregano","Orienta","Original Surfer","Oswald","Over the Rainbow","Overlock","Overlock SC","Ovo","Oxygen","Oxygen Mono","PT Mono","PT Sans","PT Sans Caption","PT Sans Narrow","PT Serif","PT Serif Caption","Pacifico","Palanquin","Palanquin Dark","Paprika","Parisienne","Passero One","Passion One","Pathway Gothic One","Patrick Hand","Patrick Hand SC","Patua One","Paytone One","Peddana","Peralta","Permanent Marker","Petit Formal Script","Petrona","Philosopher","Piedra","Pinyon Script","Pirata One","Plaster","Play","Playball","Playfair Display","Playfair Display SC","Podkova","Poiret One","Poller One","Poly","Pompiere","Pontano Sans","Poppins","Port Lligat Sans","Port Lligat Slab","Pragati Narrow","Prata","Preahvihear","Press Start 2P","Princess Sofia","Prociono","Prosto One","Puritan","Purple Purse","Quando","Quantico","Quattrocento","Quattrocento Sans","Questrial","Quicksand","Quintessential","Qwigley","Racing Sans One","Radley","Rajdhani","Raleway","Raleway Dots","Ramabhadra","Ramaraja","Rambla","Rammetto One","Ranchers","Rancho","Ranga","Rationale","Ravi Prakash","Redressed","Reenie Beanie","Revalia","Rhodium Libre","Ribeye","Ribeye Marrow","Righteous","Risque","Roboto","Roboto Condensed","Roboto Mono","Roboto Slab","Rochester","Rock Salt","Rokkitt","Romanesco","Ropa Sans","Rosario","Rosarivo","Rouge Script","Rozha One","Rubik","Rubik Mono One","Rubik One","Ruda","Rufina","Ruge Boogie","Ruluko","Rum Raisin","Ruslan Display","Russo One","Ruthie","Rye","Sacramento","Sahitya","Sail","Salsa","Sanchez","Sancreek","Sansita One","Sarala","Sarina","Sarpanch","Satisfy","Scada","Scheherazade","Schoolbell","Seaweed Script","Sevillana","Seymour One","Shadows Into Light","Shadows Into Light Two","Shanti","Share","Share Tech","Share Tech Mono","Shojumaru","Short Stack","Siemreap","Sigmar One","Signika","Signika Negative","Simonetta","Sintony","Sirin Stencil","Six Caps","Skranji","Slabo 13px","Slabo 27px","Slackey","Smokum","Smythe","Sniglet","Snippet","Snowburst One","Sofadi One","Sofia","Sonsie One","Sorts Mill Goudy","Source Code Pro","Source Sans Pro","Source Serif Pro","Special Elite","Spicy Rice","Spinnaker","Spirax","Squada One","Sree Krushnadevaraya","Stalemate","Stalinist One","Stardos Stencil","Stint Ultra Condensed","Stint Ultra Expanded","Stoke","Strait","Sue Ellen Francisco","Sumana","Sunshiney","Supermercado One","Sura","Suranna","Suravaram","Suwannaphum","Swanky and Moo Moo","Syncopate","Tangerine","Taprom","Tauri","Teko","Telex","Tenali Ramakrishna","Tenor Sans","Text Me One","The Girl Next Door","Tienne","Tillana","Timmana","Tinos","Titan One","Titillium Web","Trade Winds","Trocchi","Trochut","Trykker","Tulpen One","Ubuntu","Ubuntu Condensed","Ubuntu Mono","Ultra","Uncial Antiqua","Underdog","Unica One","UnifrakturCook","UnifrakturMaguntia","Unkempt","Unlock","Unna","VT323","Vampiro One","Varela","Varela Round","Vast Shadow","Vesper Libre","Vibur","Vidaloka","Viga","Voces","Volkhov","Vollkorn","Voltaire","Waiting for the Sunrise","Wallpoet","Walter Turncoat","Warnes","Wellfleet","Wendy One","Wire One","Work Sans","Yanone Kaffeesatz","Yantramanav","Yellowtail","Yeseva One","Yesteryear","Zeyada"]}).call(void 0)},function(e,t){e.exports=ol.proj},function(e,t){e.exports=ol.tilegrid},function(e,t){e.exports=ol.Map},function(e,t){e.exports=ol.format.GeoJSON},function(e,t){e.exports=ol.format.MVT},function(e,t){e.exports=ol.Observable},function(e,t){e.exports=ol.layer.Tile},function(e,t){e.exports=ol.layer.Vector},function(e,t){e.exports=ol.layer.VectorTile},function(e,t){e.exports=ol.source.TileJSON},function(e,t){e.exports=ol.source.Vector},function(e,t){e.exports=ol.source.VectorTile},function(e,t){e.exports=ol.source.XYZ}]).default;